#include "surelyMalloc.h"
#include "Master.h"
#include "Clock.h"

struct clock {
  int t;
  Master m;
};

Clock newClock (Master mast) {
  Clock c = (Clock)surely_malloc(sizeof *c);

  // c -> t = 0; redundant given our internal spec of sync

  c -> m = mast;

  //Connect(mast,c); Verification-only function; modeled by an 
  //APD entailment axiom in our development: Mrep_connect

  Sync(c);
  return c;
}

void Sync(Clock c) {
  c -> t = getTime(c -> m);
}

void freeClock(Clock c) {
  free(c);
}

void switchMaster (Clock c, Master mast) {
  //detach (c)

  c -> m = mast;

  Sync(c);
}
