Require Import VST.floyd.proofauto.
Require Import surelyMalloc.
Require Import Subject.
Require Import Observer.
(*Require Import VST.floyd.linking.
Require Import VST.floyd.VSU.
Check prog_funct.

Goal forall p1 p2 I1 I2, Fundefs_match p1 p2 I1 I2 ->
forall i fd1 fd2,
                         initial_world.find_id i (prog_funct p1) = Some fd1 ->
                         initial_world.find_id i (prog_funct p2) = Some fd2 ->
                         match fd1, fd2 with
                           Internal f, Internal g => merge_globdef (Gfun fd1) (Gfun fd2) = Errors.OK (Gfun fd1) /\
                                                     merge_globdef (Gfun fd1) (Gfun fd2) = Errors.OK (Gfun fd2) /\
                                                     merge_globdef (Gfun fd2) (Gfun fd1) = Errors.OK (Gfun fd1)
                        |  _, _ => True end.
intros. specialize (H i fd1 fd2 H0 H1). destruct fd1; destruct fd2; trivial.
inv H. simpl. split3; trivial. rewrite H0 in H1. simpl.
specialize (H i fd1 fd2).
red in H.
Definition eqb_statement (s s':statement):bool.
eapply statement_rect.
apply true.
  match s, s' with
  Sskip, Sskip => true
  Sassign e1 e2, Sassign e1' e2' =>
Section eq_dec.
  Local Ltac t := hnf; decide equality; auto.

  Let eq_dec_type := type_eq.
  Let eq_dec_float := Float.eq_dec.
  Let eq_dec_float32 := Float32.eq_dec.
  Let eq_dec_int := Int.eq_dec.
  Let eq_dec_int64 := Int64.eq_dec.
  Let eq_dec_ident := ident_eq.
  Let eq_dec_signature := signature_eq.
  Let eq_dec_attr : EqDec attr. repeat t. Defined.
  Let eq_dec_signedness : EqDec signedness. t. Defined.
  Let eq_dec_intsize : EqDec intsize. t. Defined.
  Let eq_dec_floatsize : EqDec floatsize. t. Defined.
  Let eq_dec_Z : EqDec Z. repeat t. Defined.
  Let eq_dec_calling_convention : EqDec calling_convention. repeat t. Defined.
  Lemma eq_dec_external_function : EqDec external_function. repeat t. Defined.
  Let eq_dec_option_ident := option_eq (ident_eq).
  Let eq_dec_option_Z : EqDec (option Z). repeat t. Defined.
  Let eq_dec_typelist : EqDec typelist. repeat t. Defined.

  Lemma eq_dec_expr : EqDec expr.
  Proof. repeat t. Defined.

  Let eq_dec_expr := eq_dec_expr.
  Let eq_dec_option_expr : EqDec (option expr). repeat t. Defined.
  Let eq_dec_list_expr : EqDec (list expr). repeat t. Defined.

  Local Ltac eq_dec a a' :=
    let H := fresh in
    assert (H : {a = a'} + {a <> a'}) by (auto; repeat (decide equality ; auto));
    destruct H; [subst; auto | try (right; congruence)].

  Lemma eq_dec_statement : forall s s' : statement, { s = s' } + { s <> s' }.
  Proof.
    apply
      (statement_rect
         (fun s => forall s', { s = s' } + { s <> s' })
         (fun l => forall l', { l = l' } + { l <> l' }));
      try (intros until s'; destruct s'); intros;
      try (destruct l');
      try solve [right; congruence | left; reflexivity];
      repeat
        match goal with
        | |- context [ ?x ?a          = ?x ?b          ] => eq_dec a b
        | |- context [ ?x ?y ?a       = ?x ?y ?b       ] => eq_dec a b
        | |- context [ ?x ?a _        = ?x ?b _        ] => eq_dec a b
        | |- context [ ?x ?y ?z ?a    = ?x ?y ?z ?b    ] => eq_dec a b
        | |- context [ ?x ?y ?a _     = ?x ?y ?b _     ] => eq_dec a b
        | |- context [ ?x ?a _  _     = ?x ?b _  _     ] => eq_dec a b
        | |- context [ ?x ?y ?z ?t ?a = ?x ?y ?z ?t ?b ] => eq_dec a b
        | |- context [ ?x ?y ?z ?a _  = ?x ?y ?z ?b _  ] => eq_dec a b
        | |- context [ ?x ?y ?a _  _  = ?x ?y ?b _  _  ] => eq_dec a b
        | |- context [ ?x ?a _  _  _  = ?x ?b _  _  _  ] => eq_dec a b
        end.
  Defined.
  Lemma eq_dec_statement_Defined : forall s s' : statement, { s = s' } + { s <> s' }.
  Proof.
    apply
      (statement_rect
         (fun s => forall s', { s = s' } + { s <> s' })
         (fun l => forall l', { l = l' } + { l <> l' }));
      try (intros until s'; destruct s'); intros;
      try (destruct l');
      try solve [right; congruence | left; reflexivity];
      repeat
        match goal with
        | |- context [ ?x ?a          = ?x ?b          ] => eq_dec a b
        | |- context [ ?x ?y ?a       = ?x ?y ?b       ] => eq_dec a b
        | |- context [ ?x ?a _        = ?x ?b _        ] => eq_dec a b
        | |- context [ ?x ?y ?z ?a    = ?x ?y ?z ?b    ] => eq_dec a b
        | |- context [ ?x ?y ?a _     = ?x ?y ?b _     ] => eq_dec a b
        | |- context [ ?x ?a _  _     = ?x ?b _  _     ] => eq_dec a b
        | |- context [ ?x ?y ?z ?t ?a = ?x ?y ?z ?t ?b ] => eq_dec a b
        | |- context [ ?x ?y ?z ?a _  = ?x ?y ?z ?b _  ] => eq_dec a b
        | |- context [ ?x ?y ?a _  _  = ?x ?y ?b _  _  ] => eq_dec a b
        | |- context [ ?x ?a _  _  _  = ?x ?b _  _  _  ] => eq_dec a b
        end.
  Defined.

  Lemma eq_dec_labeled_statements : forall l l' : labeled_statements, { l = l' } + { l <> l' }.
  Proof.
    decide equality.
    apply eq_dec_statement.
  Qed.

End eq_dec.

Check expr_eq_dec.
Print statement.



Require Import VST.floyd.linking.
Print merge_globdef.
Definition optlink_progs (prog1 prog2 : Clight.program)  
  (*: option bool*)(*Clight.program*) :=
 match prog1, prog2 with
  {|prog_defs := d1;
    prog_public := p1;
    prog_main := m1;
    prog_types := t1;
    prog_comp_env := e1;
    prog_comp_env_eq := q1|},
  {|prog_defs := d2;
    prog_public := p2;
    prog_main := m2;
    prog_types := t2;
    prog_comp_env := e2;
    prog_comp_env_eq := q2|}  => (d1, d2) end.
(* match merge_global_definitions 
               (SortGlobdef.sort d1) (SortGlobdef.sort d2) with
   Errors.Error err => None
 | Errors.OK d => Some true end end.*)
(*
     match merge_prog_types (SortComp.sort t1) (SortComp.sort t2) with
     Errors.Error err => None
   | Errors.OK t =>
       match build_composite_env t as e 
             return (build_composite_env t = e -> option bool(*Clight.program*)) with
     | Errors.Error err => fun _ => None
     | Errors.OK e =>  fun q => 
 if negb (eqb_ident m1 m2) 
   then None
   else
    Some true (*{| prog_defs := d;
    prog_public := SortPos.merge (SortPos.sort p1) (SortPos.sort p2);
    prog_main := m2;
    prog_types := t;
    prog_comp_env := e;
    prog_comp_env_eq := q|} *)
   end eq_refl 
end end end.*)
*)
Require Import VST.floyd.linking.
(*Merge SM WITH SUBJ*)
Eval compute in (link_progs surelyMalloc.prog Subject.prog).
Definition sm_subj_prog': Clight.program := 
  match link_progs surelyMalloc.prog Subject.prog with
    Errors.OK p => p
  | _ => surelyMalloc.prog (*arbitrary*)
  end.

Eval hnf in (link_progs surelyMalloc.prog Subject.prog). (*Errors.sOK*)

Definition sm_subj_prog := ltac:
  (let x := eval hnf in sm_subj_prog' in
   let x := eval simpl in x in 
   let x := eval compute in x in 
       exact x).
Eval compute in (List.map fst (initial_world.prog_funct sm_subj_prog)).
(*1-56, 61, 68, 71, 73-78*)

(*Independently, merge SM with OBS*)

Eval compute in (link_progs surelyMalloc.prog Observer.prog).
Definition sm_obs_prog': Clight.program := 
  match link_progs surelyMalloc.prog Observer.prog with
    Errors.OK p => p
  | _ => surelyMalloc.prog (*arbitrary*)
  end.

Eval hnf in (link_progs surelyMalloc.prog Observer.prog). (*Errors.sOK*)

Definition sm_obs_prog := ltac:
  (let x := eval hnf in sm_obs_prog' in
   let x := eval simpl in x in 
   let x := eval compute in x in 
       exact x).

Eval compute in (List.map fst (initial_world.prog_funct sm_obs_prog)).
(*1-56, 61, 68, 74, 76, 81-83*)

(*Now merge the two*)
Definition sm_subj_obs_prog': Clight.program := 
  match link_progs sm_subj_prog sm_obs_prog with
    Errors.OK p => p
  | _ => Subject.prog (*arbitrary*)
  end.
Definition sm_subj_obs_prog := ltac:
  (let x := eval hnf in sm_subj_obs_prog' in
   let x := eval simpl in x in 
   let x := eval compute in x in 
       exact x).

Eval compute in (sm_subj_obs_prog). 
(*link_progs sm_obs_prog (*sm_obs_prog*)Observer.prog).*)
Eval compute in (List.map fst (initial_world.prog_funct sm_subj_obs_prog')).
(*
Definition sm_subj_obs_prog := ltac:
  (let x := eval hnf in sm_subj_obs_prog' in
   let x := eval simpl in x in 
   let x := eval compute in x in 
       exact x).
Eval compute in (List.map fst (initial_world.prog_funct sm_subj_obs_prog)).
Eval compute in (initial_world.prog_funct sm_subj_obs_prog).
(*Goal List.map fst (initial_world.prog_funct sm_subj_obs_prog) = nil.
unfold map. cbv. compute. simpl.*)
Check initial_world.find_id.
Eval compute in (initial_world.find_id _surely_malloc (prog_defs sm_subj_obs_prog)).
*)
Instance sm_subj_obs_cs : compspecs. make_compspecs sm_subj_obs_prog. Defined.
