Require Import VST.floyd.proofauto.

(*Model-level representation of subjects and observers*)

(*Not sufficient, due to information loss in the update->notify->get callback
Definition SubjectRepTp:Type := (list (val*val)) * Z. (* list of (pointers to) observers, current value) *)*)

(* list of (pointers to) nodes of observers, current value) *)
Definition SubjectRepTp:Type := (list val) * Z.

Definition newSubject: SubjectRepTp:= (nil, 0).

(*Model-level representation of observers*)
Definition ObserverRepTp:Type := val * Z. (*ptr to subject, cache*)

Definition newObserver (S:SubjectRepTp) s: ObserverRepTp:= (s, snd S).

Record SubjectAPD := {
  Subjectrep: SubjectRepTp -> val -> mpred;
  RegisterPre: SubjectRepTp -> val -> mpred;
  UpdatePre: SubjectRepTp -> val -> mpred;
  GetPre: SubjectRepTp -> val -> mpred;
  GetPost: SubjectRepTp -> val -> mpred;
  Subject_Register: forall S s, Subjectrep S s |-- RegisterPre S s;
  Subject_Update: forall S s, Subjectrep S s |-- UpdatePre S s;
  Subject_GetPrePost: forall S s, Subjectrep S s |-- (GetPre S s * (GetPost S s -* Subjectrep S s))%logic;
  GetPre_ptrnull: forall S s, GetPre S s |-- !!(is_pointer_or_null s);
    (*could add ptrnull lemmas for the other residual predicates, too*)
}.

Lemma Subjectrep_ptrnull A S s: Subjectrep A S s |-- !!(is_pointer_or_null s).
Proof. sep_apply Subject_GetPrePost. sep_apply GetPre_ptrnull. entailer!. Qed.

Record ObserverAPD := {
    Observerrep: ObserverRepTp -> val -> mpred;
    NotifyPre: ObserverRepTp -> val -> mpred;
    NotifyPre_isptr: forall O o, NotifyPre O o |-- !!(isptr o);
    ValPre: ObserverRepTp -> val -> mpred;
    Observer_Notify: forall O o, Observerrep O o |-- NotifyPre O o;
    Observer_Val: forall O o, Observerrep O o |-- ValPre O o
}.

Lemma Observerrep_isptr A O o: Observerrep A O o |-- !!(isptr o).
Proof. sep_apply Observer_Notify. sep_apply NotifyPre_isptr. entailer!. Qed.