#include "surelyMalloc.h"
#include "Observer.h"
#include "Subject.h"

#include "Subject_rep.h"

Node add (Node n, Observer o) {
  Node nd = (Node)surely_malloc(sizeof *n);
  nd -> obs = o;
  nd -> next = n;
  return nd;
}

Subject newSubject () {
  Subject s = (Subject)surely_malloc(sizeof *s);
  s -> obs = NULL;
  s -> value = 0;
  return s;
}

void registr (Subject s, Observer o) {
  Node n = add(s->obs, o);
  s -> obs = n;
  notify(o, &get);
};

void update (Subject s, int n) {
  s->value = n;
  Node nd = s -> obs;
  while (nd) {
    notify(nd->obs, &get);
    nd = nd -> next;
  }
}; 

int get (Subject s) {
  return (s->value);
}; 

Observer detachfirst(Subject s) {  
  Node nd = s -> obs;
  if (!nd) { return NULL; }
  Observer o = nd -> obs;
  s -> obs = nd -> next;
  free(nd);
  return o;
}

int freeSubject(Subject s) {
  if (s->obs) { return 1; }
  free(s);
  return 0;
}
