Require Export VST.floyd.proofauto.
Require Export Predicates. (*the semantic constructions, and declaration of repr predecates*)

Require Import spec_stdlib. (*needed for mem_mgr, ie MallocFree_APD*)
Require Import Composite. (*needed for function and type names *)

Global Open Scope funspec_scope.
Notation nodeTP := (Tstruct _Node noattr).

Section CompositeASI.
  Variable M: MallocFreeAPD.
  Variable C: CompositeAPD.

  Definition create_spec :=
    DECLARE _create
    WITH gv: globals
    PRE [ ] 
    PROP() PARAMS () GLOBALS (gv) SEP(mem_mgr M gv)
    POST[ tptr nodeTP ]
    EX p: val,
     PROP()
     RETURN (p)
     SEP(isTree C p (Tnode p Tnil Tnil); mem_mgr M gv).

  Definition addLeft_spec :=
    DECLARE _addLeft
    WITH node:val, v:_, gv:globals
    PRE [ tptr nodeTP ] 
    PROP(valueOf v node = Tnode node Tnil Tnil) PARAMS (node) GLOBALS (gv)
      SEP(isTree C node v; mem_mgr M gv)
    POST[ tptr nodeTP ]
    EX res: val,
     PROP(uniqueNodes (replace v node (Tnode node (Tnode res Tnil Tnil) Tnil))=true)
     RETURN (res)
     SEP(isTree C node(*res works*) (replace v node (Tnode node (Tnode res Tnil Tnil) Tnil)); mem_mgr M gv).

  Definition MyaddLeft_spec :=
    DECLARE _addLeft
    WITH node:val, v:_, gv:globals
    PRE [ tptr nodeTP ] 
    PROP(valueOf v node = Tnode node Tnil Tnil) PARAMS (node) GLOBALS (gv)
      SEP(isTree C node v; mem_mgr M gv)
    POST[ tptr nodeTP ]
    EX res: val,
     PROP(uniqueNodes (replace v node (Tnode node (Tnode res Tnil Tnil) Tnil))=true)
     RETURN (res)
     SEP(isTree C (*node*)res (replace v node (Tnode node (Tnode res Tnil Tnil) Tnil)); mem_mgr M gv).

Lemma MyaddLeft_deriveable: funspec_sub (snd addLeft_spec) (snd MyaddLeft_spec).
Proof. do_funspec_sub. clear H. Exists w emp. destruct w as [[node v] gv]. entailer!.
 intros. Exists ( eval_id ret_temp x). entailer. cancel. 
 sep_apply (rotate C node (replace v node (Tnode node (Tnode (eval_id ret_temp x) Tnil Tnil) Tnil)) (eval_id ret_temp x)); trivial.
 simpl in *. subst. clear H1 H2.
 induction v; simpl in *. discriminate.
 destruct (Val.eq v1 node); subst; simpl.
 + destruct (Val.eq node node). 2: congruence. inv H.
   destruct (Val.eq (eval_id ret_temp x) (eval_id ret_temp x)). rewrite orb_true_r; simpl; trivial. congruence.
 + destruct (Val.eq node v1); subst; simpl.
   - inv H; simpl in *. congruence.
   - destruct (contains v2 node); simpl in *.
     * repeat rewrite andb_true_iff in H3. destruct H3 as [[[[? ?] ?] U1] U2].
       apply binop_lemmas3.negb_true in H0. apply binop_lemmas3.negb_true in H1.
       rewrite (IHv1 H U1), orb_true_r; trivial.
     * repeat rewrite andb_true_iff in H3. destruct H3 as [[[[? ?] ?] U1] U2].
       apply binop_lemmas3.negb_true in H0. apply binop_lemmas3.negb_true in H1.
       rewrite (IHv2 H U2), orb_true_r; trivial.
Qed.

 Definition getNbOfNodes_spec :=
    DECLARE _getNbOfNodes
    WITH n:val, value:_
    PRE [ tptr nodeTP ] 
    PROP() PARAMS (n) GLOBALS ()
      SEP(isTree C n value)
    POST[ tint ]
     PROP()
     RETURN (Vint (Int.repr (size (valueOf value n))))
     SEP(isTree C n value).

  Definition CompositeASI:funspecs := [ create_spec; addLeft_spec; getNbOfNodes_spec ].

End CompositeASI.