Require Export VST.floyd.proofauto.

Inductive tree :=
  Tnil: tree
| Tnode: val -> tree -> tree -> tree.

Fixpoint count (t: tree):Z :=
  match t with
    Tnil => 0
  | Tnode n l r => 1 + count l + count r
  end.

Inductive context:Prop :=
  root: context
| left_context: context -> val -> tree -> context 
| right_context: context -> val -> tree -> context.

Record TreeAPD := {
  TreePred: val -> context -> tree -> mpred;
  TreePred_ptrnull: forall n c t, TreePred n c t |-- 
        !!(is_pointer_or_null n) && TreePred n c t
}.


Hint Resolve TreePred_ptrnull: valid_pointer.
