Require Import VST.floyd.proofauto.
Require Import VST.floyd.VSU.
Require Import VST.floyd.linking.
Require Import VSU_Application.
Require Import spec_stdlib.
Require Import MMlib_prog.
Require Import verif_stdlib.
Require Import ASI_mmap0.

Section Applib_VSU.

(************ Connect application program with stlib+mm ***************************)
Definition applib': Clight.program := 
  match link_progs mmlib_prog application_prog with
    Errors.OK p => p
  | _ => mmlib_prog (*arbitrary*)
  end.
Definition applib := ltac:
  (let x := eval hnf in applib' in
   let x := eval simpl in x in 
   let x := eval compute in x in 
       exact x).

Instance ApplibCS : compspecs. make_compspecs applib. Defined.

Definition ApplibVprog:varspecs. mk_varspecs applib. Defined.

Definition ApplibImports:funspecs := nil.

Definition ApplibExports:funspecs := G_merge mmlib_Exports (AppExports M).

Definition ApplibSys:funspecs := [exit_spec; munmap_spec mmap0._munmap].

Definition ApplibInitPred (gv: globals): mpred:= ((EX R : resvec, malloc_sep.mem_mgr_R R gv) * emp)%logic.

Definition Applib_VSU:
@VSU NullExtension.Espec ApplibVprog ApplibCS ApplibSys 
     ApplibImports applib ApplibExports ApplibInitPred.
Proof.
  VSULink_tac MMlib_VSU (Application_VSU M).
  extensionality gv; simpl. reflexivity.
Qed.

Definition Applib_CanVSU: @CanonicalVSU NullExtension.Espec
   ApplibVprog ApplibCS ApplibSys 
   ApplibImports applib ApplibExports ApplibInitPred.
Proof. apply (VSU_to_CanonicalVSU Applib_VSU). Qed.

End Applib_VSU.