Require Import VST.floyd.proofauto.
Require Import VST.floyd.VSU.
Require Import VST.veric.initial_world.

Require Import VST.floyd.linking.
Require Import spec_stdlib.
Require Import spec_surelyMalloc.

Require Import ASI_Composite.
Require Import VSU_Composite.

Require Import verif_surelyMalloc.

Section Application_VSU.
Variable M: MallocFreeAPD.

Definition application_prog': Clight.program := 
  match link_progs Composite.prog surelyMalloc.prog  with
    Errors.OK p => p
  | _ => surelyMalloc.prog (*arbitrary*)
  end.

Definition application_prog := ltac:
  (let x := eval hnf in application_prog' in
   let x := eval simpl in x in 
   let x := eval compute in x in 
       exact x).

Instance AppCs : compspecs. make_compspecs application_prog. Defined.

Definition AppVprog:varspecs. mk_varspecs application_prog. Defined.

Definition AppImports:funspecs := 
[(*free_spec' M Composite._free;*) exit_spec; malloc_spec' M surelyMalloc._malloc].

Definition AppExports:funspecs := G_merge (Comp_ASI M)(SM_ASI M).

Definition Application_VSU:
@VSU NullExtension.Espec
   AppVprog AppCs nil AppImports application_prog AppExports emp.
Proof. 
  VSULink_tac (CompositeVSU M) (SMVSU M).
  extensionality gv; simpl; rewrite sepcon_emp; trivial.
Qed.

End Application_VSU.