Require Import VST.floyd.proofauto.
Require Import ASI_malloc. (*For MallocFreeAPD.*)
Require Import ASI_Composite.

Require Import main.

Section MAIN_Verif.
  Variable M: MallocFreeAPD.
  Variable C: CompositeAPD.

  (*Specification of "module-instantiated main" - we permit an arbitrary G here too.*)
  Definition main_inst_spec G:=
  DECLARE _main
  WITH gv: globals
  PRE [ ]
    PROP ()
    PARAMS () GLOBALS (gv)
    SEP (fold_right (fun g p => g gv * p) emp G; has_ext tt)
  POST[ tint ]
    PROP()
    LOCAL(temp ret_temp (Vint (Int.repr 1)))
    SEP((*mem_mgr M gv; *)TT;has_ext tt).

  Definition MainImports := CompositeASI M C. 

  Definition MainInitPred: list (globals -> mpred) := [mem_mgr M].
  Definition maininstspec := main_inst_spec MainInitPred.

  Definition MainVprog : varspecs. mk_varspecs main.prog. Defined.
  Definition MainGprog:funspecs := MainImports.

  Instance MainCompSpecs : compspecs. make_compspecs main.prog. Defined.
  Lemma body_main: semax_body MainVprog MainGprog f_main maininstspec.
  Proof.
  start_function. simpl; Intros.

   (*create*)
   forward_call. Intros mytree.

   (*addLeft(mytree)*)
   forward_call MyaddLeft_deriveable (mytree, Tnode mytree Tnil Tnil, gv).
   { simpl. destruct (Val.eq mytree mytree); trivial. congruence. }
   Intros child.

   (*addLeft(child)*)
   forward_call MyaddLeft_deriveable (child,
          (replace (Tnode mytree Tnil Tnil) mytree
             (Tnode mytree (Tnode child Tnil Tnil) Tnil)), gv).
   { simpl in *. destruct (Val.eq mytree mytree); simpl in *. 2: congruence. 
     destruct (Val.eq mytree child); simpl in *. congruence.
     destruct (Val.eq child mytree); simpl in *. congruence.
     destruct (Val.eq child child). simpl; trivial. congruence. }
   Intros child2.

   (*getNbOfNodes*)
   forward_call. forward. entailer!. f_equal. f_equal. simpl in *. 
   destruct (Val.eq mytree mytree). 2: congruence. simpl in *.
   destruct (Val.eq mytree child); simpl in *. congruence.
   destruct (Val.eq child child); simpl in *. 2: congruence.
   destruct (Val.eq mytree child); simpl in *. congruence.
   destruct (Val.eq mytree child2); simpl in *. congruence. 
   destruct (Val.eq child child2); simpl in *. congruence.
   destruct (Val.eq child2 mytree); simpl in *. congruence.
   destruct (Val.eq child2 child); simpl in *. congruence.
   destruct (Val.eq child2 child2); simpl in *; trivial. congruence.
  Qed.

End MAIN_Verif.