Require Import VST.floyd.proofauto.
Require Import VST.floyd.VSU.
Require Import spec_stdlib.
Require Import surelyMalloc.
Require Import spec_surelyMalloc.

Instance CompSpecs : compspecs. make_compspecs prog. Defined.

Section SM_VSU.

  Variable M: MallocFreeAPD.
  Notation SMASI:= (SM_ASI M). 

  Definition SM_imported_specs:funspecs := [malloc_spec' M _malloc; exit_spec].

  Definition SM_internal_specs:funspecs := SMASI.

  Definition SMVprog : varspecs. mk_varspecs prog. Defined.
  Definition SMGprog: funspecs := SM_imported_specs ++ SM_internal_specs.
(*
Lemma body_surely_malloc: semax_body SMVprog SMGprog f_surely_malloc 
     ( surely_malloc_spec M).
Proof.
start_function.
forward_call (malloc_spec_sub M t) gv.
Intros p.
if_tac.
+ subst. forward_if False.
  forward_call 1%Z. contradiction.
  inv H2.
+ forward_if True.
  - contradiction.
  - forward.
    entailer!.
  - forward.
    Exists p.
    entailer!.
Qed.*)

Lemma body_surely_malloc_numeric: 
      semax_body SMVprog SMGprog f_surely_malloc (surely_malloc_numericspec M).
Proof.
start_function.
forward_call.
Intros p.
if_tac.
+ subst. forward_if False.
  forward_call 1%Z. contradiction.
  elim H0; trivial.
+ forward_if True.
  - contradiction.
  - forward.
    entailer!.
  - forward.
    Exists p.
    entailer!.
Qed.

  Definition SMComponent: @Component NullExtension.Espec SMVprog _ 
      nil SM_imported_specs prog SMASI emp SM_internal_specs.
  Proof. 
    mkComponent.
    + solve_SF_internal body_surely_malloc_numeric.
  Qed.

  Definition SMVSU: @VSU NullExtension.Espec SMVprog _ 
      nil SM_imported_specs prog SMASI emp.
  Proof. eexists; apply SMComponent. Qed.
End SM_VSU.