 Require Export VST.floyd.proofauto.
Require Export Predicates. (*the semantic constructions, and declaration of repr predecates*)

Require Import spec_stdlib. (*needed for mem_mgr, ie MallocFree_APD*)
Require Import Connection. (*needed for function and type names *)

Global Open Scope funspec_scope.
Notation DatabaseTP := (Tstruct _database noattr).
Notation ConnectionTP:= (Tstruct _connection noattr).

Section ConnectionASI.
  Variable M: MallocFreeAPD.
  Variable D: DatabaseAPD.
  Variable C: ConnectionAPD.

  Definition newDB_spec :=
    DECLARE _newDB
    WITH dbI: DBIndex, gv: globals
    PRE [ tint ] 
    PROP() PARAMS (Vint (Int.repr dbI)) GLOBALS (gv) SEP(mem_mgr M gv)
    POST[ tptr DatabaseTP ]
    EX p: val,
     PROP()
     LOCAL(temp ret_temp p)
     SEP(DB D dbI p; mem_mgr M gv).

  Definition consConn_spec :=
    DECLARE _consConn
    WITH d:val, dbI:DBIndex, cI:ConnTP C, gv: globals
    PRE [ tptr DatabaseTP]
    PROP() PARAMS (d) GLOBALS (gv)
    SEP(DB D dbI d; NextConn C cI gv; mem_mgr M gv)
    POST[ tptr ConnectionTP ]
    EX p: val,
      PROP()
      LOCAL(temp ret_temp p)
      SEP(DB D dbI d; mem_mgr M gv;
          if Val.eq p nullval
          then NextConn C cI gv
          else (EX cI', NextConn C cI'(*(cI+1)*) gv * Conn C (d, cI) p)).

  Definition ConnectionASI:funspecs := [ consConn_spec; newDB_spec].

End ConnectionASI.