Require Export VST.floyd.proofauto.
Require Export Predicates.

Require Import spec_stdlib. (*needed for mem_mgr, ie MallocFreeAPD*)
Require Import Connectionpool. (*needed for function and type names *)

Global Open Scope funspec_scope.

Notation PoolTP := (Tstruct _pool noattr).
Notation DatabaseTP := (Tstruct _database noattr).
Notation ConnectionTP:= (Tstruct _connection noattr).

Section PoolASI.
  Variable M: MallocFreeAPD.
  Variable D: DatabaseAPD.
  Variable C: ConnectionAPD.
  Variable P: PoolAPD.

  Definition consPool_spec :=
    DECLARE _consPool
    WITH d: val, (*dbI: DBIndex,*) gv: globals
    PRE [ tptr DatabaseTP ]
    PROP() PARAMS (d) GLOBALS (gv) SEP((*DB D dbI d; *)mem_mgr M gv)
    POST[ tptr PoolTP ]
    EX p: val,
     PROP()
     LOCAL(temp ret_temp p)
     SEP(Pool P d p; (*DB D dbI d;*) mem_mgr M gv).

  Definition getConn_spec :=
    DECLARE _getConn
    WITH p:val, d:val, dbI:DBIndex, cI:ConnTP C, gv: globals
    PRE [ tptr PoolTP]
    PROP() PARAMS (p) GLOBALS (gv)
    SEP(Pool P d p; DB D dbI d; NextConn C cI gv; mem_mgr M gv)
    POST[ tptr ConnectionTP ]
    EX n: val,
      PROP()
      LOCAL(temp ret_temp n)
      SEP(Pool P d p; 
          DB D dbI d; mem_mgr M gv;
          if Val.eq n nullval then NextConn C cI gv else
          (EX cI' cI'', NextConn C cI' gv * Conn C (d, cI'') n)).

  Definition freeConn_spec :=
    DECLARE _freeConn
    WITH p:val, c:val, d:val, dbI:DBIndex, cI:ConnTP C, gv: globals
    PRE [ tptr PoolTP, tptr ConnectionTP ]
    PROP() PARAMS (p; c) GLOBALS (gv)
    SEP(Pool P d p; (*DB D dbI d;*) Conn C (d, cI) c; mem_mgr M gv)
    POST[ tvoid ]
      PROP()
      LOCAL()
      SEP(Pool P d p; (*DB D dbI d; *)mem_mgr M gv).

  Definition PoolASI:funspecs := [ consPool_spec; getConn_spec; freeConn_spec].

End PoolASI.