#ifndef PointOBJ_Interface
#define PointOBJ_Interface


/**** Simple Points have just methods for getting and setting the
      coordinate. No contructors here.***/

typedef struct point *Point;
/*typedef void * Point;*/

struct methods {
  int (*get) (Point);
  void (*set) (Point, int);
};

typedef struct methods * Methods;

struct point {
  Methods mtable;
};


/**** Bumpable points have an additional methods bumping the coordinate. */

typedef struct bpoint *BPoint;

/*Formally, "self" is still a point*/
struct bmethods {
  int (*get) (Point);
  void (*set) (Point, int);
  void (*bump) (BPoint);
};

typedef struct bmethods * BMethods;

struct bpoint {
  BMethods mtable;
};

/****Colored points are bumpable and have a color, which is
     initialized during object creation, and modified in the
     overriding of set in one variant) */

typedef struct cpoint *CPoint;

struct cmethods {
  int (*get) (Point);
  void (*set) (Point, int);
  void (*bump) (BPoint);
  int (*getC) (CPoint);
};

typedef struct cmethods * CMethods;

struct cpoint {
  CMethods mtable;
};

#endif
