Require Import VST.floyd.proofauto.
Require Import ASI_malloc. (*needed for mem_mgr*)
Require Import SimpleObjspec.
Require Import SimplePointModel.
Require Import SimplePoints_ASI.
Require Import VST.floyd.VSU.
Require Import Wrapper.
Require Import ASI_LLWrapper.
Require Import ASI_HLWrapper.

Section MakeWrapperAPD.
Variable M: MallocFreeAPD.
Variable cs:compspecs.

Definition MyPOINT T (PM: PointM T): Pred T := (*EX D,*)
fun x => Point point methods _mtable _get _set _ M (*D*) T PM x.

Definition MyBPOINT T (BPM: BPointM T): Pred T := (*EX D,*)
fun x => BPoint point bpoint bmethods _mtable _get _set _bump _ M (*D*) T BPM x.

Definition MyCPOINT T (CPM: CPointM T): Pred T := (*EX D,*)
fun x=> CPoint point bpoint cpoint cmethods _mtable _get _set _bump _getC _ M (*D*) T CPM x.

Definition MyWrapperAPD := Build_WrapperAPD MyPOINT MyBPOINT MyCPOINT.

Lemma makePt_sub T pc: 
      funspec_sub (makePoint_spec point methods _mtable _get _set _ M (*D*) T (*PM initP*)pc)
                  (makePOINT_spec point MyWrapperAPD M T (*PM initP*)pc).
Proof. destruct pc; do_funspec_sub. Exists w emp. destruct w as [gv i]; clear H; entailer!.
  intros. 
  assert_PROP (isptr (eval_id ret_temp x)) by (sep_apply Point_isptr; entailer!).
  Exists (eval_id ret_temp x); entailer!. unfold MyPOINT; simpl(*; Exists D*). cancel.
Qed.

Lemma makeBPt_sub T bc: 
      funspec_sub (makeBPoint_spec point bpoint bmethods _mtable _get _set _bump _ M T bc)
                  (makeBPOINT_spec bpoint MyWrapperAPD M T bc).
Proof. destruct bc; do_funspec_sub. Exists w emp. destruct w as [gv i]; clear H; entailer!.
  intros.
  assert_PROP (isptr (eval_id ret_temp x)) by (sep_apply BPoint_isptr; entailer!).
  Exists (eval_id ret_temp x); entailer!. unfold MyBPOINT; simpl(*; Exists D*); cancel.
Qed.

Lemma makeCPt_sub T cc: 
      funspec_sub (makeCPoint_spec point bpoint cpoint cmethods _mtable _get _set _bump _getC _ M T cc)
                  (makeCPOINT_spec cpoint MyWrapperAPD M T cc).
Proof. destruct cc; do_funspec_sub. Exists w emp. destruct w as [[gv i] c]; clear H; entailer!.
  intros. assert_PROP (isptr (eval_id ret_temp x)) by (sep_apply CPoint_isptr; entailer!).
  Exists (eval_id ret_temp x); entailer!. unfold MyCPOINT; simpl(*; Exists D*); cancel.
Qed.

Definition MyJustifiedWrapperAPD (*D*)T CT:=
           Build_JustifiedWrapperAPD point bpoint cpoint methods bmethods cmethods _mtable _get _set _bump _getC _ 
                            M T CT MyWrapperAPD (*D*) (makePt_sub (*D*)T) (makeBPt_sub (*D*)T) (makeCPt_sub (*D*)CT).

Variable T CT:Type.

  Definition HLWrapperMethods: funspecs:=
  ASI_HLWrapperMethods point bpoint cpoint (MyWrapperAPD (*M*)) T CT _GET _SET _BUMP _GETC.

  Definition LLWrapperMethods: funspecs:=
  ASI_LLWrapper point bpoint cpoint M _ _mtable _get _set _bump _getC _GET _SET _BUMP _GETC T CT.

  (*This lemma depends on definition of MyWrapper, MyPOINT etc, so can't be moved to ASI_HLWrapper.*)
  Lemma LL_sub_HL: funspecs_sqsub LLWrapperMethods HLWrapperMethods.
  Proof.
     red; intros. specialize (initial_world.find_id_In_map_fst _ _ _ H); intros.
     destruct H0 as [? | [? | [? | [? | ?]]]]; subst; try solve [contradiction]. 
  + simpl in H; inv H. simpl fst. eexists; split. reflexivity.
    eapply binary_intersection'_sub3.
    { eapply funspec_sub_trans. apply binary_intersection'_sub1.
      do_funspec_sub. destruct w as [[pt t] p]; clear H; entailer!.
      unfold MyPOINT; simpl. (* Intros DR*) Exists (((pt,t),p)(*, DR*)) emp. entailer!.
      intros. (*Exists DR*) entailer!. }
    eapply binary_intersection'_sub3. 
    { eapply funspec_sub_trans. apply binary_intersection'_sub2.
      eapply funspec_sub_trans. apply binary_intersection'_sub1.
      do_funspec_sub. destruct w as [[pt t] p]; clear H; entailer!.
      unfold MyBPOINT; simpl. (* Intros DR.*) Exists (((pt,t),p)(*, DR*)) emp. entailer!.
      intros. (* Exists DR.*) entailer!. }
    { eapply funspec_sub_trans. apply binary_intersection'_sub2.
      eapply funspec_sub_trans. apply binary_intersection'_sub2.
      do_funspec_sub. destruct w as [[pt t] p]; clear H; entailer!.
      unfold MyCPOINT; simpl. (* Intros DR.*) Exists (((pt,t),p)(*, DR*)) emp. entailer!.
      intros. (*Exists DR*) entailer!. }
  + simpl in H; inv H. simpl fst. eexists; split. reflexivity.
    eapply binary_intersection'_sub3.
    { eapply funspec_sub_trans. apply binary_intersection'_sub1.
      do_funspec_sub. destruct w as [[[pt t] p] i]; clear H; entailer!.
      unfold MyPOINT; simpl. (* Intros DR. *)
      Exists ((((pt,t),p),i)(*, DR*)) emp. entailer!.
      (*intros. (*Exists DR*) entailer!.*) }
    eapply binary_intersection'_sub3. 
    { eapply funspec_sub_trans. apply binary_intersection'_sub2.
      eapply funspec_sub_trans. apply binary_intersection'_sub1.
      do_funspec_sub. destruct w as [[[pt t] p] i]; clear H; entailer!.
      unfold MyBPOINT; simpl. (* Intros DR.*) 
      Exists ((((pt,t),p),i)(*, DR*)) emp. entailer!.
      (*intros. (*Exists DR*) entailer!.*) }
    { eapply funspec_sub_trans. apply binary_intersection'_sub2.
      eapply funspec_sub_trans. apply binary_intersection'_sub2.
      do_funspec_sub. destruct w as [[[pt t] p] i]; clear H; entailer!.
      unfold MyCPOINT; simpl(*; Intros DR*).
      Exists ((((pt,t),p),i)(*, DR*)) emp. entailer!.
      (*intros. (*Exists DR*) entailer!.*) }
  + simpl in H; inv H. simpl fst. eexists; split. reflexivity.
    eapply binary_intersection'_sub3.
    { eapply funspec_sub_trans. apply binary_intersection'_sub1.
      do_funspec_sub. destruct w as [[pt t] p]; clear H; entailer!.
      unfold MyBPOINT; simpl. (*Intros DR.*) Exists (((pt,t),p)(*, DR*)) emp. entailer!.
      (*intros. (*Exists DR.*) entailer!.*) }
    { eapply funspec_sub_trans. apply binary_intersection'_sub2.
      do_funspec_sub. destruct w as [[pt t] p]; clear H; entailer!.
      unfold MyCPOINT; simpl. (* Intros DR. *)
      Exists (((pt,t),p)(*, DR*)) emp. entailer!.
      (*intros. Exists DR. entailer!.*) }
  + simpl in H; inv H. simpl fst. eexists; split. reflexivity.
    do_funspec_sub. destruct w as [[pt t] p]; clear H; entailer!.
      unfold MyCPOINT; simpl. (*; Intros DR. *)
      Exists (((pt,t),p)(*, DR*)) emp. entailer!.
      intros. (*Exists DR.*) entailer!.
  Qed. 
End MakeWrapperAPD.

Require Import VSU_LLWrapper.

(*NICE: VSU_HLWrapper follows from VSU_LLWrapper using VSU_Exports_sub.*)
Section VSU_HLWrapper.
  Variable M: MallocFreeAPD.

  Instance CompSpecs : compspecs. make_compspecs Wrapper.prog. Defined.
  Definition Vprog : varspecs. mk_varspecs Wrapper.prog. Defined.
 
  Variable T CT:Type.

  Definition HLWrapper_VSU: @VSU NullExtension.Espec Vprog _ nil nil prog (HLWrapperMethods M _ T CT) emp.
  Proof. eapply VSU_Exports_sub. apply (LLWrapper_VSU M T CT).
     apply compute_list_norepet_e; cbv; reflexivity.
     apply (LL_sub_HL M CompSpecs T CT).
  Qed.

End VSU_HLWrapper.