Require Import VST.floyd.proofauto.
Require Import ASI_malloc.
Require Import SimplePointModel.
Require Import SimplePoints_ASI. 

Require Import ASI_LLWrapper.

Require Import ASI_WrapperClient.

Require Import WrapperClient.
Instance CompSpecs : compspecs. make_compspecs prog. Defined.

Definition Vprog : varspecs. mk_varspecs prog. Defined.

Ltac do_compute_expr_warning::=idtac.

Section Test3. 
Variable M:MallocFreeAPD.

Definition Test3_ImportedConstructors := 
   (*spec of makePoint_I1*) firstn 1 (SimplePointASI CompSpecs M _makePoint_I1 _makeBPoint_I1 _makeCPoint_I1) ++
   (*spec of makeCPoint_I2*) skipn 2 (SimplePointASI CompSpecs M _makePoint_I2 _makeBPoint_I2 _makeCPoint_I2).

Definition Test3_ImportedMethods:= 
           ASI_LLWrapper point bpoint cpoint M _ _mtable _get _set _bump _getC _GET _SET _BUMP _GETC PointRep CPointRep.
   (*LLWrapper specs of GET, SET, BUMP, GETC*)

Definition Test3_GProg_LL := Test3_ImportedConstructors ++ Test3_ImportedMethods.

Lemma verif_test3_LL:semax_body Vprog Test3_GProg_LL f_test3 (_test3, test3_spec M).
Proof. start_function.
  forward_call (gv, 3). rep_lia. Intros p1.

  forward_call (gv, 4, red). rep_lia. Intros cp1.

  forward_call GETsubPoint_LL (m1, Init_PointRep 3, p1).
  { rewrite sepcon_comm. apply sepcon_derives.  apply derives_refl. cancel. } (*Todo: remove dependence of SimplePointASI on SimpleClient?*)
  forward_call GETsubCPoint_LL (cm1, Init_CPointRep 4 red, cp1).
  { rewrite sepcon_comm. apply sepcon_derives.  apply derives_refl. cancel. }
  forward_call BUMPsubCPoint_LL (cm1, Init_CPointRep 4 red, cp1).
  { simpl. rep_lia. } 
  (*Variant1: don't simplify:
   forward_call SETsubCPoint_LL (cm1, bump _ cm1 (Init_CPointRep 4 red), cp1, 5). rep_lia.
  forward_call (cm1,set _ cm1 (bump _ cm1 (Init_CPointRep 4 red)) 5, cp1).
  forward. cancel. *)
  (*Variant 2: simplify the semantic object cp1 before continuing*)simpl.
  forward_call SETsubCPoint_LL (cm1, {| pointRep := {| value := 5 |}; color := red |}, cp1, 5). rep_lia.
  simpl.
  forward_call (cm1,{| pointRep := {| value := 5 |}; color := red |}, cp1).
  forward. cancel.
Qed.

End Test3.