Require Import VST.floyd.proofauto.
Require Import ASI_malloc.
Require Import PositiveSubtypingTheory.
Require Import SimplePointModel.
Require Import SimpleObjspec.
Require Import SimplePoints_ASI.
Require Import SimpleClient.
Require Import ASI_SimpleClient.

Instance CompSpecs : compspecs. make_compspecs prog. Defined.

Definition Vprog : varspecs. mk_varspecs prog. Defined.

Section Test1.
Variable M: MallocFreeAPD. 

Definition ASI1 := firstn 2 (SimplePointASI CompSpecs M _makePoint_I1 _makeBPoint_I1 _makeCPoint_I1).
(*Test1 does not call makeCPoint*)

Lemma verif_test1:semax_body Vprog ASI1 f_test1 (_test1, test1_spec M).
Proof. start_function.
  forward_call (gv, 3). rep_lia. Intros p1.

  forward_call (gv, 4). rep_lia. Intros bp1.

  rewrite Point_fold_unfold. Intros cso1 P m; simpl.
  (*replace_SEP 3 (field_at Ews point [StructField _mtable] m p1).
  { entailer. unfold field_at; simpl. rewrite mapsto_isptr; Intros. destruct p1; inv Pp1. 
    unfold at_offset; simpl. rewrite Ptrofs.add_zero. unfold data_at_rec. simpl. entailer.
    unfold field_compatible; simpl. apply prop_right. spli; trivial.
  forward.*)
  unfold FldAt; Intros m'; simpl. apply JMeq_eq in H; subst m'.
  freeze [0;1;3] FR1. forward.
  unfold MTable; Intros sh. unfold funcptrs; simpl.
  Intros g g' s s'. apply JMeq_eq in H0; subst g'. apply JMeq_eq in H1; subst s'. forward.
  forward_call. forward. 
  thaw FR1. deadvars!. clear.

  rewrite BPoint_fold_unfold. Intros cso2 BP bm; simpl.
  unfold FldAt; Intros bm'; simpl. simpl in bm'; apply JMeq_eq in H; subst bm'.
  (*replace_SEP 4 (field_at Ews bpoint [StructField _mtable] bm bp1). 
  { entailer. unfold field_at; simpl; entailer!. 2: apply derives_refl.
    apply FC_mtable_point_bpoint; trivial. }*)
  forward.
  unfold MTable; Intros bsh. unfold funcptrs; simpl.
  Intros bg bg' bs bs' bb bb'. apply JMeq_eq in H0; subst bg'.
     apply JMeq_eq in H1; subst bs'. apply JMeq_eq in H2; subst bb'. forward. forward. 
  (*freeze [0;2;5;6;7;10;11] FR2. replace_SEP 5 (). forward. forward.
  unfold MTable; Intros bsh. unfold funcptrs; simpl.
  Intros bg bg' bs bs' bb bb'. apply JMeq_eq in H1; subst bg'.
     apply JMeq_eq in H2; subst bs'. apply JMeq_eq in H3; subst bb'. forward.*)
  forward_call. forward.

  forward. forward. forward. deadvars!.
  forward_call (Init_PointRep 4, bp1). simpl; rep_lia. (*bumpable*)
  
  forward. forward. forward. forward_call. forward. forward.
  (*+ rewrite ! Int.signed_repr by admit.
    apply prop_right. split3; admit. (*arith*)
  + entailer!. admit. (*arith*) *)entailer!.
Qed.
End Test1.

Section Test2.
Variable M:MallocFreeAPD.

Definition ASI2 := firstn 2 (SimplePointASI CompSpecs M _makePoint_I2 _makeBPoint_I2 _makeCPoint_I2).
(*Test2 does not call makeCPoint*)

Lemma verif_test2:semax_body Vprog ASI2 f_test2 (_test2, test2_spec M).
Proof. start_function.
  forward_call (gv, 3). rep_lia. Intros p1.

  forward_call (gv, 4). rep_lia. Intros bp1.

  rewrite Point_fold_unfold. Intros cso1 P m; simpl.
  unfold FldAt; Intros m'; simpl. simpl in m'; apply JMeq_eq in H; subst m'. forward.
  unfold MTable; Intros sh. rename H into RSH. unfold funcptrs; simpl.
  Intros g g' s s'. apply JMeq_eq in H; subst g'.  apply JMeq_eq in H0; subst s'. forward.
  forward_call. forward.
  deadvars!. clear - RSH.

  rewrite BPoint_fold_unfold. Intros cso2 BP bm; simpl.
  unfold FldAt; Intros bm'; simpl. simpl in bm'; apply JMeq_eq in H; subst bm'. forward. forward.
  unfold MTable; Intros bsh. rename H into RSHB. unfold funcptrs; simpl.
  Intros bg bg' bs bs' bb bb'. apply JMeq_eq in H; subst bg'.
     apply JMeq_eq in H0; subst bs'. apply JMeq_eq in H1; subst bb'. forward.
  forward_call. forward.
  deadvars!. clear - RSHB.

  forward. forward. forward. deadvars!.
  forward_call (Init_PointRep 4, bp1). simpl; rep_lia. (*bumpable*)
  
  forward. forward. forward. forward_call. forward. forward. entailer!. 
Qed. 

End Test2.

Section Test12.
Variable M: MallocFreeAPD. 

Definition ASI12 := firstn 1 (SimplePointASI CompSpecs M _makePoint_I1 _makeBPoint_I1 _makeCPoint_I1)
                  ++ skipn 1 (SimplePointASI CompSpecs M _makePoint_I2 _makeBPoint_I2 _makeCPoint_I2).

Lemma verif_test12:semax_body Vprog ASI12 f_test12 (_test12, test12_spec M).
Proof. start_function.
  forward_call (gv, 3). rep_lia. Intros p.
  forward_call (gv, 4). rep_lia. Intros bp.
  forward_call (gv, 5, red). rep_lia. Intros cp. simpl.

  rewrite Point_fold_unfold. Intros delta P m; (*destruct delta as [csd delta];*) simpl.
  unfold FldAt; Intros m'; simpl. apply JMeq_eq in H; subst m'.
  forward.
  unfold MTable; Intros sh. rename H into RSH1. unfold funcptrs; simpl.
  Intros g g' s s'. apply JMeq_eq in H; subst g'. apply JMeq_eq in H0; subst s'. forward.
  forward_call. forward. 
  deadvars!. clear - RSH1.
  gather_SEP 0 4 5 6 7 8 9 10.
  replace_SEP 0 (Point point methods _mtable _get _set CompSpecs M PointRep m1
     (Init_PointRep 3, p)).
  { entailer!. rewrite Point_fold_unfold. Exists delta P m; simpl; entailer!.
    unfold FldAt, MTable. Exists m sh; simpl; entailer!.
    Exists s g g s. entailer!. }
  clear.

  rewrite BPoint_fold_unfold. Intros delta BP bm; simpl.
  unfold FldAt; Intros bm'; simpl. simpl in bm'; apply JMeq_eq in H; subst bm'.
  forward.
  unfold MTable; Intros bsh. rename H into RSH2. unfold funcptrs; simpl.
  Intros bg bg' bs bs' bb bb'. apply JMeq_eq in H; subst bg'.
     apply JMeq_eq in H0; subst bs'. apply JMeq_eq in H1; subst bb'. forward.
  forward_call. forward. deadvars!. clear - RSH2.
  (*Optionally, fold - but the next instruction is on the same object..
  gather_SEP 0 4 5 6 7 8 9 10. (*11 12 - apparently, the gather tactic does not allow this many arguments..*)
  gather_SEP 0 4 5.
  replace_SEP 0 (BPoint point bpoint bmethods _mtable _get _set _bump CompSpecs M DR2 PointRep bm1
     (Init_PointRep 4, bp)).
  { entailer!. rewrite BPoint_fold_unfold. Exists BP bm; simpl; entailer!.
    unfold FldAt, MTable. Exists bm bsh. simpl; entailer!.
    Exists bb bs bg. Exists bg bb bs. entailer!. }
   clear. *)


  forward. forward. deadvars!.
  forward_call (Init_PointRep 4, bp). simpl; rep_lia. (*bumpable*) (*Could again fold here, but would again need to immediately unfold*)
  
  forward. forward. forward_call. forward. deadvars!.
  gather_SEP 0 4 5 6 7 8 9 10. (*11 12 - apparently, the gather tactic does not allow this many arguments..*)
  gather_SEP 0 4 5.
  replace_SEP 0 (BPoint point bpoint bmethods _mtable _get _set _bump CompSpecs M (*DR2*) PointRep bm1
     ({| value:= 5|}, bp)).
  { entailer!. rewrite BPoint_fold_unfold. Exists delta BP bm; simpl; entailer!.
    unfold FldAt, MTable. Exists bm bsh. simpl; entailer!.
    Exists bb bs bg. Exists bg bb bs. entailer!. }
  clear.

  rewrite CPoint_fold_unfold. Intros delta CP cm; simpl.
  unfold FldAt; Intros cm'; simpl. simpl in cm'; apply JMeq_eq in H; subst cm'.
  forward.
  unfold MTable; Intros csh. rename H into RSH3. unfold funcptrs; simpl.
  Intros cg cg' cs cs' cb cb' cGC cGC'. apply JMeq_eq in H; subst cg'.
     apply JMeq_eq in H0; subst cs'. apply JMeq_eq in H1; subst cb'. apply JMeq_eq in H2; subst cGC'.
  forward. forward_call (Init_CPointRep 5 red, cp).
  { simpl. rep_lia. }
  deadvars!. simpl.

  forward. forward. forward_call. forward. deadvars!. simpl.

  forward. forward. forward_call. forward. deadvars!.
  gather_SEP 0 4 5 6 7 8 9 10. (*11 12 - apparently, the gather tactic does not allow this many arguments..*)
  gather_SEP 0 4 5 6 7.
  replace_SEP 0 (CPoint point bpoint cpoint cmethods _mtable _get _set _bump _getC CompSpecs M (*DR2*) CPointRep cm1
     ({| pointRep := {| value := 6 |}; color := red |}, cp)).
  { entailer!. rewrite CPoint_fold_unfold. Exists delta CP cm; simpl; entailer!.
    unfold FldAt, MTable. Exists cm csh. simpl; entailer!.
    Exists cGC cb cs cg. Exists cg cGC cb cs. entailer!. }
  clear.

  simpl; forward; cancel.
Qed.
End Test12.
Require Import VST.floyd.VSU.

Section VSU_SimpleClient.
Variable M: MallocFreeAPD.
(*Variable DR1 DR2: dynRep.*)

Definition SimpleClient_Imports := ASI1 M ++ 
           (SimplePointASI CompSpecs M  _makePoint_I2 _makeBPoint_I2 _makeCPoint_I2).
Definition SimpleClient_Internals := [(_test1, test1_spec M); (_test2, test2_spec M); (_test12, test12_spec M)].
Definition SimpleClient_Gprog:funspecs := SimpleClient_Imports ++ SimpleClient_Internals.

  Lemma verif_test1_common:semax_body Vprog SimpleClient_Gprog f_test1 (_test1, test1_spec M).
  Proof. eapply VSU.semax_body_subsumespec. apply (verif_test1 _ ).
  + intros i; red.
    rewrite 2 semax_prog.make_context_g_char, 2 initial_world.make_tycontext_s_find_id 
        by (apply compute_list_norepet_e; reflexivity). 
    remember (initial_world.find_id i (ASI1 M (*DR1*))) as d; symmetry in Heqd; destruct d.
    - specialize (initial_world.find_id_In_map_fst _ _ _ Heqd); intros.
      repeat (destruct H; [ simpl in H; subst i; inv Heqd; reflexivity |]). inv H.
    - remember (initial_world.find_id i SimpleClient_Gprog) as w; symmetry in Heqw; destruct w.
      * specialize (initial_world.find_id_In_map_fst _ _ _ Heqw); intros.
        repeat (destruct H; [ simpl in H; subst i; inv Heqd; reflexivity |]). inv H.
      * destruct (initial_world.find_id i Vprog); trivial.
  + intros i; red. remember (initial_world.find_id i (ASI1 M (*DR1*))) as d; symmetry in Heqd; destruct d; trivial.
    specialize (initial_world.find_id_In_map_fst _ _ _ Heqd); intros.
    repeat (destruct H; [ simpl in H; subst i; inv Heqd; eexists; split; [ reflexivity | apply seplog.funspec_sub_si_refl] |] ).
    inv H.
  Qed.
  Lemma verif_test2_common:semax_body Vprog SimpleClient_Gprog f_test2 (_test2, test2_spec M).
  Proof. eapply VSU.semax_body_subsumespec. apply (verif_test2 _ (*DR2*)).
  + intros i; red.
    rewrite 2 semax_prog.make_context_g_char, 2 initial_world.make_tycontext_s_find_id 
        by (apply compute_list_norepet_e; reflexivity). 
    remember (initial_world.find_id i (ASI2 M (*DR2*))) as d; symmetry in Heqd; destruct d.
    - specialize (initial_world.find_id_In_map_fst _ _ _ Heqd); intros.
      repeat (destruct H; [ simpl in H; subst i; inv Heqd; reflexivity |]). inv H.
    - remember (initial_world.find_id i SimpleClient_Gprog) as w; symmetry in Heqw; destruct w.
      * specialize (initial_world.find_id_In_map_fst _ _ _ Heqw); intros.
        repeat (destruct H; [ simpl in H; subst i; inv Heqd; reflexivity |]). inv H.
      * destruct (initial_world.find_id i Vprog); trivial.
  + intros i; red. remember (initial_world.find_id i (ASI2 M (*DR2*))) as d; symmetry in Heqd; destruct d; trivial.
    specialize (initial_world.find_id_In_map_fst _ _ _ Heqd); intros.
    repeat (destruct H; [ simpl in H; subst i; inv Heqd; eexists; split; [ reflexivity | apply seplog.funspec_sub_si_refl] |] ).
    inv H.
  Qed.
  Lemma verif_test12_common:semax_body Vprog SimpleClient_Gprog f_test12 (_test12, test12_spec M).
  Proof. eapply VSU.semax_body_subsumespec. apply (verif_test12 _ (*DR1 DR2*)).
  + intros i; red.
    rewrite 2 semax_prog.make_context_g_char, 2 initial_world.make_tycontext_s_find_id 
        by (apply compute_list_norepet_e; reflexivity). 
    remember (initial_world.find_id i (ASI12 M (*DR1 DR2*))) as d; symmetry in Heqd; destruct d.
    - specialize (initial_world.find_id_In_map_fst _ _ _ Heqd); intros.
      repeat (destruct H; [ simpl in H; subst i; inv Heqd; reflexivity |]). inv H.
    - remember (initial_world.find_id i SimpleClient_Gprog) as w; symmetry in Heqw; destruct w.
      * specialize (initial_world.find_id_In_map_fst _ _ _ Heqw); intros.
        repeat (destruct H; [ simpl in H; subst i; inv Heqd; reflexivity |]). inv H.
      * destruct (initial_world.find_id i Vprog); trivial.
  + intros i; red. remember (initial_world.find_id i (ASI12 M (*DR1 DR2*))) as d; symmetry in Heqd; destruct d; trivial.
    specialize (initial_world.find_id_In_map_fst _ _ _ Heqd); intros.
    repeat (destruct H; [ simpl in H; subst i; inv Heqd; eexists; split; [ reflexivity | apply seplog.funspec_sub_si_refl] |] ).
    inv H.
  Qed.

  Definition SimpleClient_Component: @Component NullExtension.Espec Vprog _ nil SimpleClient_Imports prog 
             (ASI_SimpleClient M _test1 _test2 _test12) emp SimpleClient_Internals.
  Proof. mkComponent_cautious.
     - solve_SF_internal verif_test1_common.
     - solve_SF_internal verif_test2_common.
     - solve_SF_internal verif_test12_common.
  Qed.

  Definition SimpleClient_VSU: @VSU NullExtension.Espec Vprog _ nil SimpleClient_Imports prog 
             (ASI_SimpleClient M _test1 _test2 _test12) emp.
  Proof. eexists; apply SimpleClient_Component. Qed.

End VSU_SimpleClient.