Require Import VST.floyd.proofauto.
Require Import SimplePointModel.

Section DeepPoints.

Variable T CT:Type.

Variant DeepPoint:=
  Deep_point: T -> PointM T -> DeepPoint
| Deep_bpoint: T -> BPointM T -> DeepPoint
| Deep_cpoint: CT -> CPointM CT -> DeepPoint.

Definition dp_get (d:DeepPoint):Z := match d with
    Deep_point t pm => get _ pm t
  | Deep_bpoint t bm => get _ bm t
  | Deep_cpoint t cm => get _ cm t
  end.

Definition dp_set (d:DeepPoint) (i:Z) : DeepPoint :=
  match d with
    Deep_point t pm => Deep_point (set T pm t i) pm
  | Deep_bpoint t bm => Deep_bpoint (set T bm t i) bm
  | Deep_cpoint t cm => Deep_cpoint (set CT cm t i) cm
  end.
Definition dp_bumpable (d:DeepPoint) :=
  match d with
    Deep_point t pm => False
  | Deep_bpoint t bm => bumpable _ bm t
  | Deep_cpoint t cm => bumpable _ cm t
  end.
Definition dp_bump (d:DeepPoint) : DeepPoint :=
  match d with
    Deep_point t pm => Deep_point t (*vacuous*) pm
  | Deep_bpoint t bm => Deep_bpoint (bump _ bm t) bm
  | Deep_cpoint t cm => Deep_cpoint (bump _ cm t) cm
  end.

Definition dp_colored (d:DeepPoint): Prop := match d with
  | Deep_cpoint (*_*) t cm => True
  | _ => False
end.
Definition dp_getc (d:DeepPoint):Z := match d with
    Deep_point t pm => 0 (*vacuous*)
  | Deep_bpoint t bm => 0 (*vacuous*)
  | Deep_cpoint t cm => (color_encoding _ cm (getC _ cm t))
  end.

End DeepPoints.