#include "surelyMalloc.h"
/*#include "PointOBJ_I2.h"*/
/*#include "PointOBJ_Interface.h"*/
#include "MkPoints_I2.h"
#include <limits.h>
#include <stdbool.h>

struct point_I2 { 
  Methods mtable;
  bool intmin; 
  int negvalue;
};

int get_I2 (Point p) {
  return ((((struct point_I2 *)p)->intmin)?INT_MIN:-(((struct point_I2 *)p)->negvalue));
}

void set_I2 (Point p, int i) {
  if (i==INT_MIN) {
    ((struct point_I2 *)p) -> intmin = true;
    return;
  } else {
    ((struct point_I2 *)p) -> intmin = false;
    ((struct point_I2 *)p) -> negvalue = -i;
    return;
  }
}

struct bpoint_I2 {
  BMethods mtable;
  bool intmin; 
  int negvalue;
};

void bump_I2 (BPoint p) {
  if (((struct bpoint_I2 *)p)->intmin) {
    ((struct bpoint_I2 *)p)->intmin=false;
    ((struct bpoint_I2 *)p)->negvalue = INT_MAX;
    return;
  } else { 
    ((struct bpoint_I2 *)p)->negvalue--;
    return;
  }
}

struct cpoint_I2 {
  CMethods mtable;
  bool intmin; 
  int negvalue;
  int color;
};

int getC_I2 (CPoint p) {
  return (((struct cpoint_I2 *)p)->color);
}

/*LATER
void destroy_I2 (Point p) {
  free(((struct point_I2 *)p)->mtable);
  free(p);
  }
*/

Point makePoint_I2 (int i) {
  Methods m = (Methods)surely_malloc(sizeof *m);
  /*We first fill and install the method table, so that the
    postcondition of setinternal spec can be that of set and make.
    We expect that different orders of instructions will
    be only slightly less convenient*/
  m -> get = &get_I2;
  m -> set = &set_I2;
  struct point_I2 *p = (struct point_I2 *)surely_malloc(sizeof *p);
  p -> mtable = m;
  set_I2 ((Point)p, i);
  return ((Point)p);
}

BPoint makeBPoint_I2 (int i) {
  BMethods m = (BMethods)surely_malloc(sizeof *m);
  /*We first fill and install the method table, so that the
    postcondition of setinternal spec can be that of set and make.
    We expect that different orders of instructions will
    be only slightly less convenient*/
  m -> get = &get_I2;
  m -> set = &set_I2;
  m -> bump = &bump_I2;
  struct bpoint_I2 *p = (struct bpoint_I2 *)surely_malloc(sizeof *p);
  p -> mtable = m;
  set_I2 ((Point)p, i);
  return ((BPoint)p);
}

CPoint makeCPoint_I2 (int i, int c) {
  CMethods m = (CMethods)surely_malloc(sizeof *m);
  /*We first fill and install the method table, so that the
    postcondition of setinternal spec can be that of set and make.
    We expect that different orders of instructions will
    be only slightly less convenient*/
  m -> get = &get_I2;
  m -> set = &set_I2;
  m -> bump = &bump_I2;
  m -> getC = &getC_I2;
  struct cpoint_I2 *p = (struct cpoint_I2 *)surely_malloc(sizeof *p);
  p -> mtable = m;
  p -> color = c;
  set_I2 ((Point)p, i);
  return ((CPoint)p);
}
