Require Import VST.floyd.proofauto.
Require Import VST.floyd.VSU.
Require Import VST.floyd.linking.
Require Import link_progs.

Require Import VSU_SimpleClient_Application.
Require Import spec_stdlib.
Require Import verif_stdlib.
Require Import ASI_mmap0.

Section Applib_VSU. 

Definition ApplibImports:funspecs := nil.

Goal compute_list_norepet (map fst (mmlib_Exports ++ Application_Exports M)) = true. cbv; trivial. Qed.

Definition ApplibExports:funspecs := mmlib_Exports ++ Application_Exports M.

Definition ApplibSys:funspecs := [exit_spec; munmap_spec mmap0._munmap].

Definition ApplibInitPred (gv: globals): mpred:= mem_mgr M gv.

Definition Applib_VSU:
@VSU NullExtension.Espec applib_Vprog applib_cs ApplibSys 
     ApplibImports applib ApplibExports ApplibInitPred.
Proof.
  VSULink_tac MMlib_VSU (Application_VSU M).
  extensionality gv; simpl. rewrite sepcon_emp; trivial.
Qed.

Definition Applib_CanVSU: @CanonicalVSU NullExtension.Espec
   applib_Vprog applib_cs ApplibSys 
   ApplibImports applib ApplibExports ApplibInitPred.
Proof. apply (VSU_to_CanonicalVSU Applib_VSU). Qed.

End Applib_VSU.