Require Import VST.floyd.proofauto.
Require Import ASI_malloc. 
Require Import SimplePointModel.
Require Import SimpleObjspec. (*For Pred*)
Require Import DeepPoints.
Require Import SimplePoints_ASI.

Require Import ASI_HLWrapper. (*For WrapperAPD/JustifiedWrapperAPD*)
Require Import ASI_DeepWrapper.

Require Import ASI_WrapperClient.

Require Import WrapperClient.
Instance CompSpecs : compspecs. make_compspecs prog. Defined.

Definition Vprog : varspecs. mk_varspecs prog. Defined.

Ltac do_compute_expr_warning::=idtac.

Section Test3. 
Variable M:MallocFreeAPD. (*
Variable JW: JustifiedWrapperAPD point bpoint cpoint methods bmethods cmethods 
              _mtable _get _set _bump _getC _ M.*)
Variable DP: Pred (DeepPoint PointRep CPointRep).

Definition ConstructorSpecs1 :=
           DeepConstructorsASI point bpoint cpoint  PointRep CPointRep DP M (*m1 bm1 cm1 Init_PointRep Init_CPointRep*)
            ptConstr1 bptConstr1 cptConstr1  _makePoint_I1 _makeBPoint_I1 _makeCPoint_I1.

Definition ConstructorSpecs2 :=
           DeepConstructorsASI point bpoint cpoint  PointRep CPointRep DP M (*m1 bm1 cm1 Init_PointRep Init_CPointRep*)
            ptConstr1 bptConstr1 cptConstr1 _makePoint_I2 _makeBPoint_I2 _makeCPoint_I2.

Definition ConstructorSpecs3 :=
           DeepConstructorsASI point bpoint cpoint  PointRep CPointRep DP M (*m1 bm1 cm1 Init_PointRep Init_CPointRep*)
            ptConstr1 bptConstr1 cptConstr1 _makePoint_I3 _makeBPoint_I3 _makeCPoint_I3.

Definition MethodImports := DeepMethodsASI point bpoint cpoint PointRep CPointRep DP _GET _SET _BUMP _GETC.

Definition Test3_GProg_Deep := ConstructorSpecs1 ++ ConstructorSpecs2 ++ ConstructorSpecs3 ++ MethodImports.

Lemma verif_test3_Deep:semax_body Vprog Test3_GProg_Deep f_test3 (_test3, test3_spec M).
Proof. start_function.
  forward_call (gv, 3). rep_lia. Intros p1. simpl.

  forward_call (*(CPt_sub _ _ _ _ _ _ _ _ _ _ _ _ _ _ JW2 CPointRep cm1 Init_CPointRep)*) (gv, 4, red). rep_lia. Intros cp1.

  forward_call (Deep_point PointRep CPointRep (Init_PointRep 3) m1, p1).
  forward_call (Deep_cpoint PointRep CPointRep (Init_CPointRep 4 red) cm1, cp1).
  { simpl; cancel. }
  forward_call (Deep_cpoint PointRep CPointRep (Init_CPointRep 4 red) cm1, cp1).
  { simpl. rep_lia. } 
  (*Variant1: don't simplify:
   forward_call (dp_bump PointRep CPointRep bm1 cm1
             (Deep_cpoint PointRep CPointRep (Init_CPointRep 4 red)), cp1, 5). rep_lia.
  forward_call (Init_CPointRep 5 red, cp1).
  { rewrite sepcon_assoc. apply sepcon_derives; [ apply derives_refl | cancel] . }
  simpl; forward; cancel. *)
(*  Opaque DP.*)
  (*Variant 2: simplify the semantic object cp1 before continuing*)simpl.
  forward_call (Deep_cpoint PointRep CPointRep {| pointRep := {| value := 5 |}; color := red |} cm1, cp1, 5). rep_lia.
  simpl.
  forward_call (Deep_cpoint PointRep CPointRep {| pointRep := {| value := 5 |}; color := red |} cm1, cp1).
  { simpl; trivial. }
  simpl; forward; cancel.
Qed.

End Test3.

Require Import ASI_DeepPointList.
Section Test4.
Variable M:MallocFreeAPD.
(*Variable JW: JustifiedWrapperAPD point bpoint cpoint methods bmethods cmethods 
              _mtable _get _set _bump _getC _ M.*)
Variable DP: Pred (DeepPoint PointRep CPointRep).

Definition ConstructorSpecs4_1 :=
           DeepConstructorsASI point bpoint cpoint  PointRep CPointRep DP M (*m1 bm1 cm1 Init_PointRep Init_CPointRep*)
               ptConstr1 bptConstr1 cptConstr1 _makePoint_I1 _makeBPoint_I1 _makeCPoint_I1.

Definition ConstructorSpecs4_2 :=
           DeepConstructorsASI point bpoint cpoint  PointRep CPointRep DP M (*m1 bm1 cm1 Init_PointRep Init_CPointRep*)
               ptConstr1 bptConstr1 cptConstr1 _makePoint_I2 _makeBPoint_I2 _makeCPoint_I2.

Definition ConstructorSpecs4_3 :=
           DeepConstructorsASI point bpoint cpoint  PointRep CPointRep DP M (*m1 bm1 cm1 Init_PointRep Init_CPointRep*)
               ptConstr1 bptConstr1 cptConstr1 _makePoint_I3 _makeBPoint_I3 _makeCPoint_I3.

Definition ConstructorSpecs4_4 :=
           DeepConstructorsASI point bpoint cpoint  PointRep CPointRep DP M (*m1 bm1 cm1 Init_PointRep Init_CPointRep*)
               ptConstr1 bptConstr1 cptConstr1 _makePoint_I4 _makeBPoint_I4 _makeCPoint_I4.

Variable LIST: list val -> val -> mpred.
Variable LIST_NIL: emp |-- LIST nil nullval.

Definition MethodImports_4 := ASI_PointList (Tstruct _list noattr) point M LIST PointRep CPointRep DP _insert _map_set _map_bump _sum
           ++ firstn 1 (MethodImports DP).

Definition Test4_GProg_Deep := ConstructorSpecs4_1 ++ ConstructorSpecs4_2 ++ ConstructorSpecs4_3 ++ ConstructorSpecs4_4 ++ MethodImports_4.

Lemma verif_test4:semax_body Vprog Test4_GProg_Deep f_test4 (_test4, test4_spec M).
Proof. start_function.
  forward.
  forward_call (gv, 1). simpl; rep_lia. Intros bp.
  sep_apply LIST_NIL. 

  forward_call (nullval, bp, @nil val, gv). Intros l.

  forward_call (gv, 2, green). rep_lia. Intros cp.

  forward_call (l, cp, [bp], gv). clear l. Intros l.

  (*map_bump*)
  forward_call (l, [(Deep_cpoint PointRep CPointRep (Init_CPointRep 2 green) cm1, cp); (Deep_bpoint PointRep CPointRep (Init_PointRep 1) bm1, bp)]).
  { simpl. cancel. }
  { simpl. repeat (constructor; [ try (simpl; rep_lia) |]); constructor. }
  simpl.
  
   (*GET bp*)
  forward_call (Deep_bpoint PointRep CPointRep {| value := 2 |} bm1, bp).
  { cancel. }
  simpl.

   (*GET cp*)
   forward_call (Deep_cpoint PointRep CPointRep {| pointRep := {| value := 3 |}; color := green |} cm1, cp).
  simpl.

  forward_call (gv, 3). simpl; rep_lia. Intros p1.

  forward_call (l, p1, [cp;bp], gv). clear l. Intros l.

  (*map_set*)
  forward_call (l, 42, [(Deep_point PointRep CPointRep (Init_PointRep 3) m1, p1); 
                       (Deep_cpoint PointRep CPointRep {| pointRep := {| value := 3 |}; color := green |} cm1, cp); 
                       (Deep_bpoint PointRep CPointRep {| value := 2 |} bm1, bp)]).
  { simpl. cancel. }
  { rep_lia. }
  simpl.

  forward_call (gv, 4). simpl; rep_lia. Intros p2.

  forward_call (l, p2, [p1;cp;bp], gv). clear l. Intros l.

  (*map_bump
  forward_call (l, [(Deep_point PointRep CPointRep (Init_PointRep 4), p2);
                    (Deep_point PointRep CPointRep {| value := 42 |}, p1);
                    (Deep_cpoint PointRep CPointRep {| pointRep := {| value := 42 |}; color := green |}, cp);
                    (Deep_bpoint PointRep CPointRep {| value := 42 |}, bp)]).
  { simpl. cancel. }
  { simpl. repeat (constructor; [ try (simpl; rep_lia) |]); try constructor. }
  simpl.*)

  (*sum*)
  forward_call (l, [(Deep_point _ _ (Init_PointRep 4) m1, p2); 
                    (Deep_point _ _ {| value := 42 |} m1, p1); 
                    (Deep_cpoint _ _ {| pointRep := {| value := 42 |}; color := green |} cm1, cp); 
                    (Deep_bpoint _ _ {| value := 42 |} bm1, bp)]). 
  { simpl. simpl map. simpl Points. cancel. }
  { simpl map; split.
    + repeat (constructor; [ try (simpl; rep_lia) |]); constructor.
    + unfold sum; simpl; rep_lia. }
  simpl. (*Indeed, 130: unfold sum; simpl.*) forward. cancel.
Qed.
End Test4.

Require Import VST.veric.initial_world.
Require Import VST.floyd.VSU.
Section VSU_DeepWrapperClient.
Variable M:MallocFreeAPD.
Variable DP: Pred (DeepPoint PointRep CPointRep).
Variable LIST: list val -> val -> mpred.
Variable LIST_NIL: emp |-- LIST nil nullval.

Definition CSpecs : funspecs := [(_makePoint_I1, DP_makePOINT_spec point _ _ DP M (*m1 Init_PointRep*)ptConstr1);
                                 (*(_makeBPoint_I1, DP_makeBPOINT_spec bpoint _ _ DP M (*bm1 Init_PointRep*)bptConstr1);*)
                                 (_makePoint_I2, DP_makePOINT_spec point _ _ DP M (*m1 Init_PointRep*)ptConstr1);
                                 (*(_makeCPoint_I2, DP_makeCPOINT_spec cpoint _ _ DP M (*cm1 Init_CPointRep*)cptConstr1)*)
                                 (_makeBPoint_I3, DP_makeBPOINT_spec bpoint _ _ DP M (*bm1 Init_PointRep*)bptConstr1);
                                 (_makeCPoint_I3, DP_makeCPOINT_spec cpoint _ _ DP M (*cm1 Init_CPointRep*)cptConstr1);
                                 (_makeCPoint_I4, DP_makeCPOINT_spec cpoint _ _ DP M (*cm1 Init_CPointRep*)cptConstr1)].

Definition DeepWrapperImports := CSpecs ++ MethodImports DP ++ 
           ASI_PointList (Tstruct _list noattr) point M LIST PointRep CPointRep DP _insert _map_set _map_bump _sum.

Definition DeepWrapperInternals := [ (_test3, test3_spec M); (_test4, test4_spec M)].

Definition DeepWrapperGprog: funspecs := DeepWrapperImports ++ DeepWrapperInternals.

Lemma verif_test3_common:semax_body Vprog DeepWrapperGprog f_test3 (_test3, test3_spec M).
Proof. start_function.
  forward_call (gv, 3). rep_lia. Intros p1. simpl.

  forward_call (*(CPt_sub _ _ _ _ _ _ _ _ _ _ _ _ _ _ JW2 CPointRep cm1 Init_CPointRep)*) (gv, 4, red). rep_lia. Intros cp1.

  forward_call (Deep_point PointRep CPointRep (Init_PointRep 3) m1, p1).
  forward_call (Deep_cpoint PointRep CPointRep (Init_CPointRep 4 red) cm1, cp1).
  {simpl; cancel. }
  forward_call (Deep_cpoint PointRep CPointRep (Init_CPointRep 4 red) cm1, cp1).
  { simpl. rep_lia. } 
  (*Variant1: don't simplify:
   forward_call (dp_bump PointRep CPointRep bm1 cm1
             (Deep_cpoint PointRep CPointRep (Init_CPointRep 4 red)), cp1, 5). rep_lia.
  forward_call (Init_CPointRep 5 red, cp1).
  { rewrite sepcon_assoc. apply sepcon_derives; [ apply derives_refl | cancel] . }
  simpl; forward; cancel. *)
(*  Opaque DP.*)
  (*Variant 2: simplify the semantic object cp1 before continuing*)simpl.
  forward_call (Deep_cpoint PointRep CPointRep {| pointRep := {| value := 5 |}; color := red |} cm1, cp1, 5). rep_lia.
  simpl.
  forward_call (Deep_cpoint PointRep CPointRep {| pointRep := {| value := 5 |}; color := red |} cm1, cp1).
  { simpl; trivial. }
  simpl; forward; cancel.
Qed.
Lemma verif_test4_common:semax_body Vprog DeepWrapperGprog f_test4 (_test4, test4_spec M).
Proof. start_function.
  forward.
  forward_call (gv, 1). simpl; rep_lia. Intros bp.
  sep_apply LIST_NIL. 

  forward_call (nullval, bp, @nil val, gv). Intros l.

  forward_call (gv, 2, green). rep_lia. Intros cp.

  forward_call (l, cp, [bp], gv). clear l. Intros l.

  (*map_bump*)
  forward_call (l, [(Deep_cpoint PointRep CPointRep (Init_CPointRep 2 green) cm1, cp); (Deep_bpoint PointRep CPointRep (Init_PointRep 1) bm1, bp)]).
  { simpl. cancel. }
  { simpl. repeat (constructor; [ try (simpl; rep_lia) |]); constructor. }
  simpl.
  
   (*GET bp*)
  forward_call (Deep_bpoint PointRep CPointRep {| value := 2 |} bm1, bp).
  { cancel. }
  simpl.

   (*GET cp*)
   forward_call (Deep_cpoint PointRep CPointRep {| pointRep := {| value := 3 |}; color := green |} cm1, cp).
  simpl.

  forward_call (gv, 3). simpl; rep_lia. Intros p1.

  forward_call (l, p1, [cp;bp], gv). clear l. Intros l.

  (*map_set*)
  forward_call (l, 42, [(Deep_point PointRep CPointRep (Init_PointRep 3) m1, p1); 
                       (Deep_cpoint PointRep CPointRep {| pointRep := {| value := 3 |}; color := green |} cm1, cp); 
                       (Deep_bpoint PointRep CPointRep {| value := 2 |} bm1, bp)]).
  { simpl. cancel. }
  { rep_lia. }
  simpl.

  forward_call (gv, 4). simpl; rep_lia. Intros p2.

  forward_call (l, p2, [p1;cp;bp], gv). clear l. Intros l.

  (*map_bump
  forward_call (l, [(Deep_point PointRep CPointRep (Init_PointRep 4), p2);
                    (Deep_point PointRep CPointRep {| value := 42 |}, p1);
                    (Deep_cpoint PointRep CPointRep {| pointRep := {| value := 42 |}; color := green |}, cp);
                    (Deep_bpoint PointRep CPointRep {| value := 42 |}, bp)]).
  { simpl. cancel. }
  { simpl. repeat (constructor; [ try (simpl; rep_lia) |]); try constructor. }
  simpl.*)

  (*sum*)
  forward_call (l, [(Deep_point _ _ (Init_PointRep 4) m1, p2); 
                    (Deep_point _ _ {| value := 42 |} m1, p1); 
                    (Deep_cpoint _ _ {| pointRep := {| value := 42 |}; color := green |} cm1, cp); 
                    (Deep_bpoint _ _ {| value := 42 |} bm1, bp)]). 
  { simpl. simpl map. simpl Points. cancel. }
  { simpl map; split.
    + repeat (constructor; [ try (simpl; rep_lia) |]); constructor.
    + unfold sum; simpl; rep_lia. }
  simpl. (*Indeed, 130: unfold sum; simpl.*) forward. cancel.
Qed.
  Definition DeepWrapperClient_Component: @Component NullExtension.Espec Vprog _ nil DeepWrapperImports
            prog (ASI_WrapperClient M _test3 _test4) emp DeepWrapperInternals.
  Proof. mkComponent_cautious.
     - solve_SF_internal verif_test3_common.
     - apply SF_internal_sound; eapply _SF_internal.
       + reflexivity.
       + repeat apply Forall_cons; try apply Forall_nil; try computable; reflexivity.
       + unfold var_sizes_ok; repeat constructor; try (simpl; rep_lia).
       + reflexivity.
       + apply verif_test4_common. 
   + eexists; split; [ LookupID | LookupB ].
  Qed.

  Definition DeepWrapperClient_VSU: @VSU NullExtension.Espec Vprog _ nil DeepWrapperImports
            prog (ASI_WrapperClient M _test3 _test4) emp.
  Proof. eexists; apply DeepWrapperClient_Component. Qed.
End VSU_DeepWrapperClient.