Require Import VST.floyd.proofauto.
Require Import ASI_malloc.
Require Import PositiveSubtypingTheory.
Require Import SimplePointModel.
Require Import SimpleObjspec.
Require Import SimplePoints_ASI.
Require Import SimpleClient.
Require Import ASI_SimpleClient.

Instance CompSpecs : compspecs. make_compspecs prog. Defined.

Definition Vprog : varspecs. mk_varspecs prog. Defined.

Section Test1.
Variable M: MallocFreeAPD. 

Definition ASI1 := firstn 2 (SimplePointASI CompSpecs M _makePoint_I1 _makeBPoint_I1 _makeCPoint_I1).
(*Test1 does not call makeCPoint*)

Lemma verif_test1:semax_body Vprog ASI1 f_test1 (_test1, test1_spec M).
Proof. start_function.
  forward_call (gv, 3). rep_lia. Intros p1.

  forward_call (gv, 4). rep_lia. Intros bp1.

  unfold Point. simpl. Intros P.

  rewrite prePoint_fold_unfold. Intros cso m; simpl.
  unfold SimpleObjspec.FldAt; Intros m'; simpl. apply JMeq_eq in H; subst m'.
  freeze [0;1] FR1. forward.
  unfold SimpleObjspec.MTable; Intros sh. unfold SimpleObjspec.funcptrs; simpl.
  Intros g g' s s'. apply JMeq_eq in H0; subst g'. apply JMeq_eq in H1; subst s'. forward.
  forward_call (Init_PointRep 3, p1).
  { assert (Frame = [FRZL FR1(*mem_mgr M gv;
             BPoint point bpoint bmethods _mtable _get _set _bump CompSpecs M DR1 PointRep bm1 (Init_PointRep 4, bp1)*)]);
    subst Frame; trivial. simpl.
    rewrite prePoint_fold_unfold. Exists cso m. unfold FldAt; Exists m; entailer!. cancel.
    eapply derives_trans; [ | apply now_later].
    unfold MTable. Exists sh; simpl. Exists g g s s. entailer!. }
  forward. 
  thaw FR1. deadvars!. clear cso.

  rewrite BPoint_fold_unfold. Intros cso BP bm; simpl.
  unfold SimpleObjspec.FldAt; Intros bm'; simpl. simpl in bm'; apply JMeq_eq in H0; subst bm'.
  (*replace_SEP 4 (field_at Ews bpoint [StructField _mtable] bm bp1). 
  { entailer. unfold field_at; simpl; entailer!. 2: apply derives_refl.
    apply FC_mtable_point_bpoint; trivial. }*)
  freeze [0;1] FR1. forward.
  unfold SimpleObjspec.MTable; Intros bsh. unfold SimpleObjspec.funcptrs; simpl.
  Intros bg bg' bs bs' bb bb'. apply JMeq_eq in H1; subst bg'.
     apply JMeq_eq in H2; subst bs'. apply JMeq_eq in H3; subst bb'. forward. forward. 
  (*freeze [0;2;5;6;7;10;11] FR2. replace_SEP 5 (). forward. forward.
  unfold SimpleObjspec.MTable; Intros bsh. unfold SimpleObjspec.funcptrs; simpl.
  Intros bg bg' bs bs' bb bb'. apply JMeq_eq in H1; subst bg'.
     apply JMeq_eq in H2; subst bs'. apply JMeq_eq in H3; subst bb'. forward.*)
  forward_call (Init_PointRep 4, bp1).
  { assert (Frame = [FRZL FR1(*mem_mgr M gv;
             BPoint point bpoint bmethods _mtable _get _set _bump CompSpecs M DR1 PointRep bm1 (Init_PointRep 4, bp1)*)]);
    subst Frame; trivial. simpl.
    rewrite preBPoint_fold_unfold. Exists cso bm. unfold FldAt; Exists bm; entailer!. cancel.
    eapply derives_trans; [ | apply now_later].
    unfold MTable. Exists bsh; simpl. Exists bg bg bs bs bb bb. entailer!. }
  forward.
  thaw FR1. deadvars!. clear. (* Pbm bm.*)

  rewrite preBPoint_fold_unfold. Intros cso bm; simpl.
  unfold SimpleObjspec.FldAt; Intros bm'; simpl. simpl in bm'; apply JMeq_eq in H; subst bm'.
  forward. forward.
  unfold SimpleObjspec.MTable; Intros bsh. unfold SimpleObjspec.funcptrs; simpl.
  Intros bg bg' bs bs' bb bb'. apply JMeq_eq in H0; subst bg'.
     apply JMeq_eq in H1; subst bs'. apply JMeq_eq in H2; subst bb'. forward.
  (*replace_SEP 4 (field_at Ews bpoint [StructField _mtable] bm bp1). 
  { entailer. unfold field_at; simpl; entailer!. 2: apply derives_refl.
    apply FC_mtable_point_bpoint; trivial. }*)
  forward_call (Init_PointRep 4, bp1).
  { assert (Frame = [mem_mgr M gv; prePoint point methods _mtable _get _set CompSpecs M PointRep m1 P
  (Init_PointRep 3, p1)(*
             BPoint point bpoint bmethods _mtable _get _set _bump CompSpecs M DR1 PointRep bm1 (Init_PointRep 4, bp1)*)]);
    subst Frame; trivial. simpl.
    rewrite preBPoint_fold_unfold. Exists cso bm. unfold FldAt; Exists bm; entailer!. cancel.
    eapply derives_trans; [ | apply now_later].
    unfold MTable. Exists bsh; simpl. Exists bg bg bs bs bb bb. entailer!. }
  { simpl; rep_lia. }
  deadvars!. clear. (* Pbm bm.*)
  
  rewrite preBPoint_fold_unfold. Intros cso bm; simpl.
  unfold SimpleObjspec.FldAt; Intros bm'; simpl. simpl in bm'; apply JMeq_eq in H; subst bm'.
  forward. forward.
  unfold SimpleObjspec.MTable; Intros bsh. unfold SimpleObjspec.funcptrs; simpl.
  Intros bg bg' bs bs' bb bb'. apply JMeq_eq in H0; subst bg'.
     apply JMeq_eq in H1; subst bs'. apply JMeq_eq in H2; subst bb'. forward.
  (*replace_SEP 4 (field_at Ews bpoint [StructField _mtable] bm bp1). 
  { entailer. unfold field_at; simpl; entailer!. 2: apply derives_refl.
    apply FC_mtable_point_bpoint; trivial. }*)
  forward_call ({|value:= 5|}, bp1).
  { assert (Frame = [mem_mgr M gv; prePoint point methods _mtable _get _set CompSpecs M PointRep m1 P
  (Init_PointRep 3, p1)(*
             BPoint point bpoint bmethods _mtable _get _set _bump CompSpecs M DR1 PointRep bm1 (Init_PointRep 4, bp1)*)]);
    subst Frame; trivial. simpl.
    rewrite preBPoint_fold_unfold. Exists cso bm. unfold FldAt; Exists bm; entailer!. cancel.
    eapply derives_trans; [ | apply now_later].
    unfold MTable. Exists bsh; simpl. Exists bg bg bs bs bb bb. entailer!. }
  clear. deadvars!.
  forward. forward. entailer!.
Qed.
End Test1.

Section Test2.
Variable M:MallocFreeAPD.

(*Definition ASI2 := firstn 2 (SimplePointASI CompSpecs M DR2 _makePoint_I2 _makeBPoint_I2 _makeCPoint_I2).*)
Definition ASI2 := firstn 1 (SimplePointASI CompSpecs M _makePoint_I4 _makeBPoint_I4 _makeCPoint_I4) ++
                   firstn 1 (skipn 1 (SimplePointASI CompSpecs M _makePoint_I3 _makeBPoint_I3 _makeCPoint_I3)).
(*Test2 does not call makeCPoint*)

(*Same proof script as for test1*)
Lemma verif_test2:semax_body Vprog ASI2 f_test2 (_test2, test2_spec M).
Proof. start_function.
  forward_call (gv, 3). rep_lia. Intros p1.

  forward_call (gv, 4). rep_lia. Intros bp1.

  freeze [0; 1] FR1.
  rewrite Point_fold_unfold. Intros cso P m; simpl.
  unfold SimpleObjspec.FldAt; Intros m'; simpl. simpl in m'; apply JMeq_eq in H; subst m'. forward.
  unfold SimpleObjspec.MTable; Intros sh. unfold SimpleObjspec.funcptrs; simpl.
  Intros g g' s s'. apply JMeq_eq in H0; subst g'.  apply JMeq_eq in H1; subst s'. forward.
  forward_call(Init_PointRep 3, p1).
  { assert (Frame = [FRZL FR1(*mem_mgr M gv;
             BPoint point bpoint bmethods _mtable _get _set _bump CompSpecs M DR1 PointRep bm1 (Init_PointRep 4, bp1)*)]);
    subst Frame; trivial. simpl.
    rewrite prePoint_fold_unfold. Exists cso m. unfold FldAt; Exists m; entailer!. cancel.
    eapply derives_trans; [ | apply now_later].
    unfold MTable. Exists sh; simpl. Exists g g s s. entailer!. }
  thaw FR1. deadvars!. clear.
  forward. 

  freeze [0; 1] FR1.
  rewrite BPoint_fold_unfold. Intros cso BP bm; simpl.
  unfold SimpleObjspec.FldAt; Intros bm'; simpl. simpl in bm'; apply JMeq_eq in H; subst bm'. forward. forward.
  unfold SimpleObjspec.MTable; Intros bsh. unfold SimpleObjspec.funcptrs; simpl.
  Intros bg bg' bs bs' bb bb'. apply JMeq_eq in H0; subst bg'.
     apply JMeq_eq in H1; subst bs'. apply JMeq_eq in H2; subst bb'. forward.
  forward_call (Init_PointRep 4, bp1).
  { assert (Frame = [FRZL FR1]);
    subst Frame; trivial. simpl.
    rewrite preBPoint_fold_unfold. Exists cso bm. unfold FldAt; Exists bm; entailer!. cancel.
    eapply derives_trans; [ | apply now_later].
    unfold MTable. Exists bsh; simpl. Exists bg bg bs bs bb bb. entailer!. }
  thaw FR1. deadvars!. clear.
  forward.

  freeze [1; 2] FR1.
  rewrite preBPoint_fold_unfold. Intros cso (*BP*) bm; simpl.
  unfold SimpleObjspec.FldAt; Intros bm'; simpl. simpl in bm'; apply JMeq_eq in H; subst bm'. forward. forward.
  unfold SimpleObjspec.MTable; Intros bsh. unfold SimpleObjspec.funcptrs; simpl.
  Intros bg bg' bs bs' bb bb'. apply JMeq_eq in H0; subst bg'.
     apply JMeq_eq in H1; subst bs'. apply JMeq_eq in H2; subst bb'. forward.
  forward_call (Init_PointRep 4, bp1).
  { assert (Frame = [FRZL FR1]);
    subst Frame; trivial. simpl.
    rewrite preBPoint_fold_unfold. Exists cso bm. unfold FldAt; Exists bm; entailer!. cancel.
    eapply derives_trans; [ | apply now_later].
    unfold MTable. Exists bsh; simpl. Exists bg bg bs bs bb bb. entailer!. }
  { simpl; rep_lia. }
  thaw FR1. deadvars!. clear.

  freeze [1; 2] FR1.
  rewrite preBPoint_fold_unfold. Intros cso (*BP*) bm; simpl.
  unfold SimpleObjspec.FldAt; Intros bm'; simpl. simpl in bm'; apply JMeq_eq in H; subst bm'. forward. forward.
  unfold SimpleObjspec.MTable; Intros bsh. unfold SimpleObjspec.funcptrs; simpl.
  Intros bg bg' bs bs' bb bb'. apply JMeq_eq in H0; subst bg'.
     apply JMeq_eq in H1; subst bs'. apply JMeq_eq in H2; subst bb'. forward.
  forward_call ({|value:=5|}, bp1).
  { assert (Frame = [FRZL FR1]);
    subst Frame; trivial. simpl.
    rewrite preBPoint_fold_unfold. Exists cso bm. unfold FldAt; Exists bm; entailer!. cancel.
    eapply derives_trans; [ | apply now_later].
    unfold MTable. Exists bsh; simpl. Exists bg bg bs bs bb bb. entailer!. }
  thaw FR1. deadvars!. clear.

  forward. forward. entailer!. 
Qed. 

End Test2.

Section Test12.
Variable M: MallocFreeAPD. 

Definition ASI12 := firstn 1 (SimplePointASI CompSpecs M _makePoint_I1 _makeBPoint_I1 _makeCPoint_I1)
                  ++ firstn 1 (skipn 1 (SimplePointASI CompSpecs M _makePoint_I3 _makeBPoint_I3 _makeCPoint_I3))
                  ++ firstn 1 (skipn 2 (SimplePointASI CompSpecs M _makePoint_I4 _makeBPoint_I4 _makeCPoint_I4)).

Lemma verif_test12:semax_body Vprog ASI12 f_test12 (_test12, test12_spec M).
Proof. start_function.
  forward_call (gv, 3). rep_lia. Intros p.
  forward_call (gv, 4). rep_lia. Intros bp.
  forward_call (gv, 5, red). rep_lia. Intros cp.

  freeze [0;1;2] FR1.
  rewrite Point_fold_unfold. Intros cso P m; simpl.
  unfold SimpleObjspec.FldAt; Intros m'; simpl. apply JMeq_eq in H; subst m'.
  forward.
  unfold SimpleObjspec.MTable; Intros sh. unfold SimpleObjspec.funcptrs; simpl.
  Intros g g' s s'. apply JMeq_eq in H0; subst g'. apply JMeq_eq in H1; subst s'. forward.
  forward_call (Init_PointRep 3, p).
  { assert (Frame = [FRZL FR1]);
    subst Frame; trivial. simpl.
    rewrite prePoint_fold_unfold. Exists cso m. unfold FldAt; Exists m; entailer!. cancel.
    eapply derives_trans; [ | apply now_later].
    unfold MTable. Exists sh; simpl. Exists g g s s. entailer!. }
  thaw FR1. deadvars!. clear.

  forward. 
  freeze [0;1;2] FR1.
  rewrite BPoint_fold_unfold. Intros cso BP m; simpl.
  unfold SimpleObjspec.FldAt; Intros m'; simpl. apply JMeq_eq in H; subst m'.
  forward.
  unfold SimpleObjspec.MTable; Intros sh. unfold SimpleObjspec.funcptrs; simpl.
  Intros g g' s s' b b'. apply JMeq_eq in H0; subst g'. apply JMeq_eq in H1; subst s'. apply JMeq_eq in H2; subst b'. 
  forward. forward.
  forward_call (Init_PointRep 4, bp).
  { assert (Frame = [FRZL FR1]);
    subst Frame; trivial. simpl.
    rewrite preBPoint_fold_unfold. Exists cso m. unfold FldAt; Exists m; entailer!. cancel.
    eapply derives_trans; [ | apply now_later].
    unfold MTable. Exists sh; simpl. Exists g g s s b b. entailer!. }
  thaw FR1. deadvars!. clear.

  forward. 
  freeze [1;2;3] FR1.
  rewrite preBPoint_fold_unfold. Intros cso m; simpl.
  unfold SimpleObjspec.FldAt; Intros m'; simpl. apply JMeq_eq in H; subst m'.
  forward.
  unfold SimpleObjspec.MTable; Intros sh. unfold SimpleObjspec.funcptrs; simpl.
  Intros g g' s s' b b'. apply JMeq_eq in H0; subst g'. apply JMeq_eq in H1; subst s'. apply JMeq_eq in H2; subst b'. 
  forward. forward.
  forward_call (Init_PointRep 4, bp).
  { assert (Frame = [FRZL FR1]);
    subst Frame; trivial. simpl.
    rewrite preBPoint_fold_unfold. Exists cso m. unfold FldAt; Exists m; entailer!. cancel.
    eapply derives_trans; [ | apply now_later].
    unfold MTable. Exists sh; simpl. Exists g g s s b b. entailer!. }
  { simpl; rep_lia. } 
  (*thaw FR1.*) deadvars!. clear.

  (*freeze [1;2;3] FR1.*)
  rewrite preBPoint_fold_unfold. Intros cso m; simpl.
  unfold SimpleObjspec.FldAt; Intros m'; simpl. apply JMeq_eq in H; subst m'.
  forward.
  unfold SimpleObjspec.MTable; Intros sh. unfold SimpleObjspec.funcptrs; simpl.
  Intros g g' s s' b b'. apply JMeq_eq in H0; subst g'. apply JMeq_eq in H1; subst s'. apply JMeq_eq in H2; subst b'. 
  forward. forward.
  forward_call ({|value:= 5|}, bp).
  { assert (Frame = [FRZL FR1]);
    subst Frame; trivial. simpl.
    rewrite preBPoint_fold_unfold. Exists cso m. unfold FldAt; Exists m; entailer!. cancel.
    eapply derives_trans; [ | apply now_later].
    unfold MTable. Exists sh; simpl. Exists g g s s b b. entailer!. }
  thaw FR1. deadvars!. clear.

  forward.

  freeze [0;1;2] FR1.
  rewrite CPoint_fold_unfold. Intros cso CP m; simpl.
  unfold SimpleObjspec.FldAt; Intros m'; simpl. apply JMeq_eq in H; subst m'.
  forward. forward.
  unfold SimpleObjspec.MTable; Intros sh. unfold SimpleObjspec.funcptrs; simpl.
  Intros g g' s s' b b' gC gC'. apply JMeq_eq in H0; subst g'. apply JMeq_eq in H1; subst s'.
  apply JMeq_eq in H2; subst b'. apply JMeq_eq in H3; subst gC'.
  forward.
  forward_call (Init_CPointRep 5 red, cp).
  { assert (Frame = [FRZL FR1]);
    subst Frame; trivial. simpl.
    rewrite preCPoint_fold_unfold. Exists cso m. unfold FldAt; Exists m; entailer!. cancel.
    eapply derives_trans; [ | apply now_later].
    unfold MTable. Exists sh; simpl. Exists g g s s b b gC gC. entailer!. }
  { simpl; rep_lia. }
  (*thaw FR1.*) deadvars!. clear. simpl.

(*  freeze [0;1;2] FR1.*)
  rewrite preCPoint_fold_unfold. Intros cso (*CP*) m; simpl.
  unfold SimpleObjspec.FldAt; Intros m'; simpl. apply JMeq_eq in H; subst m'.
  forward. forward.
  unfold SimpleObjspec.MTable; Intros sh. unfold SimpleObjspec.funcptrs; simpl.
  Intros g g' s s' b b' gC gC'. apply JMeq_eq in H0; subst g'. apply JMeq_eq in H1; subst s'.
  apply JMeq_eq in H2; subst b'. apply JMeq_eq in H3; subst gC'.
  forward.
  forward_call ({| pointRep := {| value := 6 |}; color := red |}, cp).
  { assert (Frame = [FRZL FR1]);
    subst Frame; trivial. simpl.
    rewrite preCPoint_fold_unfold. Exists cso m. unfold FldAt; Exists m; entailer!. cancel.
    eapply derives_trans; [ | apply now_later].
    unfold MTable. Exists sh; simpl. Exists g g s s b b gC gC. entailer!. }
  (*thaw FR1.*) deadvars!. clear. simpl.
  forward.

(*  freeze [0;1;2] FR1.*)
  rewrite preCPoint_fold_unfold. Intros cso (*CP*) m; simpl.
  unfold SimpleObjspec.FldAt; Intros m'; simpl. apply JMeq_eq in H; subst m'.
  forward. forward.
  unfold SimpleObjspec.MTable; Intros sh. unfold SimpleObjspec.funcptrs; simpl.
  Intros g g' s s' b b' gC gC'. apply JMeq_eq in H0; subst g'. apply JMeq_eq in H1; subst s'.
  apply JMeq_eq in H2; subst b'. apply JMeq_eq in H3; subst gC'.
  forward.
  forward_call ({| pointRep := {| value := 6 |}; color := red |}, cp).
  { assert (Frame = [FRZL FR1]);
    subst Frame; trivial. simpl.
    rewrite preCPoint_fold_unfold. Exists cso m. unfold FldAt; Exists m; entailer!. cancel.
    eapply derives_trans; [ | apply now_later].
    unfold MTable. Exists sh; simpl. Exists g g s s b b gC gC. entailer!. }
  thaw FR1. deadvars!. clear. simpl.
  forward. forward. cancel. (*

  gather_SEP 0 4 5 6 7 8 9 10.
  replace_SEP 0 (Point point methods _mtable _get _set CompSpecs M DR1 PointRep m1
     (Init_PointRep 3, p)).
  { entailer!. rewrite Point_fold_unfold. Exists P m; simpl; entailer!.
    unfold SimpleObjspec.FldAt, SimpleObjspec.MTable. Exists m sh; simpl; entailer!.
    Exists s g g s. entailer!. }
  clear.

  rewrite BPoint_fold_unfold. Intros BP bm; simpl.
  unfold SimpleObjspec.FldAt; Intros bm'; simpl. simpl in bm'; apply JMeq_eq in H; subst bm'.
  forward.
  unfold SimpleObjspec.MTable; Intros bsh. unfold SimpleObjspec.funcptrs; simpl.
  Intros bg bg' bs bs' bb bb'. apply JMeq_eq in H0; subst bg'.
     apply JMeq_eq in H1; subst bs'. apply JMeq_eq in H2; subst bb'. forward. forward. 
  forward_call. forward. deadvars!.
  (*Optionally, fold - but the next instruction is on the same object..
  gather_SEP 0 4 5 6 7 8 9 10. (*11 12 - apparently, the gather tactic does not allow this many arguments..*)
  gather_SEP 0 4 5.
  replace_SEP 0 (BPoint point bpoint bmethods _mtable _get _set _bump CompSpecs M DR2 PointRep bm1
     (Init_PointRep 4, bp)).
  { entailer!. rewrite BPoint_fold_unfold. Exists BP bm; simpl; entailer!.
    unfold SimpleObjspec.FldAt, SimpleObjspec.MTable. Exists bm bsh. simpl; entailer!.
    Exists bb bs bg. Exists bg bb bs. entailer!. }
   clear. *)


  forward. forward. forward. deadvars!.
  forward_call (Init_PointRep 4, bp). simpl; rep_lia. (*bumpable*) (*Could again fold here, but would again need to immediately unfold*)
  
  forward. forward. forward. forward_call. forward. deadvars!.
  gather_SEP 0 4 5 6 7 8 9 10. (*11 12 - apparently, the gather tactic does not allow this many arguments..*)
  gather_SEP 0 4 5.
  replace_SEP 0 (BPoint point bpoint bmethods _mtable _get _set _bump CompSpecs M DR2 PointRep bm1
     ({| value:= 5|}, bp)).
  { entailer!. rewrite BPoint_fold_unfold. Exists BP bm; simpl; entailer!.
    unfold SimpleObjspec.FldAt, SimpleObjspec.MTable. Exists bm bsh. simpl; entailer!.
    Exists bb bs bg. Exists bg bb bs. entailer!. }
  clear.

  rewrite CPoint_fold_unfold. Intros CP cm; simpl.
  unfold SimpleObjspec.FldAt; Intros cm'; simpl. simpl in cm'; apply JMeq_eq in H; subst cm'.
  forward.
  unfold SimpleObjspec.MTable; Intros csh. unfold SimpleObjspec.funcptrs; simpl.
  Intros cg cg' cs cs' cb cb' cGC cGC'. apply JMeq_eq in H0; subst cg'.
     apply JMeq_eq in H1; subst cs'. apply JMeq_eq in H2; subst cb'. apply JMeq_eq in H3; subst cGC'.
  forward. forward. forward_call (Init_CPointRep 5 red, cp).
  { simpl. rep_lia. }
  deadvars!. simpl.

  forward. forward. forward. forward_call. forward. deadvars!. simpl.

  forward. forward. forward. forward_call. forward. deadvars!.
  gather_SEP 0 4 5 6 7 8 9 10. (*11 12 - apparently, the gather tactic does not allow this many arguments..*)
  gather_SEP 0 4 5 6 7.
  replace_SEP 0 (CPoint point bpoint cpoint cmethods _mtable _get _set _bump _getC CompSpecs M DR2 CPointRep cm1
     ({| pointRep := {| value := 6 |}; color := red |}, cp)).
  { entailer!. rewrite CPoint_fold_unfold. Exists CP cm; simpl; entailer!.
    unfold SimpleObjspec.FldAt, SimpleObjspec.MTable. Exists cm csh. simpl; entailer!.
    Exists cGC cb cs cg. Exists cg cGC cb cs. entailer!. }
  clear.

  simpl; forward; cancel.*)
Qed.
End Test12.
Require Import VST.floyd.VSU.

Section VSU_SimpleClient.
Variable M: MallocFreeAPD.

Definition SimpleClient_Imports := 
  firstn 2 (SimplePointASI CompSpecs M _makePoint_I1 _makeBPoint_I1 _makeCPoint_I1) ++
  firstn 1 (SimplePointASI CompSpecs M _makePoint_I4 _makeBPoint_I4 _makeCPoint_I4) ++ 
  firstn 1 (skipn 2 (SimplePointASI CompSpecs M _makePoint_I4 _makeBPoint_I4 _makeCPoint_I4)) ++
  firstn 1 (skipn 1 (SimplePointASI CompSpecs M _makePoint_I3 _makeBPoint_I3 _makeCPoint_I3)).
Definition SimpleClient_Internals := [(_test1, test1_spec M); (_test2, test2_spec M); (_test12, test12_spec M)].
Definition SimpleClient_Gprog:funspecs := SimpleClient_Imports ++ SimpleClient_Internals.

  Lemma verif_test1_common:semax_body Vprog SimpleClient_Gprog f_test1 (_test1, test1_spec M).
  Proof. eapply VSU.semax_body_subsumespec. apply verif_test1.
  + intros i; red.
    rewrite 2 semax_prog.make_context_g_char, 2 initial_world.make_tycontext_s_find_id 
        by (apply compute_list_norepet_e; reflexivity). 
    remember (initial_world.find_id i (ASI1 M)) as d; symmetry in Heqd; destruct d.
    - specialize (initial_world.find_id_In_map_fst _ _ _ Heqd); intros.
      repeat (destruct H; [ simpl in H; subst i; inv Heqd; reflexivity |]). inv H.
    - remember (initial_world.find_id i SimpleClient_Gprog) as w; symmetry in Heqw; destruct w.
      * specialize (initial_world.find_id_In_map_fst _ _ _ Heqw); intros.
        repeat (destruct H; [ simpl in H; subst i; inv Heqd; reflexivity |]). inv H.
      * destruct (initial_world.find_id i Vprog); trivial.
  + intros i; red. remember (initial_world.find_id i (ASI1 M)) as d; symmetry in Heqd; destruct d; trivial.
    specialize (initial_world.find_id_In_map_fst _ _ _ Heqd); intros.
    repeat (destruct H; [ simpl in H; subst i; inv Heqd; eexists; split; [ reflexivity | apply seplog.funspec_sub_si_refl] |] ).
    inv H.
  Qed.
  Lemma verif_test2_common:semax_body Vprog SimpleClient_Gprog f_test2 (_test2, test2_spec M).
  Proof. eapply VSU.semax_body_subsumespec. apply verif_test2.
  + intros i; red.
    rewrite 2 semax_prog.make_context_g_char, 2 initial_world.make_tycontext_s_find_id 
        by (apply compute_list_norepet_e; reflexivity). 
    remember (initial_world.find_id i (ASI2 M)) as d; symmetry in Heqd; destruct d.
    - specialize (initial_world.find_id_In_map_fst _ _ _ Heqd); intros.
      repeat (destruct H; [ simpl in H; subst i; inv Heqd; reflexivity |]). inv H.
    - remember (initial_world.find_id i SimpleClient_Gprog) as w; symmetry in Heqw; destruct w.
      * specialize (initial_world.find_id_In_map_fst _ _ _ Heqw); intros.
        repeat (destruct H; [ simpl in H; subst i; inv Heqd; reflexivity |]). inv H.
      * destruct (initial_world.find_id i Vprog); trivial.
  + intros i; red. remember (initial_world.find_id i (ASI2 M)) as d; symmetry in Heqd; destruct d; trivial.
    specialize (initial_world.find_id_In_map_fst _ _ _ Heqd); intros.
    repeat (destruct H; [ simpl in H; subst i; inv Heqd; eexists; split; [ reflexivity | apply seplog.funspec_sub_si_refl] |] ).
    inv H.
  Qed.
  Lemma verif_test12_common:semax_body Vprog SimpleClient_Gprog f_test12 (_test12, test12_spec M).
  Proof. eapply VSU.semax_body_subsumespec. apply verif_test12.
  + intros i; red.
    rewrite 2 semax_prog.make_context_g_char, 2 initial_world.make_tycontext_s_find_id 
        by (apply compute_list_norepet_e; reflexivity). 
    remember (initial_world.find_id i (ASI12 M)) as d; symmetry in Heqd; destruct d.
    - specialize (initial_world.find_id_In_map_fst _ _ _ Heqd); intros.
      repeat (destruct H; [ simpl in H; subst i; inv Heqd; reflexivity |]). inv H.
    - remember  (initial_world.find_id i Vprog) as q; destruct q; trivial.
      symmetry in Heqq. specialize (initial_world.find_id_In_map_fst _ _ _ Heqq); intros.
      simpl in H; contradiction.
  + intros i; red. remember (initial_world.find_id i (ASI12 M)) as d; symmetry in Heqd; destruct d; trivial.
    specialize (initial_world.find_id_In_map_fst _ _ _ Heqd); intros.
    repeat (destruct H; [ simpl in H; subst i; inv Heqd; eexists; split; [ reflexivity | apply seplog.funspec_sub_si_refl] |] ).
    inv H.
  Qed.

  Definition SimpleClient_Component: @Component NullExtension.Espec Vprog _ nil SimpleClient_Imports prog 
             (ASI_SimpleClient M _test1 _test2 _test12) emp SimpleClient_Internals.
  Proof. mkComponent_cautious.
     - solve_SF_internal verif_test1_common.
     - solve_SF_internal verif_test2_common.
     - solve_SF_internal verif_test12_common.
  Qed.

  Definition SimpleClient_VSU: @VSU NullExtension.Espec Vprog _ nil SimpleClient_Imports prog 
             (ASI_SimpleClient M _test1 _test2 _test12) emp.
  Proof. eexists; apply SimpleClient_Component. Qed.

End VSU_SimpleClient.