Require Import VST.floyd.proofauto.
Require Import ASI_malloc.
Require Import PositiveSubtypingTheory.
Require Import SimplePointModel.
Require Import PositiveSubtypingPoints_ASI.

Require Import SimpleClient.
Instance CompSpecs : compspecs. make_compspecs prog. Defined.

Definition Vprog : varspecs. mk_varspecs prog. Defined.

Parameter M: MallocFreeAPD.

Definition test1_spec :=
  DECLARE _test1
  WITH gv:globals
  PRE []
  PROP () PARAMS () GLOBALS (gv) SEP (mem_mgr M gv)
  POST [ tint ]
  PROP () RETURN (Vint (Int.repr 12)) SEP (mem_mgr M gv; TT) (*objects left over as we don't have dealloc yet*).

(*Definition DR1 : dynRep := {| dyn_point := point; dyn_bpoint:=bpoint; dyn_cpoint:=cpoint |}.*)
Parameter DR1: dynRep. (*instantiated by linkig*)
Definition ASI1 := SimplePointASI CompSpecs M DR1 _makePoint_I1 _makeBPoint_I1 _makeCPoint_I1.

Lemma verif_test1:semax_body Vprog ASI1 f_test1 test1_spec.
Proof. start_function.
  forward_call (gv, 3). rep_lia. Intros p1.

  forward_call (gv, 4). rep_lia. Intros bp1.

  rewrite PointSub_fold_unfold. Intros P m; simpl.
  unfold SimpleObjspec.FldAt; Intros m'; simpl. apply JMeq_eq in H; subst m'.
  freeze [0;1;3] FR1. forward.
  unfold SimpleObjspec.MTable; Intros sh. unfold SimpleObjspec.funcptrs; simpl.
  Intros g g' s s'. apply JMeq_eq in H0; subst g'. apply JMeq_eq in H1; subst s'. forward.
  forward_call. forward. 
  thaw FR1. deadvars!.

  rewrite BPointSub_fold_unfold. Intros BP bm; simpl.
  unfold SimpleObjspec.FldAt; Intros bm'; simpl. simpl in bm'; apply JMeq_eq in H0; subst bm'.
  (*replace_SEP 4 (field_at Ews bpoint [StructField _mtable] bm bp1). 
  { entailer. unfold field_at; simpl; entailer!. 2: apply derives_refl.
    apply FC_mtable_point_bpoint; trivial. }*)
  forward.
  unfold SimpleObjspec.MTable; Intros bsh. unfold SimpleObjspec.funcptrs; simpl.
  Intros bg bg' bs bs' bb bb'. apply JMeq_eq in H1; subst bg'.
     apply JMeq_eq in H2; subst bs'. apply JMeq_eq in H3; subst bb'. forward. forward. 
  (*freeze [0;2;5;6;7;10;11] FR2. replace_SEP 5 (). forward. forward.
  unfold SimpleObjspec.MTable; Intros bsh. unfold SimpleObjspec.funcptrs; simpl.
  Intros bg bg' bs bs' bb bb'. apply JMeq_eq in H1; subst bg'.
     apply JMeq_eq in H2; subst bs'. apply JMeq_eq in H3; subst bb'. forward.*)
  forward_call. forward.

  forward. forward. forward. deadvars!.
  forward_call (Init_PointRep 4, bp1). simpl; rep_lia. (*bumpable*)
  
  forward. forward. forward. forward_call. forward. forward.
  (*+ rewrite ! Int.signed_repr by admit.
    apply prop_right. split3; admit. (*arith*)
  + entailer!. admit. (*arith*) *)entailer!.
Qed.

Definition test2_spec :=
  DECLARE _test2
  WITH gv:globals
  PRE []
  PROP () PARAMS () GLOBALS (gv) SEP (mem_mgr M gv)
  POST [ tint ]
  PROP () RETURN (Vint (Int.repr 12)) SEP (mem_mgr M gv; TT) (*objects left over as we don't have dealloc yet*).

Parameter DR2: dynRep. (*instantiated by linkig*)
Definition ASI2 := SimplePointASI CompSpecs M DR2 _makePoint_I2 _makeBPoint_I2 _makeCPoint_I2.

(*Same proof script as for test1*)
Lemma verif_test2:semax_body Vprog ASI2 f_test2 test2_spec.
Proof. start_function.
  forward_call (gv, 3). rep_lia. Intros p1.

  forward_call (gv, 4). rep_lia. Intros bp1.

  rewrite PointSub_fold_unfold. Intros P m; simpl.
  unfold SimpleObjspec.FldAt; Intros m'; simpl. simpl in m'; apply JMeq_eq in H; subst m'. forward.
  unfold SimpleObjspec.MTable; Intros sh. unfold SimpleObjspec.funcptrs; simpl.
  Intros g g' s s'. apply JMeq_eq in H0; subst g'.  apply JMeq_eq in H1; subst s'. forward.
  forward_call. forward.

  rewrite BPointSub_fold_unfold. Intros BP bm; simpl.
  unfold SimpleObjspec.FldAt; Intros bm'; simpl. simpl in bm'; apply JMeq_eq in H0; subst bm'. forward. forward.
  unfold SimpleObjspec.MTable; Intros bsh. unfold SimpleObjspec.funcptrs; simpl.
  Intros bg bg' bs bs' bb bb'. apply JMeq_eq in H1; subst bg'.
     apply JMeq_eq in H2; subst bs'. apply JMeq_eq in H3; subst bb'. forward.
  forward_call. forward.

  forward. forward. forward. deadvars!.
  forward_call (Init_PointRep 4, bp1). simpl; rep_lia. (*bumpable*)
  
  forward. forward. forward. forward_call. forward. forward. entailer!. 
Qed. 

Require Import ASI_Wrapper.

Definition test3_spec :=
  DECLARE _test3
  WITH gv:globals
  PRE []
  PROP () PARAMS () GLOBALS (gv) SEP (mem_mgr M gv)
  POST [ tint ]
  PROP () RETURN (Vint (Int.repr 9)) SEP (mem_mgr M gv; TT) (*objects left over as we don't have dealloc yet*).

Definition ASI3: funspecs := LL_ASI_Wrapper point bpoint cpoint M _ _mtable _get _set _bump _getC _GET _SET _BUMP _GETC PointRep CPointRep
                             ++ ASI1 ++ ASI2.

Lemma verif_test3:semax_body Vprog ASI3 f_test3 test3_spec.
Proof. start_function.
  forward_call (gv, 3). rep_lia. Intros p1.

  forward_call (gv, 4, red). rep_lia.
  Intros cp1.

  forward_call GETsubPoint_LL (m1, Init_PointRep 3, p1, DR1).
  forward_call GETsubCPoint_LL (cm1, Init_CPointRep 4 red, cp1, DR2).
  forward_call BUMPsubCPoint_LL (cm1, Init_CPointRep 4 red, cp1, DR2).
  { simpl. rep_lia. } 
  (*Variant1: don't simplify:
   forward_call SETsubCPoint (cm1, bump CPointRep1 cm1 (Init_CPointRep1 4 red), cp1, 5, point). rep_lia.
  forward_call (cm1,set CPointRep1 cm1 (bump CPointRep1 cm1 (Init_CPointRep1 4 red)) 5,
          cp1, point).
  forward. cancel.*)
  (*Variant 2: simplify the semantic object cp1 before continuing*)simpl.
  forward_call SETsubCPoint_LL (cm1, {| pointRep := {| value := 5 |}; color := red |}, cp1, 5, DR2). rep_lia.
  simpl.
  forward_call (cm1,{| pointRep := {| value := 5 |}; color := red |},
          cp1, DR2).
  forward. cancel.
Qed.