Require Import VST.floyd.proofauto.
Require Import ASI_malloc. 
Require Import SimplePointModel.
Require Import SimpleClasses.
Require Import SimplePoints_ASI.

Require Import ASI_HLWrapper.

Require Import ASI_WrapperClient.

Require Import WrapperClient.
Instance CompSpecs : compspecs. make_compspecs prog. Defined.

Definition Vprog : varspecs. mk_varspecs prog. Defined.

Ltac do_compute_expr_warning::=idtac.

Section Test3. 
Variable M:MallocFreeAPD.

Variable JW: JustifiedWrapperAPD point bpoint cpoint methods bmethods cmethods 
              _mtable _get _set _bump _getC _ M PointRep CPointRep .

Definition ConstructorSpecs1 :=
   ASI_HLWrapperConstructors point bpoint cpoint JW M PointRep CPointRep (*m1 bm1 cm1 Init_PointRep Init_CPointRep*)
      ptConstr1 bptConstr1 cptConstr1 _makePoint_I1 _makeBPoint_I1 _makeCPoint_I1.
(*
Definition ConstructorSpecs2 :=
   ASI_HLWrapperConstructors point bpoint cpoint JW M PointRep CPointRep m1 bm1 cm1 Init_PointRep Init_CPointRep _makePoint_I2 _makeBPoint_I2 _makeCPoint_I2.
*)
Definition ConstructorSpecs3 :=
   ASI_HLWrapperConstructors point bpoint cpoint JW M PointRep CPointRep (*m1 bm1 (*cm1*)cmBlueStatic Init_PointRep Init_CPointRep*)
   ptConstr1 bptConstr1 cptConstrBlueStatic _makePoint_I3 _makeBPoint_I3 _makeCPoint_I3.

Definition MethodImports := ASI_HLWrapperMethods point bpoint cpoint JW PointRep CPointRep _GET _SET _BUMP _GETC.

Definition Test3_GProg_HL := ConstructorSpecs1 ++ ConstructorSpecs3 ++ MethodImports.

Lemma verif_test3_HL:semax_body Vprog Test3_GProg_HL f_test3 (_test3, test3_spec M).
Proof. start_function.
  forward_call (gv, 3). rep_lia. Intros p1.

  forward_call (*(CPt_sub _ _ _ _ _ _ _ _ _ _ _ _ _ _ JW2 CPointRep cm1 Init_CPointRep)*) (gv, 4, red). rep_lia. Intros cp1.

  forward_call GETsubPoint (m1, Init_PointRep 3, p1).
  forward_call GETsubCPoint ((*cm1*)cmBlueStatic, Init_CPointRep 4 red, cp1).
  forward_call BUMPsubCPoint ((*cm1*)cmBlueStatic, Init_CPointRep 4 red, cp1).
  { simpl. rep_lia. } 
  (*Variant1: don't simplify:
   forward_call SETsubCPoint (cm1, bump _ cm1 (Init_CPointRep 4 red), cp1, 5). rep_lia.
  forward_call (cm1,set _ cm1 (bump _ cm1 (Init_CPointRep 4 red)) 5, cp1).
  forward. cancel. *)
  (*Variant 2: simplify the semantic object cp1 before continuing*)simpl.
  forward_call SETsubCPoint ((*cm1*)cmBlueStatic, {| pointRep := {| value := 5 |}; color := red |}, cp1, 5).
  { rewrite sepcon_assoc. apply sepcon_derives. apply derives_refl. cancel. }
  rep_lia.
  simpl.
  forward_call ((*cm1*)cmBlueStatic,{| pointRep := {| value := 5 |}; color := blue(*red*) |}, cp1).
  { rewrite sepcon_assoc. apply sepcon_derives. apply derives_refl. cancel. }
  forward. cancel.
Qed.

End Test3.