Require Import VST.floyd.proofauto.
Require Import VST.floyd.VSU.
Require Import VST.veric.initial_world.

Require Import malloc.
Require Import mmap0.
Require Import MM_prog.
Require Import ASI_malloc.
Require Import ASI_mmap0.
Require Import VSU_malloc_definitions.
Require Import VSU_malloc.
Require Import VSU_mmap0.

Instance mm_cs : compspecs. make_compspecs mm_prog. Defined.

Definition mm_Vprog:varspecs. mk_varspecs mm_prog. Defined.

(*MF_ASI has different order (TODO: change VSULink tactic so that
  imports need not be list equality but can be extensional equality*)
Definition mm_Imports:funspecs := nil.

(*This def exposes mmap Definition mm_Exports:funspecs := G_merge Mmap0_ASI (Malloc_ASI (ForgetR R_APD)).*)
Definition mm_Exports:funspecs := Malloc_ASI (ForgetR R_APD) _malloc _free.

Definition MM_VSU: @VSU NullExtension.Espec mm_Vprog mm_cs SYS
                   mm_Imports mm_prog mm_Exports (mem_mgr (ForgetR R_APD)).
Proof.
  eapply VSU_Exports_sub.
  + VSULink_tac MM0_VSU MF_VSU.
    extensionality gv; simpl. rewrite emp_sepcon; trivial.
  + LNR_tac.
  + intros ? ? ?. simpl in H. 
    repeat (if_tac in H; [ subst; eexists; split; [reflexivity 
                                                  | inv H; apply funspec_sub_refl] |]);
    congruence.
Qed.

Definition MM_CanVSU: @CanonicalVSU NullExtension.Espec mm_Vprog mm_cs SYS
                      mm_Imports mm_prog mm_Exports (mem_mgr (ForgetR R_APD)).
Proof. apply (VSU_to_CanonicalVSU MM_VSU). Qed.

(*The resource-related interface needs to include mmap0, so let's do the ususal G_merge*)
Definition mm_R_Exports:funspecs := G_merge (Mmap0_ASI _mmap0 _munmap) (Malloc_R_ASI R_APD _pre_fill _try_pre_fill _malloc _free).
(*Too narrow for the client main_R.c: Definition mm_R_Exports:funspecs := Malloc_R_ASI R_APD.*)

Definition MM_R_VSU: @VSU NullExtension.Espec mm_Vprog mm_cs SYS
                          mm_Imports mm_prog mm_R_Exports
                          (malloc_sep.mem_mgr_R malloc_lemmas.emptyResvec).
Proof.
  eapply VSU_Exports_sub.
  + VSULink_tac MM0_VSU MF_R_VSU.
    extensionality gv; simpl. rewrite emp_sepcon; trivial.
  + LNR_tac.
  + intros ? ? ?. simpl in H. 
    repeat (if_tac in H; [ subst; eexists; split; [reflexivity 
                                                  | inv H; apply funspec_sub_refl] |]);
    congruence.
Qed.

Definition MM_R_CanVSU: @CanonicalVSU NullExtension.Espec mm_Vprog mm_cs SYS
                        mm_Imports mm_prog mm_R_Exports
                        (malloc_sep.mem_mgr_R malloc_lemmas.emptyResvec).
Proof. apply (VSU_to_CanonicalVSU MM_R_VSU). Qed.
