Require Import VST.floyd.proofauto.
Require Import ASI_malloc. (*For MallocFreeAPD.*)
Require Import ASI_SimpleClient.
Require Import ASI_WrapperClient.
Require Import main.

(*We verify the body of main abstractly in M, OP and SP.
  We just provide the semax_body s
Require Import ASI_SimpleClienttatement, no VSU.
  The spec of main is not VST standard spec, but a variant
  that can be instantiated to contain the appropriate initialization
  predidates, given suitable implementations (ie VSUs) of the code modules
  and the library.*)
Section MAIN_Verif.
  Variable M: MallocFreeAPD.
  (*Specification of "module-instantiated main" - we permit an arbitrary G here too.*)
  Definition main_inst_spec G:=
  DECLARE _main
  WITH gv: globals
  PRE [ ]
    PROP ()
    PARAMS () GLOBALS (gv)
    SEP (fold_right (fun g p => g gv * p) emp G; has_ext tt)
  POST[ tint ]
    PROP()
    LOCAL(temp ret_temp (Vint (Int.repr (42+9+130)))) (*Different result then other directories, due to color change in SET-I4*)
    SEP((*mem_mgr M gv; *)TT;has_ext tt).

  Definition MainImports := ASI_SimpleClient M _test1 _test2 _test12(* _test4*)
                         ++ ASI_WrapperClient M _test3 _test4. 

  Definition MainInitPred: list (globals -> mpred) := nil.
  Definition maininstspec := (main_inst_spec [mem_mgr M]).

  (*Definition main_internal_specs: funspecs := [mainspec (*M*)].*)

  Definition MainVprog : varspecs. mk_varspecs main.prog. Defined.
  Definition MainGprog:funspecs := MainImports(* ++ main_internal_specs*).

  Instance MainCompSpecs : compspecs. make_compspecs main.prog. Defined.
  Lemma body_main: semax_body MainVprog MainGprog f_main maininstspec.
  Proof.
  start_function. simpl; Intros.
  forward_call.
  forward_call.
  forward_call.
  forward_call.
  forward_call.
  forward. simpl. cancel.
  Qed.

End MAIN_Verif.