Require Import VST.floyd.proofauto.
Require Import SimplePointModel.

Section DeepPoints.

Variable T CT:Type.

Variant DeepPoint:=
  Deep_point: (*forall T, *)T -> PointM T -> DeepPoint
| Deep_bpoint: (*forall T, *)T -> BPointM T -> DeepPoint
| Deep_cpoint: (*forall CT, *)CT -> CPointM CT -> DeepPoint.

Definition dp_get (d:DeepPoint):Z := match d with
    Deep_point (*_*) t pm => get _ pm t
  | Deep_bpoint (*_*) t bm => get _ bm t
  | Deep_cpoint (*_*) t cm => get _ cm t
  end.

Definition dp_set (d:DeepPoint) (i:Z) : DeepPoint :=
  match d with
    Deep_point (*_*) t  pm => Deep_point (*_*) (set _ pm t i) pm
  | Deep_bpoint (*_*) t bm => Deep_bpoint (*_*) (set _ bm t i) bm
  | Deep_cpoint (*_*) t cm => Deep_cpoint (*_*) (set _ cm t i) cm
  end.

Definition dp_bumpable (d:DeepPoint) :=
  match d with
    Deep_point (*_*) t pm => False
  | Deep_bpoint (*_*) t bm => bumpable _ bm t
  | Deep_cpoint (*_*) t cm => bumpable _ cm t
  end.
Definition dp_bump (d:DeepPoint) : DeepPoint :=
  match d with
    Deep_point (*_*) t pm => Deep_point (*_*) t (*vacuous*) pm
  | Deep_bpoint (*_*) t bm => Deep_bpoint (*_*) (bump _ bm t) bm
  | Deep_cpoint (*_*) t cm => Deep_cpoint (*_*) (bump _ cm t) cm
  end.

Definition dp_colored (d:DeepPoint): Prop := match d with
  | Deep_cpoint (*_*) t cm => True
  | _ => False
end.
Definition dp_getc (d:DeepPoint):Z := match d with
    Deep_point (*_*) t pm => 0 (*vacuous*)
  | Deep_bpoint (*_*) t bm => 0 (*vacuous*)
  | Deep_cpoint (*_*) t cm => (color_encoding _ cm (getC _ cm t))
  end.

End DeepPoints.