Require Import VST.floyd.proofauto.

Variant DeepObj (M:Type -> Type) T:Type:= 
  DpObj:forall (m: M T) (t:T), DeepObj M T.
(*Definition DeepObj (M:Type -> Type):= forall T (m: M T), Type.*)


Require Import SimplePointModel.

Section DeepPoints.

Definition Dpoint := DeepObj PointM.
Definition DBpoint:= DeepObj BPointM.
Definition DCpoint:= DeepObj CPointM.

Variable T CT:Type.
Variant DeepPoint:Type :=
  Deep_point: Dpoint T -> DeepPoint
| Deep_bpoint: DBpoint T -> DeepPoint
| Deep_cpoint: DCpoint CT -> DeepPoint.

Definition dp_get (d:DeepPoint):Z.
destruct d.
+ destruct d. apply (get _ m t).
+ destruct d. apply (get _ m t).
+ destruct d. apply (get _ m t).
Defined.

Variant DeepPoint':=
  Deep_point': T -> PointM T -> DeepPoint'
| Deep_bpoint': T -> BPointM T -> DeepPoint'
| Deep_cpoint': CT -> CPointM CT -> DeepPoint'.

Definition dp_get' (d:DeepPoint'):Z := match d with
    Deep_point' t pm => get _ pm t
  | Deep_bpoint' t bm => get _ bm t
  | Deep_cpoint' t cm => get _ cm t
  end.

Variable t:T.
Variable m:PointM T. Check Dpoint.
Definition d: Dpoint T := (DpObj _ _ t m). (*Check dp_get.: DeepPoint -> Z*)
Goal dp_get (Deep_point _ (DpObj _ _ t m))= dp_get' (Deep_point' t m).

Definition dp_set (d:DeepPoint) (i:Z) : DeepPoint :=
  match d with
    Deep_point t pm => Deep_point (set T pm t i) pm
  | Deep_bpoint t bm => Deep_bpoint (set T bm t i) bm
  | Deep_cpoint t cm => Deep_cpoint (set CT cm t i) cm
  end.
Definition dp_bumpable (d:DeepPoint) :=
  match d with
    Deep_point t pm => False
  | Deep_bpoint t bm => bumpable _ bm t
  | Deep_cpoint t cm => bumpable _ cm t
  end.
Definition dp_bump (d:DeepPoint) : DeepPoint :=
  match d with
    Deep_point t pm => Deep_point t (*vacuous*) pm
  | Deep_bpoint t bm => Deep_bpoint (bump _ bm t) bm
  | Deep_cpoint t cm => Deep_cpoint (bump _ cm t) cm
  end.
Definition dp_getc (d:DeepPoint):Z := match d with
    Deep_point t pm => 0 (*vacuous*)
  | Deep_bpoint t bm => 0 (*vacuous*)
  | Deep_cpoint t cm => (color_encoding _ cm (getC _ cm t))
  end.*)

End DeepPoints.