Require Import VST.floyd.proofauto.
Require Import VST.floyd.linking.
Require Import SimplePoint_I1.
Require Import SimplePoint_I2.

Time   (* 0.6s + 0.04s + 27 = 34s*)
Definition prog_I1_I2_step1 : Clight.program :=
  ltac:(NEW_LINK_PROGS.do_link_progs_step1_unfold SimplePoint_I1.prog SimplePoint_I2.prog).

Time  (* 0.076 seconds *)
Definition prog_I1_I2 : Clight.program :=
  ltac:(NEW_LINK_PROGS.do_link_progs_step2  prog_I1_I2_step1).

Require Import SimplePoint_I3.
Definition prog_I123_step1 : Clight.program :=
  ltac:(NEW_LINK_PROGS.do_link_progs_step1_unfold prog_I1_I2 SimplePoint_I3.prog).

Time  (* 0.076 seconds *)
Definition prog_I123 : Clight.program :=
  ltac:(NEW_LINK_PROGS.do_link_progs_step2  prog_I123_step1).

Require Import SimpleClient.

Time
Definition with_client_step1 : Clight.program :=
  ltac:(NEW_LINK_PROGS.do_link_progs_step1_unfold prog_I123 SimpleClient.prog).
(*4.8 + 4.5 + 27 = 43*)

Definition with_client : Clight.program :=
  ltac:(NEW_LINK_PROGS.do_link_progs_step2 with_client_step1).

Require Import Wrapper. 
Time
Definition with_wrapper_step1 : Clight.program :=
  ltac:(NEW_LINK_PROGS.do_link_progs_step1_unfold with_client Wrapper.prog).
(*5 + 4.4 + 30.9 = 47*)

Definition with_wrapper : Clight.program :=
  ltac:(NEW_LINK_PROGS.do_link_progs_step2 with_wrapper_step1).

Require Import PointList. 
Time
Definition with_pointlist_step1 : Clight.program :=
  ltac:(NEW_LINK_PROGS.do_link_progs_step1_unfold with_wrapper PointList.prog).
(*5.6 + 4.9 + 41 = 59*)

Definition with_pointlist : Clight.program :=
  ltac:(NEW_LINK_PROGS.do_link_progs_step2 with_pointlist_step1).

Require Import WrapperClient. 
Time
Definition with_wrapperclient_step1 : Clight.program :=
  ltac:(NEW_LINK_PROGS.do_link_progs_step1_unfold with_pointlist WrapperClient.prog).
(*5.7 + 4.9 + 40 = 58*)

Definition with_wrapperclient : Clight.program :=
  ltac:(NEW_LINK_PROGS.do_link_progs_step2 with_wrapperclient_step1).

Require Import surelyMalloc. 
Time
Definition with_sm_step1 : Clight.program :=
  ltac:(NEW_LINK_PROGS.do_link_progs_step1_unfold with_wrapperclient surelyMalloc.prog).
(*5.1 + 4.2 + 29 = 44*)

Definition application_prog : Clight.program :=
  ltac:(NEW_LINK_PROGS.do_link_progs_step2 with_sm_step1).

Require Import MMlib_prog.
Definition applib_step1 : Clight.program :=
  ltac:(NEW_LINK_PROGS.do_link_progs_step1_unfold mmlib_prog application_prog).
(*18+14+43*)
Definition applib : Clight.program :=
  ltac:(NEW_LINK_PROGS.do_link_progs_step2 applib_step1).

Require Import main.
Definition withmain_step1 : Clight.program :=
  ltac:(NEW_LINK_PROGS.do_link_progs_step1_unfold applib main.prog).
(*10+9+36*)
Definition withmain : Clight.program :=
  ltac:(NEW_LINK_PROGS.do_link_progs_step2 withmain_step1).

Instance p12_cs : compspecs. make_compspecs  prog_I1_I2. Defined.
Instance p123_cs : compspecs. make_compspecs  prog_I123. Defined.
Instance with_client_cs: compspecs. make_compspecs with_client. Defined.
Instance with_wrapper_cs: compspecs. make_compspecs with_wrapper. Defined.
Instance with_wrapperclient_cs: compspecs. make_compspecs with_wrapperclient. Defined.
Instance with_pointlist_cs: compspecs. make_compspecs with_pointlist. Defined.
Instance application_cs: compspecs. make_compspecs application_prog. Defined.
Instance applib_cs: compspecs. make_compspecs applib. Defined.
Instance with_main_cs: compspecs. make_compspecs withmain. Defined.

Definition p12_Vprog:varspecs. mk_varspecs prog_I1_I2. Defined.
Definition p123_Vprog:varspecs. mk_varspecs prog_I123. Defined.
Definition with_client_Vprog: varspecs. mk_varspecs with_client. Defined.
Definition with_wrapper_Vprog: varspecs. mk_varspecs with_wrapper. Defined.
Definition with_wrapperclient_Vprog: varspecs. mk_varspecs with_wrapperclient. Defined.
Definition with_pointlist_Vprog: varspecs. mk_varspecs with_pointlist. Defined.
Definition application_Vprog: varspecs. mk_varspecs application_prog. Defined.
Definition applib_Vprog: varspecs. mk_varspecs applib. Defined.
Definition with_main_Vprog: varspecs. mk_varspecs withmain. Defined.

