Require Import VST.floyd.proofauto.
Require Import PositiveSubtypingPoints_ASI.
Require Import ASI_malloc.
Require Import SimpleClient.

Instance CompSpecs : compspecs. make_compspecs prog. Defined.

Notation point := (Tstruct _point noattr). 
(*Notation bpoint := (Tstruct _bpoint noattr). 
Notation cpoint1 := (Tstruct _cpoint_I1 noattr). 

Notation point2:= (Tstruct _point_I2 noattr). 
Notation bpoint2 := (Tstruct _bpoint_I2 noattr). 
Notation cpoint2 := (Tstruct _cpoint_I2 noattr). *)

Notation methods := (Tstruct _methods noattr).
Notation bmethods := (Tstruct _bmethods noattr).
Notation cmethods := (Tstruct _cmethods noattr).

Definition Vprog : varspecs. mk_varspecs prog. Defined.

Parameter M: MallocFreeAPD.

Definition test1_spec :=
  DECLARE _test1
  WITH gv:globals
  PRE []
  PROP () PARAMS () GLOBALS (gv) SEP (mem_mgr M gv)
  POST [ tint ]
  PROP () RETURN (Vint (Int.repr 12)) SEP (mem_mgr M gv; TT) (*objects left over as we don't have dealloc yet*).

Parameter Rep1 CRep1:Type.
Parameter PointM1: PointM Rep1.
Parameter BPointM1: BPointM Rep1.
Parameter CPointM1: CPointM CRep1.
Parameter init1: Z -> Rep1.
Parameter initCol1: Z -> Color -> CRep1.

Definition ASI1 := PointASI _ M Rep1 CRep1 _mtable _get _set _bump _getC
  point point point point methods bmethods cmethods PointM1 BPointM1 CPointM1
  init1 initCol1 _makePoint_I1 _makeBPoint_I1 _makeCPoint_I1.

Parameter Rep2 CRep2:Type.
Parameter PointM2: PointM Rep2.
Parameter BPointM2: BPointM Rep2.
Parameter CPointM2: CPointM CRep2.
Parameter init2: Z -> Rep2.
Parameter initCol2: Z -> Color -> CRep2.
Definition ASI2 := PointASI _ M Rep2 CRep2 _mtable _get _set _bump _getC
  point point point point methods bmethods cmethods PointM2 BPointM2 CPointM2
  init2 initCol2 _makePoint_I2 _makeBPoint_I2 _makeCPoint_I2.

(*Definition Gprog := ASI1++ASI2.*)
Lemma verif_test1:semax_body Vprog ASI1 f_test1 test1_spec.
Proof. start_function.
  forward_call (gv, 3). rep_lia. Intros p1.

  forward_call (gv, 4). rep_lia. Intros bp1.

  rewrite Point_fold_unfold. Intros P m; simpl.
  unfold SimpleObjspec.FldAt; Intros m'; simpl. simpl in m'; apply JMeq_eq in H; subst. forward.
  unfold SimpleObjspec.MTable; Intros sh. unfold SimpleObjspec.funcptrs; simpl.
  Intros g g' s s'. apply JMeq_eq in H0; subst g'.  apply JMeq_eq in H1; subst s'. forward.
  forward_call. forward.

  rewrite BPoint_fold_unfold. Intros BP bm; simpl.
  unfold SimpleObjspec.FldAt; Intros bm'; simpl. simpl in bm'; apply JMeq_eq in H0; subst. forward. forward.
  unfold SimpleObjspec.MTable; Intros bsh. unfold SimpleObjspec.funcptrs; simpl.
  Intros bg bg' bs bs' bb bb'. apply JMeq_eq in H1; subst bg'.
     apply JMeq_eq in H2; subst bs'. apply JMeq_eq in H3; subst bb'. forward.
  forward_call. forward.

  forward. forward. forward. deadvars!.  forward_call (init1 4, bp1). admit. (*bumpable*)
  
  forward. forward. forward. forward_call. forward. forward.
  + rewrite ! Int.signed_repr by admit.
    apply prop_right. split3; admit. (*arith*)
  + entailer!. admit. (*arith*) 
Admitted.  

(*Axioms validated at end of PositiveSubtypingPoints_VSU2.v*)
Parameter bumpable2: bumpable Rep2 BPointM2 (init2 4).
Parameter get_init2: forall i, get Rep2 PointM2 (init2 i) = i.
Parameter get_Binit2: forall i, get Rep2 BPointM2 (init2 i) = i.
Parameter get_bump2: forall i, get Rep2 BPointM2 (bump Rep2 BPointM2 (init2 i)) = i+1.

Definition test2_spec :=
  DECLARE _test2
  WITH gv:globals
  PRE []
  PROP () PARAMS () GLOBALS (gv) SEP (mem_mgr M gv)
  POST [ tint ]
  PROP () RETURN (Vint (Int.repr 12)) SEP (mem_mgr M gv; TT) (*objects left over as we don't have dealloc yet*).

Lemma verif_test2:semax_body Vprog ASI2 f_test2 test2_spec.
Proof. start_function.
  forward_call (gv, 3). rep_lia. Intros p1.

  forward_call (gv, 4). rep_lia. Intros bp1.

  rewrite Point_fold_unfold. Intros P m; simpl.
  unfold SimpleObjspec.FldAt; Intros m'; simpl. simpl in m'; apply JMeq_eq in H; subst. forward.
  unfold SimpleObjspec.MTable; Intros sh. unfold SimpleObjspec.funcptrs; simpl.
  Intros g g' s s'. apply JMeq_eq in H0; subst g'.  apply JMeq_eq in H1; subst s'. forward.
  forward_call. forward.

  rewrite BPoint_fold_unfold. Intros BP bm; simpl.
  unfold SimpleObjspec.FldAt; Intros bm'; simpl. simpl in bm'; apply JMeq_eq in H0; subst. forward. forward.
  unfold SimpleObjspec.MTable; Intros bsh. unfold SimpleObjspec.funcptrs; simpl.
  Intros bg bg' bs bs' bb bb'. apply JMeq_eq in H1; subst bg'.
     apply JMeq_eq in H2; subst bs'. apply JMeq_eq in H3; subst bb'. forward.
  forward_call. forward.

  forward. forward. forward. deadvars!.  forward_call (init2 4, bp1). apply bumpable2.
  
  forward. forward. forward. forward_call. forward. forward.
  + rewrite ! get_bump2. rewrite ! get_init2. rewrite ! get_Binit2. rewrite ! Int.signed_repr.
    apply prop_right. rep_lia. rep_lia. rep_lia. rep_lia. rep_lia.
  + entailer!. rewrite ! get_bump2. rewrite ! get_init2. rewrite ! get_Binit2. trivial. 
Qed. 

Section SPECS.
Variable T:Type.
(*Variable M:MallocFreeAPD.*)

Definition GET_spec :=
  DECLARE _GET
  WITH PM: PointM T, r:T, p:val, cl:type
  PRE [ tptr point]
  PROP () PARAMS (p) GLOBALS () SEP (Point point M T _ _mtable _get _set methods point PM (r,p))
  POST [ tint ]
  PROP () RETURN (Vint (Int.repr (get _ PM r))) SEP (Point point M T _ _mtable _get _set methods point PM (r,p)).

Lemma verif_GET:semax_body Vprog nil f_GET GET_spec.
Proof.
 start_function.
 rewrite Point_fold_unfold. Intros P m; simpl.
  unfold SimpleObjspec.FldAt; Intros m'; simpl. simpl in m'. apply JMeq_eq in H; subst. forward.
  unfold SimpleObjspec.MTable; Intros sh. unfold SimpleObjspec.funcptrs; simpl.
  Intros g g' s s'. apply JMeq_eq in H0; subst g'.  apply JMeq_eq in H1; subst s'. forward.
  forward_call. forward.
 rewrite Point_fold_unfold. Exists P m'; simpl. entailer!.
 unfold SimpleObjspec.FldAt. Exists m'; simpl. entailer!.
  unfold SimpleObjspec.MTable. Exists sh. unfold SimpleObjspec.funcptrs; simpl.
  Exists g g s s. entailer!.
Qed.
 
Definition SET_spec :=
  DECLARE _SET
  WITH PM: PointM T, r:T, p:val, i: Z, cl:type
  PRE [ tptr point, tint]
  PROP (Int.min_signed <= i <= Int.max_signed) PARAMS (p; Vint(Int.repr i)) GLOBALS ()
  SEP (Point point M T _ _mtable _get _set methods point PM (r,p))
  POST [ tvoid ]
  PROP () RETURN () SEP (Point point M T _ _mtable _get _set methods point PM (set _ PM r i,p)).

Lemma verif_SET:semax_body Vprog nil f_SET SET_spec.
Proof.
 start_function. rename H into BND.
 rewrite Point_fold_unfold. Intros P m; simpl.
  unfold SimpleObjspec.FldAt; Intros m'; simpl. simpl in m'. apply JMeq_eq in H; subst. forward.
  unfold SimpleObjspec.MTable; Intros sh. unfold SimpleObjspec.funcptrs; simpl.
  Intros g g' s s'. apply JMeq_eq in H0; subst g'.  apply JMeq_eq in H1; subst s'. forward.
  forward_call (r,p,i). forward.
 rewrite Point_fold_unfold. Exists P m'; simpl. entailer!.
 unfold SimpleObjspec.FldAt. Exists m'; simpl. entailer!.
  unfold SimpleObjspec.MTable. Exists sh. unfold SimpleObjspec.funcptrs; simpl.
  Exists g g s s. entailer!.
Qed. 

Definition BUMP_spec :=
  DECLARE _BUMP
  WITH BPM: BPointM T, r:T, p:val, cl:type
  PRE [ tptr point]
  PROP (bumpable T BPM r) PARAMS (p) GLOBALS ()
  SEP (BPoint point M T _ _mtable _get _set _bump bmethods point BPM (r,p))
  POST [ tvoid ]
  PROP () RETURN () SEP (BPoint point M T _ _mtable _get _set _bump bmethods point BPM (bump _ BPM r,p)).

Lemma verif_BUMP:semax_body Vprog nil f_BUMP BUMP_spec.
Proof.
 start_function. rename H into BUMPABLE.
 rewrite BPoint_fold_unfold. Intros BP m; simpl.
  unfold SimpleObjspec.FldAt; Intros m'; simpl. simpl in m'. apply JMeq_eq in H; subst. forward.
  unfold SimpleObjspec.MTable; Intros sh. unfold SimpleObjspec.funcptrs; simpl.
  Intros g g' s s' b b'. apply JMeq_eq in H0; subst g'.  apply JMeq_eq in H1; subst s'.
  apply JMeq_eq in H2; subst b'. forward. forward.
  forward_call (r,p). forward.
 rewrite BPoint_fold_unfold. Exists BP m'; simpl. entailer!.
 unfold SimpleObjspec.FldAt. Exists m'; simpl. entailer!.
  unfold SimpleObjspec.MTable. Exists sh. unfold SimpleObjspec.funcptrs; simpl.
  Exists g g s s b b. entailer!.
Qed.

Definition GETC_spec :=
  DECLARE _GETC
  WITH CPM: CPointM T, r:T, p:val, cl:type
  PRE [ tptr point]
  PROP () PARAMS (p) GLOBALS ()
  SEP (CPoint point M T _ _mtable _get _set _bump _getC cmethods point CPM (r,p))
  POST [ tint ]
  PROP () RETURN (Vint (Int.repr (color_encoding _ CPM (getC _ CPM r)))) 
          SEP (CPoint point M T _ _mtable _get _set _bump _getC cmethods point CPM (r,p)).

Lemma verif_GETC:semax_body Vprog nil f_GETC GETC_spec.
Proof.
 start_function.
 rewrite CPoint_fold_unfold. Intros CP m; simpl.
  unfold SimpleObjspec.FldAt; Intros m'; simpl. simpl in m'. apply JMeq_eq in H; subst. forward.
  unfold SimpleObjspec.MTable; Intros sh. unfold SimpleObjspec.funcptrs; simpl.
  Intros g g' s s' b b' gC gC'. apply JMeq_eq in H0; subst g'.  apply JMeq_eq in H1; subst s'.
  apply JMeq_eq in H2; subst b'. apply JMeq_eq in H3; subst gC'. forward. forward.
  forward_call (r,p). forward.
 rewrite CPoint_fold_unfold. Exists CP m'; simpl. entailer!.
 unfold SimpleObjspec.FldAt. Exists m'; simpl. entailer!.
  unfold SimpleObjspec.MTable. Exists sh. unfold SimpleObjspec.funcptrs; simpl.
  Exists g g s s b b gC gC. entailer!.
Qed. 

End SPECS.

Definition test3_spec :=
  DECLARE _test3
  WITH gv:globals
  PRE []
  PROP () PARAMS () GLOBALS (gv) SEP (mem_mgr M gv)
  POST [ tint ]
  PROP () RETURN (Vint (Int.repr 9)) SEP (mem_mgr M gv; TT) (*objects left over as we don't have dealloc yet*).


Definition ASI3 := [(_GET, binary_intersection' (snd (GET_spec Rep1)) (snd (GET_spec Rep2)) (eq_refl _)(eq_refl _) ); 
                    SET_spec Rep1; BUMP_spec Rep1; GETC_spec Rep1] ++ ASI1 ++ ASI2.
(*                    makePoint_spec point M T _ _mtable _get _set methods point MyPoint MyInit].
Parameter MyPoint: PointM T.
Parameter MyInit: Z -> T.
Check (makePoint_spec point M T _ _mtable _get _set methods point MyPoint MyInit).*)

Lemma GET_sub1: funspec_sub (binary_intersection' (snd (GET_spec Rep1)) (snd (GET_spec Rep2)) (eq_refl _)(eq_refl _))
                           (snd (GET_spec Rep1)).
Proof. apply binary_intersection'_sub. Qed.
Lemma GET_sub2: funspec_sub (binary_intersection' (snd (GET_spec Rep1)) (snd (GET_spec Rep2)) (eq_refl _)(eq_refl _))
                           (snd (GET_spec Rep2)).
Proof. apply binary_intersection'_sub. Qed.

Parameter BLUE: color_encoding CRep2 CPointM2 blue=2.
Require Import PositiveSubtypingTheory.
Parameter SubTP2: PosSubT CRep2 Rep2.
Lemma verif_test3:semax_body Vprog ASI3 f_test3 test3_spec.
Proof. start_function.
  forward_call (gv, 3). rep_lia. Intros p1.

  forward_call (gv, 4, blue). 2: rep_lia. rewrite BLUE. entailer!. Intros cp1.

  forward_call GET_sub1 (PointM1, init1 3, p1, point).
  forward_call GET_sub2 (PointM2, project _ _ SubTP2 (initCol2 4 blue), cp1, point).
  { 

  rewrite Point_fold_unfold. Intros P m; simpl.
  unfold SimpleObjspec.FldAt; Intros m'; simpl. simpl in m'; apply JMeq_eq in H; subst. forward.
  unfold SimpleObjspec.MTable; Intros sh. unfold SimpleObjspec.funcptrs; simpl.
  Intros g g' s s'. apply JMeq_eq in H0; subst g'.  apply JMeq_eq in H1; subst s'. forward.
  forward_call. forward.

  rewrite BPoint_fold_unfold. Intros BP bm; simpl.
  unfold SimpleObjspec.FldAt; Intros bm'; simpl. simpl in bm'; apply JMeq_eq in H0; subst. forward. forward.
  unfold SimpleObjspec.MTable; Intros bsh. unfold SimpleObjspec.funcptrs; simpl.
  Intros bg bg' bs bs' bb bb'. apply JMeq_eq in H1; subst bg'.
     apply JMeq_eq in H2; subst bs'. apply JMeq_eq in H3; subst bb'. forward.
  forward_call. forward.

  forward. forward. forward. deadvars!.  forward_call (init2 4, bp1). apply bumpable2.
  
  forward. forward. forward. forward_call. forward. forward.
  + rewrite ! get_bump2. rewrite ! get_init2. rewrite ! get_Binit2. rewrite ! Int.signed_repr.
    apply prop_right. rep_lia. rep_lia. rep_lia. rep_lia. rep_lia.
  + entailer!. rewrite ! get_bump2. rewrite ! get_init2. rewrite ! get_Binit2. trivial. 
Qed. 

forward.
 
  { entailer.

     = [(_makePoint_I1,
        makePoint_spec point M Rep1 CompSpecs
          _mtable _get _set methods point1
          PointM1 init1)]
     : list (ident * funspec)

Instance CompSpecs : compspecs. make_compspecs prog. Defined.

Notation point := (Tstruct _point noattr).

Notation point1:= (Tstruct _point_I1 noattr). 
Notation bpoint1 := (Tstruct _bpoint_I1 noattr). 
Notation cpoint1 := (Tstruct _cpoint_I1 noattr). 

Notation point2:= (Tstruct _point_I2 noattr). 
Notation bpoint2 := (Tstruct _bpoint_I2 noattr). 
Notation cpoint2 := (Tstruct _cpoint_I2 noattr). 

Notation methods := (Tstruct _methods noattr).
Notation bmethods := (Tstruct _bmethods noattr).
Notation cmethods := (Tstruct _cmethods noattr).

Definition Vprog : varspecs. mk_varspecs prog. Defined.

Parameter M: MallocFreeAPD.

Definition test1_spec :=
  DECLARE _test1
  WITH gv:globals
  PRE []
  PROP () PARAMS () GLOBALS (gv) SEP (mem_mgr M gv)
  POST [ tint ]
  PROP () RETURN (Vint (Int.repr 12)) SEP (mem_mgr M gv).

Parameter Rep1 CRep1:Type.
Parameter PointM1: PointM Rep1.
Parameter BPointM1: BPointM Rep1.
Parameter CPointM1: CPointM CRep1.
Parameter init1: Z -> Rep1.
Parameter initCol1: Z -> Color -> CRep1.

Definition ASI1 := PointASI _ M Rep1 CRep1 _mtable _get _set _bump _getC
  point point1 bpoint1 cpoint1 methods bmethods cmethods PointM1 BPointM1 CPointM1
  init1 initCol1 _makePoint_I1 _makeBPoint_I1 _makeCPoint_I1.

Parameter Rep2 CRep2:Type.
Parameter PointM2: PointM Rep2.
Parameter BPointM2: BPointM Rep2.
Parameter CPointM2: CPointM CRep2.
Parameter init2: Z -> Rep2.
Parameter initCol2: Z -> Color -> CRep2.
Definition ASI2 := PointASI _ M Rep2 CRep2 _mtable _get _set _bump _getC
  point point2 bpoint2 cpoint2 methods bmethods cmethods PointM2 BPointM2 CPointM2
  init2 initCol2 _makePoint_I2 _makeBPoint_I2 _makeCPoint_I2.

Definition Gprog := ASI1++ASI2.
Eval simpl in (firstn 1 ASI1).
Lemma verif_test1:semax_body Vprog Gprog f_test1 test1_spec.
Proof. start_function.
  forward_call (gv, 3). rep_lia. Intros p1.

  forward_call (gv, 4). rep_lia. Intros bp1.
  rewrite Point_fold_unfold. Intros P m; simpl.
  unfold SimpleObjspec.FldAt; Intros m'; simpl. simpl in m'.  apply JMeq_eq in H. forward.

     = [(_makePoint_I1,
        makePoint_spec point M Rep1 CompSpecs
          _mtable _get _set methods point1
          PointM1 init1)]
     : list (ident * funspec)
