Require Import VST.floyd.proofauto.
Require Import VST.floyd.VSU.
Require Import VST.floyd.library. (*for body_lemma_of_funspec *)
Require Import stdlib.
Require Import spec_stdlib.

Instance StdlibCompSpecs : compspecs. make_compspecs stdlib.prog. Defined.

Section Stdlib_VSU.
(*Variable M: MallocFreeAPD.*)
(*Parameter body_malloc:
 forall {Espec: OracleKind} {cs: compspecs} ,
   VST.floyd.library.body_lemma_of_funspec EF_malloc (snd (malloc_spec' M)).
(*
Parameter body_free:
 forall {Espec: OracleKind} {cs: compspecs} ,
   VST.floyd.library.body_lemma_of_funspec EF_free (snd (free_spec' M)).*)
*)
Parameter body_exit:
 forall {Espec: OracleKind},
  VST.floyd.library.body_lemma_of_funspec
    (EF_external "exit" (mksignature (AST.Tint :: nil) AST.Tvoid cc_default))
    (snd (exit_spec)).

Definition placeholder_spec :=
 DECLARE _placeholder
 WITH u: unit
 PRE [ ]
   PROP (False) PARAMS () GLOBALS () SEP()
 POST [ tint ]
   PROP() LOCAL() SEP().
(*
  Definition MF_ASI: funspecs := Malloc_ASI M.

  Definition MF_imported_specs:funspecs :=  nil.

  Definition MF_internal_specs: funspecs := placeholder_spec::MF_ASI.

  Definition MFVprog : varspecs. mk_varspecs prog. Defined.
  Definition MFGprog: funspecs := MF_imported_specs ++ MF_internal_specs.
*)
Lemma body_placeholder G: semax_body (*MFVprog MFGprog*)nil G f_placeholder placeholder_spec.
Proof.
start_function.
contradiction.
Qed.

  Definition StdlibVprog : varspecs. mk_varspecs prog. Defined.

  (*Since stdlib.h includes malloc.h, malloc and free are external functions of stdlib,
   so need to be imports here)*)
  Variable M: MallocFreeAPD.
  Definition StdlibComponent: @Component NullExtension.Espec StdlibVprog StdlibCompSpecs 
      [exit_spec] (Malloc_ASI M _malloc _free) prog [exit_spec] emp [exit_spec;placeholder_spec].
  Proof. 
    mkComponent. 
    - clear; solve_SF_external (@body_exit NullExtension.Espec).
    - clear; solve_SF_internal body_placeholder.
  Qed.

  Definition Stdlib_VSU: @VSU NullExtension.Espec StdlibVprog StdlibCompSpecs 
      [exit_spec] (Malloc_ASI M _malloc _free) prog [exit_spec] emp.
  Proof. eexists; apply StdlibComponent. Qed.

  Definition Stdlib_CanVSU: @CanonicalVSU NullExtension.Espec StdlibVprog StdlibCompSpecs 
      [exit_spec] (Malloc_ASI M _malloc _free) prog [exit_spec] emp.
  Proof. apply (VSU_to_CanonicalVSU Stdlib_VSU). Qed.

End Stdlib_VSU.

Require Import MM_prog.
Require Import MMlib_prog.
Require Import VSU_MM.

Section MMlib_VSU.
(*Variable M: MallocFreeAPD.*)

Instance mmlib_cs : compspecs. make_compspecs mmlib_prog. Defined.

Definition mmlib_Vprog:varspecs. mk_varspecs mmlib_prog. Defined.

Definition mmlib_Imports:funspecs := nil.

Definition M:=(ForgetR VSU_malloc_definitions.R_APD).

Definition mmlib_Exports:funspecs := exit_spec::Malloc_ASI M _malloc _free.

Definition MMlib_VSU: @VSU NullExtension.Espec mmlib_Vprog mmlib_cs 
                   (exit_spec::VSU_mmap0.SYS (*ie exit, munmap*))
                   mmlib_Imports mmlib_prog mmlib_Exports (mem_mgr M).
Proof.
  VSULink_tac (Stdlib_VSU M) MM_VSU.
  extensionality gv; simpl. rewrite emp_sepcon; trivial.
Qed.

Definition MMlib_CanVSU: @CanonicalVSU NullExtension.Espec mmlib_Vprog mmlib_cs 
                   (exit_spec::VSU_mmap0.SYS (*ie exit, munmap*))
                   mmlib_Imports mmlib_prog mmlib_Exports (mem_mgr M).
Proof. apply (VSU_to_CanonicalVSU MMlib_VSU). Qed.
End MMlib_VSU.
