Require Import VST.floyd.proofauto.
Require Import PositiveSubtypingTheory.
Require Import spec_stdlib. (*needed for mem_mgr*)
Require Import SimpleObjspec.
Require Import PositiveSubtypingPoints_ASI.

Require Import SimplePoint_I2.
Instance CompSpecs : compspecs. make_compspecs prog. Defined.

Notation point := (Tstruct _point noattr).
Notation methods := (Tstruct _methods noattr).

Notation bpoint := (Tstruct _bpoint_I2 noattr). (*specialization to I2 undesirable externaly, but ok in class hierarchy*)
Notation bmethods := (Tstruct _bmethods noattr).

Notation cpoint := (Tstruct _cpoint_I2 noattr). (*specialization to I2 undesirable*)
Notation cmethods := (Tstruct _cmethods noattr).

Record PointRep2 := { imin:bool; nvalue : Z }.

Definition m2: PointM PointRep2 := {|
  get := fun s : PointRep2 => if imin s then Int.min_signed else nvalue s;
  set := fun (_ : PointRep2) (i : Z) => 
      {| imin := Z.eqb i Int.min_signed; nvalue := -i |} |}.

Notation point2:= (Tstruct _point_I2 noattr). 
Check Val.of_bool.
Definition Pred2: Pred PointRep2 := fun xp =>(*
   (EX minint z, 
   match xp with (i, p) =>
   !!((minint=Vtrue /\ imin i = Int.min_signed) \/
     (minint=Vfalse /\ Int.min_signed < i <= Int.max_signed /\ z=Vint (Int.repr (-i)))) &&
    (@field_at CompSpecs Ews point2 [StructField _intmin] minint p * 
     @field_at CompSpecs Ews point2 [StructField _negvalue] z p *
     spacer Ews 5 8 p)
   end)%logic.*)
 (field_at Ews point2 [StructField _intmin] (Val.of_bool (imin (fst xp))) (snd xp) *
 if imin (fst xp) 
 then field_at_ Ews point2 [StructField _negvalue] (snd xp)
 else !!(Int.min_signed < - nvalue (fst xp) <= Int.max_signed)
        && field_at Ews point2 [StructField _negvalue] (Vint (Int.repr (nvalue (fst xp)))) (snd xp))%logic.

Lemma dataverif_get: semax_body nil nil f_get_I2 (_get_I2, get_spec point _ m2 Pred2).
Proof.
  start_function. unfold Pred2; simpl; Intros. forward.
  { entailer!. red. red in H0. destruct x as [imin nv]. simpl. simpl in H0.
    unfold Val.of_bool in H0. unfold Val.of_bool.
    destruct imin; simpl. right; trivial. left; trivial. }
Parameter QQ: environ -> mpred.
  unfold Val.of_bool. remember (imin x). destruct b.
  + forward_if (PROP ( )
        LOCAL (temp _t'1 (Vint (Int.sub (Int.neg (Int.repr 2147483647)) (Int.repr 1))); temp _p p)
        SEP (field_at Ews point2 [StructField _intmin] Vtrue p; field_at_ Ews point2 [StructField _negvalue] p)). 
    forward. entailer!. inv H.
    forward. unfold Pred2. simpl. rewrite <- Heqb. entailer!.
  + forward_if (PROP ( )
         LOCAL (temp _t'1 (Vint (Int.neg (Int.repr (nvalue x))));
                temp _t'3 (Vint (Int.repr (nvalue x))); (*temp _t'2 Vfalse; *)
                temp _p p)
         SEP (field_at Ews point2 [StructField _intmin] Vfalse p;
              field_at Ews point2 [StructField _negvalue] (Vint (Int.repr (nvalue x))) p)).
    lia.
    Intros.
    forward. forward.
    { entailer!. rewrite Int.signed_zero. lia. }
    entailer.
    forward. unfold Pred2; simpl. rewrite <- Heqb. entailer!.
     trivial. rewrite Int.signed_repr. trivial. red in H4. exploit H4. congruence. intros. red in H5. simpl in H5.
      unfold POSTCONDITION, abbreviate. (fun (z:environ) => emp).
Qed.
Lemma dataverif_set: semax_body nil nil f_set_I2 (_set_I2, set_spec point _ m1 Pred1).
Proof.
  start_function. unfold Pred1; simpl. forward. forward.
Qed.

Definition bm1: BPointM PointRep2 := {|
  PointM_of_BPointM := m1;
  bump := fun s => {| value := value s + 1 |};
  bumpable := fun s => Int.min_signed <= value s < Int.max_signed
|}.

Notation bpoint1:= (Tstruct _bpoint_I2 noattr). 
Definition BPred1: Pred PointRep2 := fun xp =>
 field_at Ews bpoint1 [StructField _value] (Vint (Int.repr (value (fst xp)))) (snd xp).
Lemma dataverif_bump: semax_body nil nil f_bump_I2 (_bump_I2, bump_spec point _ bm1 BPred1). (*Pred1*)
Proof.
  start_function. unfold BPred1; simpl. (*
  assert_PROP (field_compatible point1 [StructField _value] p) as FC by entailer!.
  replace_SEP 0 (field_at Ews bpoint1 [StructField _value] (Vint (Int.repr (value x))) p).
  { entailer. unfold field_at. simpl. entailer!. clear - FC. destruct FC as [? [? [? [? ?]]]].
    destruct p; inv H. split3; try reflexivity.
    split3. 
    + red; simpl. red in H1; simpl in H1; trivial.
    + clear - H2. inv H2. inv H. eapply align_compatible_rec_Tstruct; try eassumption.
      clear H4. inv H1. simpl. f_equal. f_equal. admit. } *)
  forward. forward.
  { entailer!. red in H. simpl in H.
    do 2 rewrite Int.signed_repr by rep_lia. rep_lia. }
  forward. (*unfold Pred1; simpl.
  unfold field_at; simpl; entailer!.*)
Qed.

Record CPointRep2 := { pointR1 :> PointRep2; color : Color }.

Lemma PosSubT_CpointRep2_PointRep2: PosSubT CPointRep2 PointRep2.
Proof. 
apply (Build_PosSubT _ _ pointR1 (fun c r => {| pointR1 := r; color := color c |})); intros; simpl; trivial.
destruct s; simpl; trivial.
Qed.

Definition mycolor_encoding (C:Color) :Z :=
  match C with blue => 1 | red => 2 | green => 3 end.

Definition cm1: CPointM CPointRep2 :=
{| BPointM_of_CPointM := {|
                      PointM_of_BPointM := {|
                                           get := fun s : CPointRep2 => value s;
                                           set := fun (s : CPointRep2) (i : Z) => {| pointR1 := {| value := i |}; color := color s |} |};
                      bump := fun s => {| pointR1 := {| value := (value s)  + 1 |}; color := color s |};
                      bumpable := fun s => Int.min_signed <= value s < Int.max_signed |};
   getC := fun s : CPointRep2 => color s;
   color_encoding := mycolor_encoding |}.

Notation cpoint1:= (Tstruct _cpoint_I2 noattr).

Definition CPred1: Pred CPointRep2 := fun xp =>
 (field_at Ews cpoint1 [StructField _value] (Vint (Int.repr (value (fst xp)))) (snd xp) *
  field_at Ews cpoint1 [StructField _color] (Vint (Int.repr (color_encoding _ cm1 (color (fst xp))))) (snd xp))%logic.

Lemma dataverif_getC: semax_body nil nil f_getC_I2 (_getC_I2, getC_spec point _ cm1 CPred1).
Proof.
  start_function. unfold CPred1; simpl; Intros.
  forward. forward.
Qed.
(*
(*
Lemma Point_fold_unfold' PM dynclass x:
  Point PM dynclass x = EX P:Pred T, 
                        P x * malloc_token M Ews (*point*)dynclass (snd x) *
                        (EX m : val, !! isptr m && FldAt T (*point*)dynclass _mtable m x *
                                     MTable T M methods [_get; _set] m
                                     [get_spec T PM; set_spec T PM] P).
Proof. unfold Point. apply obj_mpred_fold_unfold'. Qed. 

(*In particular, we can unfold a cpoint that actually has the Cpoint methods as if it were a point;
  we get ONLY methods get & set, with the specs from CM *)
Lemma CPoint_fold_unfold_as_Point' (CM: CPointM T) x:
  Point CM cpoint x = EX P, P x * malloc_token M Ews cpoint (snd x) *
                    (EX m : val, !! isptr m && FldAt T cpoint _mtable m x *
                                 MTable T M methods [_get; _set] m
                                 [get_spec T CM; set_spec T CM] P).
Proof. apply Point_fold_unfold'. Qed.*)

(*What concept does the following predicate correspond to?*)
Definition ExPoint (PM: PointM T): Pred T:= EX dynclass, Point PM dynclass. (*maybe this idea can be used to model interfaces?
We're abstracting over the representation (struct). This might work if we also abstract existentially over _get_I2; _set_I2.
Investigate further once we have verifications of I2 and I2.

Also consider the variant EX moreIDs, moreSpecs
obj_mpred T CompSpecs M _mtable dynclass methods ([ _get_I2; _set_I2]++moreIDs) ([get_spec _ PM; set_spec _ PM] ++ moreSpecs).
for all the constructions above, ie allow additional methods in subitems (subtypes, subclasses???).
And relate to 
Definition Class (M: Type -> Type) (R:Type): Type :=
  forall S, PosSubT S R -> M S.
from line 1 of this file*)

 
Lemma BPoint_fold_unfold' BPM dynclass x:
  BPoint BPM dynclass x = EX P : Pred T,
                        P x * malloc_token M Ews (*bpoint*)dynclass (snd x) *
                        (EX m : val, !! isptr m && FldAt T (*bpoint*)dynclass _mtable m x *
                                     MTable T M bmethods [_get; _set; _bump] m
                                     [get_spec T BPM; set_spec T BPM; bump_spec T BPM] P).
Proof. unfold BPoint. apply obj_mpred_fold_unfold'. Qed.

Lemma CPoint_fold_unfold' CPM dynclass x:
  CPoint CPM dynclass x = EX P : Pred T,
                        P x * malloc_token M Ews (*cpoint*)dynclass (snd x) *
                        (EX m : val, !! isptr m && FldAt T (*cpoint*)dynclass _mtable m x *
                                     MTable T M cmethods [_get; _set; _bump; _getC] m
                                     [get_spec T CPM; set_spec T CPM; bump_spec T CPM; getC_spec T CPM] P).
Proof. unfold CPoint. apply obj_mpred_fold_unfold'. Qed. 
End PointPreds.

Section PointPreds.
Variable M:MallocFreeAPD.

Variable T: Type.

Definition OLDPoint (PM: PointM T): Pred T:= 
  obj_mpred T CompSpecs M _mtable point methods [ _get; _set] [get_spec _ PM; set_spec _ PM].

Definition OLDBPoint (BPM: BPointM T): Pred T:= 
  obj_mpred T CompSpecs M _mtable bpoint bmethods
           [ _get; _set; _bump]
           [get_spec _ BPM; set_spec _ BPM; bump_spec _ BPM].

Definition OLDCPoint (CPM: CPointM T): Pred T:=
  obj_mpred T CompSpecs M _mtable cpoint cmethods 
            [ _get; _set; _bump; _getC]
            [get_spec _ CPM; set_spec _ CPM; bump_spec _ CPM; getC_spec _ CPM].
(*Maybe reorganize order of arguments of obj_mpred so that method and struct identifiers come after the specs?*)

Lemma OLDPoint_fold_unfold PM:
  OLDPoint PM = fun x => EX P : Pred T,
                        P x * malloc_token M Ews point (snd x) *
                        (EX m : val, !! isptr m && FldAt T point _mtable m x *
                                     MTable T M methods [_get; _set] m
                                     [get_spec T PM; set_spec T PM] P).
Proof. unfold OLDPoint. apply obj_mpred_fold_unfold. Qed. 
Lemma OLDPoint_fold_unfold' PM x:
  OLDPoint PM x = EX P, P x * malloc_token M Ews point (snd x) *
                    (EX m : val, !! isptr m && FldAt T point _mtable m x *
                                 MTable T M methods [_get; _set] m
                                 [get_spec T PM; set_spec T PM] P).
Proof. unfold OLDPoint. apply obj_mpred_fold_unfold'. Qed. 

(*In particular, we can unfold a point that actually has the Cpoint methods as if it were a point;
  we get ONLY methods get & set, with the specs from CM - dynamic binding.
WELL use of point (rather than cpoint in terms for malloc_token and FldAt may be wrong!!!*)
Lemma OLDCPoint_fold_unfold_as_Point' (CM: CPointM T) x:
  OLDPoint CM x = EX P, P x * malloc_token M Ews point (snd x) *
                    (EX m : val, !! isptr m && FldAt T point _mtable m x *
                                 MTable T M methods [_get; _set] m
                                 [get_spec T CM; set_spec T CM] P).
Proof. apply OLDPoint_fold_unfold'. Qed.

Lemma OLDBPoint_fold_unfold BPM:
  OLDBPoint BPM = fun x => EX P : Pred T,
                        P x * malloc_token M Ews bpoint (snd x) *
                        (EX m : val, !! isptr m && FldAt T bpoint _mtable m x *
                                     MTable T M bmethods [_get; _set; _bump] m
                                     [get_spec T BPM; set_spec T BPM; bump_spec T BPM] P).
Proof. unfold OLDBPoint. apply obj_mpred_fold_unfold. Qed.
 
Lemma OLDBPoint_fold_unfold' BPM x:
  OLDBPoint BPM x = EX P : Pred T,
                        P x * malloc_token M Ews bpoint (snd x) *
                        (EX m : val, !! isptr m && FldAt T bpoint _mtable m x *
                                     MTable T M bmethods [_get; _set; _bump] m
                                     [get_spec T BPM; set_spec T BPM; bump_spec T BPM] P).
Proof. unfold OLDBPoint. apply obj_mpred_fold_unfold'. Qed.

Lemma OLDCPoint_fold_unfold CPM:
  OLDCPoint CPM = fun x => EX P : Pred T,
                        P x * malloc_token M Ews cpoint (snd x) *
                        (EX m : val, !! isptr m && FldAt T cpoint _mtable m x *
                                     MTable T M cmethods [_get; _set; _bump; _getC] m
                                     [get_spec T CPM; set_spec T CPM; bump_spec T CPM; getC_spec T CPM] P).
Proof. unfold OLDCPoint. apply obj_mpred_fold_unfold. Qed.
 
Lemma OLDCPoint_fold_unfold' CPM x:
  OLDCPoint CPM x = EX P : Pred T,
                        P x * malloc_token M Ews cpoint (snd x) *
                        (EX m : val, !! isptr m && FldAt T cpoint _mtable m x *
                                     MTable T M cmethods [_get; _set; _bump; _getC] m
                                     [get_spec T CPM; set_spec T CPM; bump_spec T CPM; getC_spec T CPM] P).
Proof. unfold OLDCPoint. apply obj_mpred_fold_unfold'. Qed. 
End PointPreds.
*)
(*We might be tempted to verify get wrt the following spec:*)
Check get_spec. Check Point.
Lemma objverif_get M: semax_body nil nil f_get_I2 (_get_I2, get_spec point _ m1 (Point point M _ _ _mtable _get _set methods point1 m1)).
Proof.
  start_function. rewrite Point_fold_unfold. Intros P m. simpl.
Abort. (*But there's no way we can complete this proof - P is abstract!
  Point - being based on obj_mpred - is a view that hides the C representation/layout of
  a Point1Rep object - spec based on the obj_mpred predicate (eg Point) are 
  hence only of use to for clients.
  The mechanism by which inner (C-layout-aware) specs are related to outer (layout-unaware but
(  semantic)representation-aware) specifications is object creation.*)

Require Import spec_surelyMalloc.
Definition Vprog : varspecs. mk_varspecs prog. Defined.

  Definition PointMspecs:= [get_spec; set_spec].
  Definition PointMT T M P m := MTable T M methods [_get; _set] m
           [get_spec point T P; set_spec point T P].

  Definition BPointMT T M (P:BPointM T)  m := MTable T M bmethods [_get; _set; _bump] m
           [get_spec point T P; set_spec point T P; bump_spec point T P].

  Definition CPointMT T M (P:CPointM T)  m := MTable T M cmethods [_get; _set; _bump; _getC] m
           [get_spec point T P; set_spec point T P; bump_spec point T P; getC_spec point T P].

Section ConstructorSpecs.
Variable MF: MallocFreeAPD. 

Lemma make_PointMT:
  forall T P PR g s m,
  (func_ptr' (get_spec point T P PR) g *
  func_ptr' (set_spec point T P PR) s *
  malloc_token MF Ews (Tstruct _methods noattr) m *
  data_at Ews (Tstruct _methods noattr) (g,s) m
  |-- PointMT T MF P m PR)%logic.
Proof.
  intros.
  unfold PointMT, MTable. simpl.
  Exists Ews; entailer!.
  unfold_data_at (data_at Ews (Tstruct _methods noattr) _ m). cancel.
  Exists s g g s. entailer!. 
Qed.

Lemma make_BPointMT:
  forall T (P:BPointM T) PR g s b m,
  (func_ptr' (get_spec point T P PR) g *
  func_ptr' (set_spec point T P PR) s *
  func_ptr' (bump_spec point T P PR) b *
  malloc_token MF Ews (Tstruct _bmethods noattr) m *
  data_at Ews (Tstruct _bmethods noattr) (g,(s,b)) m
  |-- BPointMT T MF P m PR)%logic. 
Proof.
  intros.
  unfold BPointMT, MTable. simpl.
  Exists Ews; entailer!.
  unfold_data_at (data_at Ews (Tstruct _bmethods noattr) _ m). cancel.
  Exists b s g g b s. entailer!. 
Qed.

Lemma make_CPointMT:
  forall T (P:CPointM T) PR g s b gC m,
  (func_ptr' (get_spec point T P PR) g *
  func_ptr' (set_spec point T P PR) s *
  func_ptr' (bump_spec point T P PR) b *
  func_ptr' (getC_spec point T P PR) gC *
  malloc_token MF Ews (Tstruct _cmethods noattr) m *
  data_at Ews (Tstruct _cmethods noattr) (g,(s,(b,gC))) m
  |-- CPointMT T MF P m PR)%logic. 
Proof.
  intros.
  unfold CPointMT, MTable. simpl.
  Exists Ews; entailer!.
  unfold_data_at (data_at Ews (Tstruct _cmethods noattr) _ m). cancel.
  Exists gC b s g. Exists g gC b s. entailer!. 
Qed.

Definition Init_PointRep2 (i:Z): PointRep2 := {|value := i|}.
Definition Init_CPointRep2 (i: Z) (c:Color):= Build_CPointRep2 (Init_PointRep2 i) c.

Definition makePoint_I2_spec:= (_makePoint_I2, makePoint_spec point MF PointRep2 _ _mtable _get _set methods point1 m1 Init_PointRep2).

(*The Grog contains get/setspec for m1 and Pred1, but makePoint's spec mentions Point!*)
Definition Point1_Gprog : funspecs :=   ltac:(with_library prog
    ([(_get_I2, get_spec point _ m1 Pred1);
      (_set_I2, set_spec point _ m1 Pred1);
    makePoint_I2_spec] ++ SM_ASI MF)).

Lemma body_makePoint_I2: semax_body Vprog Point1_Gprog f_makePoint_I2 makePoint_I2_spec.
Proof.
unfold makePoint_I2_spec, makePoint_spec.
    (*redundant function_pointers.*)
start_function. 
forward_call surelymalloc_spec_sub (point1, gv).
    { simpl. split3; trivial. rep_lia. }
Intros p.
forward.
 
forward_call surelymalloc_spec_sub (methods, gv).
    { simpl. split3; trivial. rep_lia. }
Intros m.
(*needed for application of make_PointMT 5 lines below*) make_func_ptr _get_I2.  make_func_ptr _set_I2. 
forward. forward. forward. forward.
Exists p. entailer!.
sep_apply (make_PointMT PointRep2 m1 Pred1 (gv _get_I2)  (gv _set_I2) m).
rewrite Point_fold_unfold. simpl. Exists Pred1 m. entailer!.
unfold PointMT. cancel.
unfold Pred1; simpl.
unfold_data_at (data_at Ews point1 _ p). cancel.
unfold FldAt. Exists m; simpl. entailer!.
Qed.

(*Similarly for makeBPoint_I2*)
Definition makeBPoint_I2_spec := (_makeBPoint_I2, makeBPoint_spec point MF PointRep2 _ _mtable _get _set _bump bmethods bpoint1 bm1 Init_PointRep2).

(*Note that we use  get_spec _ bm1 BPred1 rather than get_spec _m1 Pred1)*)
Definition BPoint1_Gprog : funspecs :=   ltac:(with_library prog
    ([(_get_I2, get_spec point _ bm1 BPred1);
      (_set_I2, set_spec point _ bm1 BPred1);
      (_bump_I2, bump_spec point _ bm1 BPred1);
    makeBPoint_I2_spec] ++ SM_ASI MF)).

Lemma body_makeBPoint_I2: semax_body Vprog BPoint1_Gprog f_makeBPoint_I2 makeBPoint_I2_spec.
Proof.
unfold makeBPoint_I2_spec, makeBPoint_spec.
    (*redundant function_pointers.*)
start_function. 
forward_call surelymalloc_spec_sub (bpoint1, gv).
    { simpl. split3; trivial. rep_lia. }
Intros p.
forward.
 
forward_call surelymalloc_spec_sub (bmethods, gv).
    { simpl. split3; trivial. rep_lia. }
Intros m.
(*needed for application of make_PointMT 5 lines below*) make_func_ptr _get_I2. make_func_ptr _set_I2. make_func_ptr _bump_I2.
forward. forward. forward. forward. forward.
Exists p. entailer!.
sep_apply (make_BPointMT PointRep2 bm1 BPred1 (gv _get_I2)  (gv _set_I2)  (gv _bump_I2) m).
rewrite BPoint_fold_unfold. simpl. Exists BPred1 m. entailer!.
unfold BPointMT. simpl. cancel.
unfold BPred1; simpl.
unfold_data_at (data_at Ews bpoint1 _ p). cancel.
unfold FldAt. Exists m; simpl. entailer!.
Qed.

Definition makeCPoint_I2_spec := (_makeCPoint_I2, makeCPoint_spec point MF CPointRep2 _ _mtable _get _set _bump _getC cmethods cpoint1 cm1 Init_CPointRep2).

(*Note that we use  get_spec _ cm1 CPred1 rather than get_spec _bm1 Pred1 or ...*)
Definition CPoint1_Gprog : funspecs :=   ltac:(with_library prog
    ([(_get_I2, get_spec point _ cm1 CPred1);
      (_set_I2, set_spec point _ cm1 CPred1);
      (_bump_I2, bump_spec point _ cm1 CPred1);
      (_getC_I2, getC_spec point _ cm1 CPred1);
    makeCPoint_I2_spec] ++ SM_ASI MF)).

Lemma body_makeCPoint_I2: semax_body Vprog CPoint1_Gprog f_makeCPoint_I2 makeCPoint_I2_spec.
Proof.
unfold makeCPoint_I2_spec, makeCPoint_spec.
    (*redundant function_pointers.*)
start_function. 
forward_call surelymalloc_spec_sub (cpoint1, gv).
    { simpl. split3; trivial. rep_lia. }
Intros p.
forward. forward.
 
forward_call surelymalloc_spec_sub (cmethods, gv).
    { simpl. split3; trivial. rep_lia. }
Intros m.
(*needed for application of make_PointMT 5 lines below*) make_func_ptr _get_I2. make_func_ptr _set_I2.
   make_func_ptr _bump_I2. make_func_ptr _getC_I2.
forward. forward. forward. forward. forward. forward.
Exists p. entailer!.
sep_apply (make_CPointMT CPointRep2 cm1 CPred1 (gv _get_I2) (gv _set_I2) (gv _bump_I2) (gv _getC_I2) m).
rewrite CPoint_fold_unfold. simpl. Exists CPred1 m. entailer!.
unfold CPointMT. simpl. cancel.
unfold CPred1; simpl.
unfold_data_at (data_at Ews cpoint1 _ p). cancel.
unfold FldAt. Exists m; simpl. entailer!.
Qed.

Section Subsumption.

Lemma align_compatible_bpoint_point {b i} (AL:align_compatible bpoint1 (Vptr b i)):
      align_compatible point1 (Vptr b i).
Proof. inv AL. inv H. inv H1. 
    eapply align_compatible_rec_Tstruct; [reflexivity |].
    simpl co_members in *; intros. specialize (H3 i0).
    simpl in H.
    if_tac in H.
    { inv H. specialize (H3 _ _ (eq_refl _) (eq_refl _)).
      eapply align_compatible_rec_by_value. reflexivity.
      inv H0. inv H3. inv H. apply H0. }
    clear H1. 
    if_tac in H.
    { inv H. specialize (H3 _ _ (eq_refl _) (eq_refl _)).
      eapply align_compatible_rec_by_value. reflexivity.
      inv H0. inv H3. inv H. apply H0. }
    inv H.
Qed.

Lemma field_compatible_bpoint_point_value {p} (FC:field_compatible bpoint1 [StructField _value] p):
      field_compatible point1 [StructField _value] p.
Proof.
  destruct FC as [Pt [COMPL [SZ [AL LNF]]]].
  destruct p; inv Pt. split3; try reflexivity.
  split3.
  - red; simpl. red in SZ; simpl in SZ. lia.
  - clear - AL. apply align_compatible_bpoint_point; trivial.
  - split; simpl; auto. right; left; trivial.
Qed.

Lemma gsub_point_bpoint pt: funspec_sub (get_spec pt _ m1 Pred1) (get_spec pt _ bm1 BPred1).
Proof. do_funspec_sub. destruct w as [P p]; simpl; Intros. clear H.
unfold BPred1, Pred1; simpl.
Exists (P, p) emp.
entailer!.
+ intros. entailer!. unfold field_at; simpl. entailer!.
+ simpl in *. unfold field_at; simpl. entailer!.
  clear - H. apply field_compatible_bpoint_point_value; trivial. 
Qed.
 
Lemma align_compatible_cpoint_bpoint {b i} (AL:align_compatible cpoint1 (Vptr b i)):
      align_compatible bpoint1 (Vptr b i).
Proof. inv AL. inv H. inv H1. 
    eapply align_compatible_rec_Tstruct; [reflexivity |].
    simpl co_members in *; intros. specialize (H3 i0).
    simpl in H.
    if_tac in H.
    { inv H. specialize (H3 _ _ (eq_refl _) (eq_refl _)).
      eapply align_compatible_rec_by_value. reflexivity.
      inv H0. inv H3. inv H. apply H0. }
    clear H1. 
    if_tac in H.
    { inv H. specialize (H3 _ _ (eq_refl _) (eq_refl _)).
      eapply align_compatible_rec_by_value. reflexivity.
      inv H0. inv H3. inv H. apply H0. }
    inv H.
Qed.

Lemma field_compatible_cpoint_bpoint_value {p} (FC:field_compatible cpoint1 [StructField _value] p):
      field_compatible bpoint1 [StructField _value] p.
Proof.
  destruct FC as [Pt [COMPL [SZ [AL LNF]]]].
  destruct p; inv Pt. split3; try reflexivity.
  split3.
  - red; simpl. red in SZ; simpl in SZ. lia.
  - clear - AL. apply align_compatible_cpoint_bpoint; trivial.
  - split; simpl; auto. right; left; trivial.
Qed.

Lemma gsub_bpoint_cpoint pt : funspec_sub (get_spec pt _ bm1 BPred1) (get_spec pt _ cm1 CPred1).
Proof. do_funspec_sub. destruct w as [CP p]; simpl; Intros. clear H.
destruct CP as [PT COL].
unfold CPred1, BPred1; simpl.
Exists (PT, p) 
       (field_at Ews cpoint1 [StructField _color] (Vint (Int.repr (mycolor_encoding COL))) p).
entailer!.
+ intros. entailer!. unfold field_at; simpl. entailer!.
+ simpl in *. unfold field_at; simpl. entailer!.
  clear - H. apply field_compatible_cpoint_bpoint_value; trivial.
Qed.

Lemma gsub_point_cpoint pt: funspec_sub (get_spec pt _ m1 Pred1) (get_spec pt _ cm1 CPred1).
Proof. eapply funspec_sub_trans. apply gsub_point_bpoint. apply gsub_bpoint_cpoint. Qed.

Lemma ssub_point_bpoint pt: funspec_sub (set_spec pt _ m1 Pred1) (set_spec pt _ bm1 BPred1).
Proof. do_funspec_sub. destruct w as [[P p] i]; simpl; Intros. clear H. rename H0 into BNDS.
unfold BPred1, Pred1; simpl.
Exists ((P, p), i) emp.
entailer!.
+ intros. entailer!. unfold field_at; simpl. entailer!.
+ unfold field_at; simpl. entailer!.
  clear - H. apply field_compatible_bpoint_point_value; trivial.
Qed.

Lemma ssub_bpoint_cpoint pt: funspec_sub (set_spec pt _ bm1 BPred1) (set_spec pt _ cm1 CPred1).
Proof. do_funspec_sub. destruct w as [[[PT COL] p] c]; simpl; Intros. clear H. rename H0 into BND.
unfold CPred1, BPred1; simpl.
Exists ((PT, p), c) 
       (field_at Ews cpoint1 [StructField _color] (Vint (Int.repr (mycolor_encoding COL))) p).
entailer!.
+ intros. entailer!. unfold field_at; simpl. entailer!.
+ unfold field_at; simpl. entailer!.
  clear - H. apply field_compatible_cpoint_bpoint_value; trivial.
Qed. 

Lemma ssub_point_cpoint pt: funspec_sub (set_spec pt _ m1 Pred1) (set_spec pt _ cm1 CPred1).
Proof. eapply funspec_sub_trans. apply ssub_point_bpoint. apply ssub_bpoint_cpoint. Qed.

Lemma bsub_bpoint_cpoint pt: funspec_sub (bump_spec pt _ bm1 BPred1) (bump_spec pt _ cm1 CPred1).
Proof. do_funspec_sub. destruct w as [[PT COL] p]; simpl; Intros. clear H. rename H0 into BND.
unfold CPred1, BPred1; simpl.
Exists (PT, p) 
       (field_at Ews cpoint1 [StructField _color] (Vint (Int.repr (mycolor_encoding COL))) p).
entailer!.
+ intros. entailer!. unfold field_at; simpl. entailer!.
+ unfold field_at; simpl. entailer!.
  clear - H. apply field_compatible_cpoint_bpoint_value; trivial.
Qed.
 
End Subsumption.
(*Check binary_intersection.: funspec -> funspec -> option funspec*)
Check binary_intersection'. 

Definition gspec pt := binary_intersection' 
                   (binary_intersection' (get_spec pt _ m1 Pred1) (get_spec pt _ bm1 BPred1) (eq_refl _) (eq_refl _))
                   (get_spec pt _ cm1 CPred1) (eq_refl _) (eq_refl _).

Definition sspec pt:= binary_intersection' 
                   (binary_intersection' (set_spec pt _ m1 Pred1) (set_spec pt _ bm1 BPred1) (eq_refl _) (eq_refl _))
                   (set_spec pt _ cm1 CPred1) (eq_refl _) (eq_refl _).

Definition bspec pt:= binary_intersection' (bump_spec pt _ bm1 BPred1) (bump_spec pt _ cm1 CPred1) (eq_refl _) (eq_refl _).

Definition commonGprog:= ltac:(with_library prog
    ([(_get_I2, gspec point);
      (_set_I2, sspec point);
      (_bump_I2, bspec point);
      (_getC_I2, getC_spec point _ cm1 CPred1);
    makePoint_I2_spec;
    makeBPoint_I2_spec;
    makeCPoint_I2_spec] ++ (*free_spec' MF _free ::*) SM_ASI MF )).

Lemma body_makeCPoint_I2_common: semax_body Vprog commonGprog f_makeCPoint_I2 makeCPoint_I2_spec.
Proof. eapply VSU.semax_body_subsumespec. apply body_makeCPoint_I2.
  * intros i; red.
    rewrite 2 semax_prog.make_context_g_char, 2 initial_world.make_tycontext_s_find_id
        by (apply compute_list_norepet_e; reflexivity). (* by LNR_tac.*)
    remember (initial_world.find_id i CPoint1_Gprog) as w.
    destruct w; [symmetry in Heqw | simpl; trivial]. simpl in Heqw.
    repeat (if_tac in Heqw; [ subst i; inv Heqw; reflexivity |]).
    congruence.
  * intros i; red. 
    remember (initial_world.find_id i CPoint1_Gprog ) as w.
    destruct w; [symmetry in Heqw | solve [trivial]]. simpl in Heqw.
    if_tac in Heqw; [ | clear H].
    { subst i; inv Heqw.
      eexists; split; [ reflexivity | ].
      apply seplog.funspec_sub_sub_si.
      apply binary_intersection'_sub. }
    if_tac in Heqw; [ | clear H].
    { subst i; inv Heqw.
      eexists; split; [ reflexivity | ].
      apply seplog.funspec_sub_sub_si.
      apply binary_intersection'_sub. }
    if_tac in Heqw; [ | clear H].
    { subst i; inv Heqw.
      eexists; split; [ reflexivity | ].
      apply seplog.funspec_sub_sub_si.
      apply binary_intersection'_sub. }
    repeat (if_tac in Heqw; [ subst i; inv Heqw;
                              eexists; split; [ reflexivity | apply funspec_sub_si_refl]
                            | ]).
    congruence.
Qed.

Lemma body_makeBPoint_I2_common: semax_body Vprog commonGprog f_makeBPoint_I2 makeBPoint_I2_spec.
Proof. eapply VSU.semax_body_subsumespec. apply body_makeBPoint_I2.
  * intros i; red.
    rewrite 2 semax_prog.make_context_g_char, 2 initial_world.make_tycontext_s_find_id 
        by (apply compute_list_norepet_e; reflexivity). (* by LNR_tac.*)
    remember (initial_world.find_id i BPoint1_Gprog) as w.
    destruct w; [symmetry in Heqw | simpl; trivial]. simpl in Heqw.
    repeat (if_tac in Heqw; [ subst i; inv Heqw; try reflexivity |]).
    congruence.
  * intros i; red. 
    remember (initial_world.find_id i BPoint1_Gprog ) as w.
    destruct w; [symmetry in Heqw | solve [trivial]]. simpl in Heqw.
    if_tac in Heqw; [ | clear H].
    { subst i; inv Heqw.
      eexists; split; [ reflexivity | ].
      apply seplog.funspec_sub_sub_si.
      apply seplog.funspec_sub_trans
      with (f2 := binary_intersection' (get_spec point _ m1 Pred1) (get_spec point _ bm1 BPred1) (eq_refl _) (eq_refl _));
      apply (binary_intersection'_sub). }
    if_tac in Heqw; [ | clear H].
    { subst i; inv Heqw.
      eexists; split; [ reflexivity | ].
      apply seplog.funspec_sub_sub_si.
      apply seplog.funspec_sub_trans
      with (f2 := binary_intersection' (set_spec point _ m1 Pred1) (set_spec point _ bm1 BPred1) (eq_refl _) (eq_refl _));
      apply (binary_intersection'_sub). }
    if_tac in Heqw; [ | clear H].
    { subst i; inv Heqw.
      eexists; split; [ reflexivity | ].
      apply seplog.funspec_sub_sub_si. apply binary_intersection'_sub. }
    repeat (if_tac in Heqw; [ subst i; inv Heqw;
                              eexists; split; [ reflexivity | apply funspec_sub_si_refl]
                            | ]).
    congruence.
Qed.

Lemma body_makePoint_I2_common: semax_body Vprog commonGprog f_makePoint_I2 makePoint_I2_spec.
Proof. eapply VSU.semax_body_subsumespec. apply body_makePoint_I2.
  * intros i; red.
    rewrite 2 semax_prog.make_context_g_char, 2 initial_world.make_tycontext_s_find_id 
        by (apply compute_list_norepet_e; reflexivity). (* by LNR_tac.*)
    remember (initial_world.find_id i Point1_Gprog) as w.
    destruct w; [symmetry in Heqw | simpl; trivial]. simpl in Heqw.
    repeat (if_tac in Heqw; [ subst i; inv Heqw; try reflexivity |]).
    congruence.
  * intros i; red. 
    remember (initial_world.find_id i Point1_Gprog ) as w.
    destruct w; [symmetry in Heqw | solve [trivial]]. simpl in Heqw.
    if_tac in Heqw; [ | clear H].
    { subst i; inv Heqw.
      eexists; split; [ reflexivity | ].
      apply seplog.funspec_sub_sub_si.
      apply seplog.funspec_sub_trans
      with (f2 := binary_intersection' (get_spec point _ m1 Pred1) (get_spec point _ bm1 BPred1) (eq_refl _) (eq_refl _));
      apply (binary_intersection'_sub). }
    if_tac in Heqw; [ | clear H].
    { subst i; inv Heqw.
      eexists; split; [ reflexivity | ].
      apply seplog.funspec_sub_sub_si.
      apply seplog.funspec_sub_trans
      with (f2 := binary_intersection' (set_spec point _ m1 Pred1) (set_spec point _ bm1 BPred1) (eq_refl _) (eq_refl _));
      apply (binary_intersection'_sub). }
    repeat (if_tac in Heqw; [ subst i; inv Heqw;
                              eexists; split; [ reflexivity | apply funspec_sub_si_refl]
                            | ]).
    congruence.
Qed.
End ConstructorSpecs.


Require Import VST.floyd.VSU.
Section MakeVSU.
Variable M: MallocFreeAPD.


  Definition I2_Imports := (*[free_spec' M _free] ++*) SM_ASI M.
  Definition I2_InternalSpecs: funspecs:=[(_get_I2, gspec point);
      (_set_I2, sspec point);
      (_bump_I2, bspec point);
      (_getC_I2, getC_spec point _ cm1 CPred1);
    makePoint_I2_spec M;
    makeBPoint_I2_spec M;
    makeCPoint_I2_spec M].

(*  Definition I2_ASI := PointRep_ASI M I2_OL I2_CompSpecs I2_data _makePoint_I2 (*_getMtable_I2*).
  Definition I2DataASI:= PointRep_DataASI M _get_I2 _set_I2 _bump_I2 _destroy_I2 I2Rep. 
  Definition I2_InternalSpecs: funspecs := I2DataASI
             (*combine [_get_I2; _set_I2; _bump_I2; _destroy_I2] (map (fun x => x (I2Rep M)) (MySpecs M))*)
             ++ I2_ASI.
*)
  Definition I2_Gprog:funspecs := I2_Imports ++ I2_InternalSpecs.
  Definition I2_ASI := PointASI _ M PointRep2 CPointRep2 _mtable _get _set _bump _getC point point1 bpoint1 
             cpoint1 methods bmethods cmethods m1 bm1 cm1 Init_PointRep2 Init_CPointRep2
_makePoint_I2 _makeBPoint_I2 _makeCPoint_I2.
  Definition ASI := [ makePoint_I2_spec M; makeBPoint_I2_spec M; makeCPoint_I2_spec M].

Lemma dataverif_get_common: semax_body Vprog (commonGprog M) f_get_I2 (_get_I2, gspec point).
Proof. eapply VSU.semax_body_subsumespec.
  + eapply semax_body_funspec_sub. apply dataverif_get. 2: LNR_tac.
    apply binary_intersection'_sub3.
    - apply binary_intersection'_sub3. apply funspec_sub_refl.
      apply gsub_point_bpoint.
    - apply gsub_point_cpoint.
  + intros i; red.
    rewrite 2 semax_prog.make_context_g_char, 2 initial_world.make_tycontext_s_find_id 
        by (apply compute_list_norepet_e; reflexivity). simpl; trivial. (* by LNR_tac.*)
  + intros i; red. simpl; trivial.
Qed.
Lemma dataverif_set_common: semax_body Vprog (commonGprog M) f_set_I2 (_set_I2, sspec point).
Proof. eapply VSU.semax_body_subsumespec.
  + eapply semax_body_funspec_sub. apply dataverif_set. 2: LNR_tac.
    apply binary_intersection'_sub3.
    - apply binary_intersection'_sub3. apply funspec_sub_refl.
      apply ssub_point_bpoint.
    - apply ssub_point_cpoint.
  + intros i; red.
    rewrite 2 semax_prog.make_context_g_char, 2 initial_world.make_tycontext_s_find_id 
        by (apply compute_list_norepet_e; reflexivity). simpl; trivial. (* by LNR_tac.*)
  + intros i; red. simpl; trivial.
Qed.
 
Lemma dataverif_bump_common: semax_body Vprog (commonGprog M) f_bump_I2 (_bump_I2, bspec point).
Proof. eapply VSU.semax_body_subsumespec.
  + eapply semax_body_funspec_sub. apply dataverif_bump. 2: LNR_tac.
    apply binary_intersection'_sub3.
    - apply funspec_sub_refl.
    - apply bsub_bpoint_cpoint.
  + intros i; red.
    rewrite 2 semax_prog.make_context_g_char, 2 initial_world.make_tycontext_s_find_id 
        by (apply compute_list_norepet_e; reflexivity). simpl; trivial. (* by LNR_tac.*)
  + intros i; red. simpl; trivial.
Qed.

Lemma dataverif_getC_common: semax_body Vprog (commonGprog M) f_getC_I2 (_getC_I2, getC_spec point _ cm1 CPred1).
Proof. eapply VSU.semax_body_subsumespec. apply dataverif_getC.
  + intros i; red.
    rewrite 2 semax_prog.make_context_g_char, 2 initial_world.make_tycontext_s_find_id 
        by (apply compute_list_norepet_e; reflexivity). simpl; trivial. (* by LNR_tac.*)
  + intros i; red. simpl; trivial.
Qed.

 Ltac findentry_cautious := cbv.

Ltac mkComponent_cautious :=
  eapply Build_Component;
   [ intros i H; (first
      [ repeat (destruct H; [ subst; do 4 eexists; findentry_cautious; reflexivity |  ]); contradiction | idtac ])
   | apply compute_list_norepet_e; reflexivity
   | apply compute_list_norepet_e; reflexivity
   | apply compute_list_norepet_e; reflexivity
   | intros i H; (first [ solve ltac:(contradiction) | simpl in H ]);
      repeat (destruct H; [ subst; do 4 eexists; reflexivity |  ]); try contradiction
   | intros; (*simpl*)cbv; split; trivial; try (solve [ lookup_tac ])
   | apply compute_list_norepet_e; reflexivity
   | intros i H; (first [ solve ltac:(contradiction) | simpl in H ]); repeat (destruct H; [ subst; reflexivity |  ]);
      try contradiction
   | intros i phi fd H H0; simpl in H0;
     repeat (if_tac in H0; [ inv H0; cbv in H; inv H |  ]); try discriminate
     (*.intros i phi fd H H0; simpl in H; repeat (if_tac in H; [ inv H; inv H0 |  ]; try discriminate)*)
   | finishComponent
   | intros; (first [ solve [ apply derives_refl ] | solve [ reflexivity ] | solve [ simpl; cancel ] | idtac ]) ].

  Definition I2_Component: @Component NullExtension.Espec Vprog _ 
      nil I2_Imports prog I2_ASI emp I2_InternalSpecs.
  Proof. mkComponent_cautious. 
     - solve_SF_internal dataverif_get_common.
     - solve_SF_internal dataverif_set_common.
     - solve_SF_internal dataverif_bump_common.
     - solve_SF_internal dataverif_getC_common. 
     - solve_SF_internal body_makePoint_I2_common.
     - solve_SF_internal body_makeBPoint_I2_common. 
     - solve_SF_internal body_makeCPoint_I2_common.
Qed.

  Definition I2_VSU: @VSU NullExtension.Espec Vprog _ 
      nil I2_Imports prog I2_ASI emp.
  Proof. eexists; apply I2_Component. Qed.

End MakeVSU.